////////////////////////////////////////////////////////////////////////////
// PathFinding AIs
//   Worm
//   Gardener
//   Rattler
//   Sidewinder
//   Kite
//   Boa

//  Old Test
//  if (New.head-AI->Vector.head <= 180 && New.head-AI->Vector.head > -60) // Randomize Left/Right for higher level

int Worm (class Unit *AI, int bx, int by, int MP, int range) {

int i,j;
int dx = bx - AI->Vector.x; // Change in X
int dy = by - AI->Vector.y; // Change in Y
//dx *= 2; // each hex is 2 units wide and 1 wide

dy *= 2;
Vector New;
//Vector Vector;

AI->MP = MP;

if (dx >= dy) {      // Move along the X
  if (dx <= 0)                //  Left
    New.head = 270;
  if (dx >= 0)                // Right
    New.head = 70;
} else {
  if (dy <= 0 && dx <= 0)     // Head Up and Left
    New.head = 330;
  if (dy <= 0 && dx >= 0)     // Head Up and Right
    New.head = 30;
  if (dy >= 0 && dx <= 0)     // Head Down and Left
    New.head = 210;
  if (dy >= 0 && dx >= 0)     // Head Down and Right
    New.head = 150;

  }
//  gotoxy(1,24);
  rest(MoveRest*2); // Pause
  if (AI->Vector.head-New.head > 180 || (AI->Vector.head-New.head > -180 && AI->Vector.head-New.head <= 0)) // Test for left and right
    while (AI->Vector.head != New.head && AI->MP >= 0) {
    AI->TurnRight(); rest(MoveRest); }
  else
    while (AI->Vector.head != New.head && AI->MP >= 0) {
    AI->TurnLeft(); rest(MoveRest); }

    while (AI->Advance()!=Off) {
      if (Options.HighLight == On)
        drawHighLight(AI->Vector.x,AI->Vector.y);
      rest(MoveRest);
      }

return 0;
};

// Un Modified
int GardenerAlpha (class Unit *AI, int bx, int by, int MP, int range) {

int i,j;
int dx = bx - AI->Vector.x; // Change in X
int dy = by - AI->Vector.y; // Change in Y
//dx *= 2; // each hex is 2 units wide and 1 wide

dy *= 2;
Vector New;
//Vector Vector;

AI->MP = MP;

if (dx >= dy) {      // Move along the X
  if (dx <= 0)                //  Left
    New.head = 270;
  if (dx >= 0)                // Right
    New.head = 90;
} else {
  if (dy <= 0 && dx <= 0)     // Head Up and Left
    New.head = 330;
  if (dy <= 0 && dx >= 0)     // Head Up and Right
    New.head = 30;
  if (dy >= 0 && dx <= 0)     // Head Down and Left
    New.head = 210;
  if (dy >= 0 && dx >= 0)     // Head Down and Right
    New.head = 150;

  }
//  gotoxy(1,24);
//  Start Heading
  rest(MoveRest*2); // Pause
  if ((AI->Vector.head - New.head) < 0 && abs(AI->Vector.head - New.head) < 180) // Randomize Left/Right for higher level
    while (AI->Vector.head != New.head && AI->MP >= 0) {
    AI->TurnRight(); rest(MoveRest); }
  else
    while (AI->Vector.head != New.head && AI->MP >= 0) {
    AI->TurnLeft(); rest(MoveRest); }

//    gotoxy(50,AI->MP+1);
//    cprintf(">%d    ",New.head);

    while (AI->Advance()!=Off) {

      dx = bx - AI->Vector.x; // Change in X
      dy = by - AI->Vector.y; // Change in Y

    if (dy == 0)  // Mech is on the same Y-Axis
      if (dx < 0) New.head = 270; // Go Left
        else New.head = 90;
    if (dx == dy)  // Mech on hexside
      if (dx >= 0) New.head = 150;
        else New.head = 330;
    if (dx ==-dy)  // Mech facing on hexside
      if (dx >= 0) New.head = 30;
        else New.head = 210;

//    gotoxy(50,AI->MP+6);
//    cprintf(">%d   ",New.head);

    if ((AI->Vector.head - New.head) < 0 && abs(AI->Vector.head - New.head) < 180) // Randomize Left/Right for higher level
      while (AI->Vector.head != New.head && AI->MP >= 0) {
        AI->TurnRight(); rest(MoveRest); }
    else
      while (AI->Vector.head != New.head && AI->MP >= 0) {
        AI->TurnLeft(); rest(MoveRest); }

        }
      
return 0;
}

int Gardener (class Unit *AI, int bx, int by, int MP, int range) {

int i,j;
int dx = bx - AI->Vector.x; // Change in X
int dy = by - AI->Vector.y; // Change in Y
//dx *= 2; // each hex is 2 units wide and 1 wide

range ++; // Because doLos returns 1 as minimum

dy *= 2;
Vector New;
//Vector Vector;

AI->MP = MP;

if (dx >= dy) {      // Move along the X
  if (dx <= 0)                //  Left
    New.head = 270;
  if (dx >= 0)                // Right
    New.head = 90;
} else {
  if (dy <= 0 && dx <= 0)     // Head Up and Left
    New.head = 330;
  if (dy <= 0 && dx >= 0)     // Head Up and Right
    New.head = 30;
  if (dy >= 0 && dx <= 0)     // Head Down and Left
    New.head = 210;
  if (dy >= 0 && dx >= 0)     // Head Down and Right
    New.head = 150;

  }
//  gotoxy(1,24);
//  Start Heading
  rest(MoveRest*2); // Pause
  if ((AI->Vector.head - New.head) < 0 && abs(AI->Vector.head - New.head) < 180) // Randomize Left/Right for higher level
    while (AI->Vector.head != New.head && AI->MP > 0) {
    AI->TurnRight();rest(MoveRest); }
  else
    while (AI->Vector.head != New.head && AI->MP > 0) {
    AI->TurnLeft();rest(MoveRest); }

      // if unit too close it will back up
    while (doLos(AI->Vector.x,AI->Vector.y,bx,by) < range && AI->Reverse()!=Off) rest(MoveRest);

    while (doLos(AI->Vector.x,AI->Vector.y,bx,by) != range && AI->Advance()!=Off) {

      rest(MoveRest);

      dx = bx - AI->Vector.x; // Change in X
      dy = by - AI->Vector.y; // Change in Y

    if (dy == 0)  // Mech is on the same Y-Axis
      if (dx < 0) New.head = 270; // Go Left
        else New.head = 90;
    if (dx == dy)  // Mech on hexside
      if (dx >= 0) New.head = 150;
        else New.head = 330;
    if (dx ==-dy)  // Mech facing on hexside
      if (dx >= 0) New.head = 30;
        else New.head = 210;

    if ((AI->Vector.head - New.head) < 0 && abs(AI->Vector.head - New.head) < 180) // Randomize Left/Right for higher level
      while (AI->Vector.head != New.head && AI->MP > 0) {
        AI->TurnRight(); rest(MoveRest);}
    else
      while (AI->Vector.head != New.head && AI->MP > 0) {
        AI->TurnLeft(); rest(MoveRest);}

        }
      
return 0;
}

int Rattler (class Unit *AI, int bx, int by, int MP, int range) {

int i,j;
int dx = bx - AI->Vector.x; // Change in X
int dy = by - AI->Vector.y; // Change in Y
//dx *= 2; // each hex is 2 units wide and 1 wide

range ++; // Because doLos returns 1 as minimum

dy *= 2;
Vector New;

AI->MP = MP;

if (dx >= dy) {     // Move along the X
  if (dx <= 0)                //  Left
    New.head = 270;
  if (dx >= 0)                // Right
    New.head = 90;
} else {
  if (dy <= 0 && dx <= 0)     // Head Up and Left
    New.head = 330;
  if (dy <= 0 && dx >= 0)     // Head Up and Right
    New.head = 30;
  if (dy >= 0 && dx <= 0)     // Head Down and Left
    New.head = 210;
  if (dy >= 0 && dx >= 0)     // Head Down and Right
    New.head = 150;

  }

//  AI->Vector.head = New.head;
//  gotoxy(1,24);
//  Start Heading
  rest(MoveRest*2);
  if (AI->Vector.head-New.head > 180 || (AI->Vector.head-New.head > -180 && AI->Vector.head-New.head <= 0)) // Test for left and right
    while (AI->Vector.head != New.head && AI->MP > 0) {
    AI->TurnRight(); rest(MoveRest);}
  else
    while (AI->Vector.head != New.head && AI->MP > 0) {
    AI->TurnLeft(); rest(MoveRest);}

      // if unit too close it will back up
    while (doLos(AI->Vector.x,AI->Vector.y,bx,by) < range && AI->Reverse()) rest(MoveRest);

    while (AI->Advance() && doLos(AI->Vector.x,AI->Vector.y,bx,by) > range) {

      rest(MoveRest);
      dx = bx - AI->Vector.x; // Change in X
      dy = by - AI->Vector.y; // Change in Y

    if (dy == 0)  // Mech is on the same Y-Axis
      if (dx < 0) New.head = 270; // Go Left
        else New.head = 90;
    if (dx == dy)  // Mech on hexside
      if (dx >= 0) New.head = 150;
        else New.head = 330;
    if (dx ==-dy)  // Mech facing on hexside
      if (dx >= 0) New.head = 30;
        else New.head = 210;

//    gotoxy(50,AI->MP+6);
//    cprintf(">%d   ",New.head);

    if (AI->Vector.head-New.head > 180 || (AI->Vector.head-New.head > -180 && AI->Vector.head-New.head <= 0)) // Test for left and right
      while (AI->Vector.head != New.head && AI->MP > 0) {
        AI->TurnRight(); rest(MoveRest); }
    else
      while (AI->Vector.head != New.head && AI->MP > 0) {
        AI->TurnLeft(); rest(MoveRest); }

    if (Options.HighLight == On)
      drawHighLight(AI->Vector.x,AI->Vector.y);
      }

return 0;
}

int SideWinder (class Unit *AI, int bx, int by, int MP, int range) {

int i,j;   // Counters
int g,h,k,l; // Avoidance
int dx = bx - AI->Vector.x; // Change in X
int dy = by - AI->Vector.y; // Change in Y
//dx *= 2; // each hex is 2 units wide and 1 wide

range ++; // Because doLos returns 1 as minimum

dy *= 2;
Vector New;
//Vector Vector;

AI->MP = MP;

if (dx >= dy) {      // Move along the X
  if (dx <= 0)                //  Left
    New.head = 270;
  if (dx >= 0)                // Right
    New.head = 90;
} else {
  if (dy <= 0 && dx <= 0)     // Head Up and Left
    New.head = 330;
  if (dy <= 0 && dx >= 0)     // Head Up and Right
    New.head = 30;
  if (dy >= 0 && dx <= 0)     // Head Down and Left
    New.head = 210;
  if (dy >= 0 && dx >= 0)     // Head Down and Right
    New.head = 150;

  }
//  gotoxy(1,24);
//  Start Heading
      // if unit too close it will back up      
//    while (AI->MP >= 0 && AI->Reverse() && doLos(AI->Vector.x,AI->Vector.y,bx,by) < range);

  rest(MoveRest*2);// Pause
  i=On;
  while (AI->MP > 0 && i==On && doLos(AI->Vector.x,AI->Vector.y,bx,by) > range) {

    rest(MoveRest);

      dx = bx - AI->Vector.x; // Change in X
      dy = by - AI->Vector.y; // Change in Y

    if (dy == 0)  // Mech is on the same Y-Axis
      if (dx < 0) New.head = 270; // Go Left
        else New.head = 90;
    if (dx == dy)  // Mech on hexside
      if (dx >= 0) New.head = 150;
        else New.head = 330;
    if (dx ==-dy)  // Mech facing on hexside
      if (dx >= 0) New.head = 30;
        else New.head = 210;
  
    if ( getMoveCost(AI->Vector,New.head) != RETURNNULL); // Path is open
    else {    // Mech must turn so it is facing a passable hex
      j =30;
      for (i=0;i<2;i++) {
        j+=60;
        g=New.head+j;
        h=New.head-j;
        if (g > 330) g-=360;
          k = getMoveCost(AI->Vector,g);
        if (h < 30)  h+=360;
          l = getMoveCost(AI->Vector,h);
        if (k >= l && k!=RETURNNULL) New.head = g;
        if (k <  l && l!=RETURNNULL) New.head = h;
        }
      }
    if (AI->Vector.head-New.head > 180 || (AI->Vector.head-New.head > -180 && AI->Vector.head-New.head <= 0)) // Test for left and right
      while (AI->Vector.head != New.head && AI->MP >= 0) {
        AI->TurnRight(); rest(MoveRest); }
    else
      while (AI->Vector.head != New.head && AI->MP >= 0) {
        AI->TurnLeft(); rest(MoveRest); }

    i=AI->Advance();
    if (Options.HighLight == On)
      drawHighLight(AI->Vector.x,AI->Vector.y);

    }
      
return 0;
}

int Kite (class Unit *AI, int bx, int by, int MP, int range) {

int i,j;   // Counters
int g,h,k,l; // Avoidance
int dx = bx - AI->Vector.x; // Change in X
int dy = by - AI->Vector.y; // Change in Y
//dx *= 2; // each hex is 2 units wide and 1 wide

range ++; // Because doLos returns 1 as minimum

//dy *= 2;
Vector New;
//Vector Vector;
AI->MP = MP;
/*
if (dx >= dy) {      // Move along the X
  if (dx <= 0)                //  Left
    New.head = 270;
  if (dx >= 0)                // Right
    New.head = 90;
} else {
  if (dy <= 0 && dx <= 0)     // Head Up and Left
    New.head = 330;
  if (dy <= 0 && dx >= 0)     // Head Up and Right
    New.head = 30;
  if (dy >= 0 && dx <= 0)     // Head Down and Left
    New.head = 210;
  if (dy >= 0 && dx >= 0)     // Head Down and Right
    New.head = 150;
  }
*/
  New.head = AI->Vector.head;
  if (dy == 0)  // Mech is on the same Y-Axis
    if (dx < 0) New.head = 270;// Go Left
      else New.head = 90;
  if (dx == dy)  // Mech on hexside
    if (dx >= 0) New.head = 150;
      else New.head = 330;
  if (dx ==-dy)  // Mech facing on hexside
    if (dx >= 0) New.head = 30;
      else New.head = 210;

//  gotoxy(1,24);
//  Start Heading
      // if unit too close it will back up      
//    while (AI->MP >= 0 && AI->Reverse() && doLos(AI->Vector.x,AI->Vector.y,bx,by) < range);

  rest(MoveRest*2);
//  if ( getMoveCost(AI->Vector,New.head) != RETURNNULL) // Path is open

//    textprintf(screen,font,50,50+AI->Index*16,EGAColour[7],">> %d %d\n",AI->Vector.head,New.head);
//    getkey();
    if (AI->Vector.head != New.head)
      if (AI->Vector.head-New.head > 180 || (AI->Vector.head-New.head > -180 && AI->Vector.head-New.head <= 0)) // Test for left and right
        while (AI->Vector.head != New.head && AI->MP >= 0) {
          AI->TurnRight(); rest(MoveRest);}
      else
        while (AI->Vector.head != New.head && AI->MP >= 0) {
          AI->TurnLeft(); rest(MoveRest);}

  i = On;
  while (AI->MP >= 0 && i==On && doLos(AI->Vector.x,AI->Vector.y,bx,by) >= range) {

      rest(MoveRest);
      dx = bx - AI->Vector.x; // Change in X
      dy = by - AI->Vector.y; // Change in Y

    if (dy == 0)  // Mech is on the same Y-Axis
      if (dx < 0) New.head = 270;// Go Left
        else New.head = 90;
    if (dx == dy)  // Mech on hexside
      if (dx >= 0) New.head = 150;
        else New.head = 330;
    if (dx ==-dy)  // Mech facing on hexside
      if (dx >= 0) New.head = 30;
        else New.head = 210;


    if ( getMoveCost(AI->Vector,New.head) != RETURNNULL); // Path is open
    else {    // Mech must turn so it is facing a passable hex
      j = 0;
      for (i=0;i<2;i++) {
        j+=60;
        g=New.head+j;
        h=New.head-j;
        if (g > 330) g-=360;
          k = getMoveCost(AI->Vector,g);
        if (h < 30)  h+=360;
          l = getMoveCost(AI->Vector,h);
        if (k >= l && k!=RETURNNULL) New.head = g, i+=3;
        if (k <  l && l!=RETURNNULL) New.head = h, i+=3;
        }
      }

    if (AI->Vector.head != New.head)
      if (AI->Vector.head-New.head > 180 || (AI->Vector.head-New.head > -180 && AI->Vector.head-New.head <= 0)) // Test for left and right
        while (AI->Vector.head != New.head && AI->MP >= 0) {
          AI->TurnRight(); rest(MoveRest);}
      else
        while (AI->Vector.head != New.head && AI->MP >= 0) {
          AI->TurnLeft(); rest(MoveRest);}

    if (doLos(AI->Vector.x,AI->Vector.y,bx,by) == 1) return 0;
      else i=AI->Advance();

    if (Options.HighLight == On)
      drawHighLight(AI->Vector.x,AI->Vector.y);
    }

return 0;
}



// Boa 1 - best Range
int Boa (class Unit *AI, int bx, int by, int MP, int range) {
// Boa tries to evade enemy fire
// If enemy far away move straight in
// if close look for cover

int i,j;   // Counters
int g,h,k,l; // Avoidance

int MH;

int ModHead;    // Best Heading
int ModForward; // Hexes to move forward, then turn to ModHead
int ModAdvance; // Hexes to advance after turn

int Modifier;

int HexMoved, acc, vul;

int dx = bx - AI->Vector.x; // Change in X
int dy = by - AI->Vector.y; // Change in Y
//dx *= 2; // each hex is 2 units wide and 1 wide

range ++; // Because doLos returns 1 as minimum

//dy *= 2;
Vector New;
//Vector Vector;
/*
gotoxy(1,24);
textattr(AI->Colour);
cprintf("                                                   ");
gotoxy(1,24);
cprintf(">> %d %d <> AI MECH : %s   %d C ",dx,dy,AI->Name,MP);
*/
MH = (MP+1)/2; // use half of MP to advance
AI->MP = MH;

if (dx >= dy) {      // Move along the X
  if (dx <= 0)                //  Left
    New.head = 270;
  if (dx >= 0)                // Right
    New.head = 90;
} else {
  if (dy <= 0 && dx <= 0)     // Head Up and Left
    New.head = 330;
  if (dy <= 0 && dx >= 0)     // Head Up and Right
    New.head = 30;
  if (dy >= 0 && dx <= 0)     // Head Down and Left
    New.head = 210;
  if (dy >= 0 && dx >= 0)     // Head Down and Right
    New.head = 150;

  }
//  gotoxy(1,24);
//  Start Heading
      // if unit too close it will back up      
//    while (AI->MP >= 0 && AI->Reverse() && doLos(AI->Vector.x,AI->Vector.y,bx,by) < range);
  rest(MoveRest*2);
  if ( getMoveCost(AI->Vector,New.head) != RETURNNULL) // Path is open
    if ((AI->Vector.head - New.head) < 0 && abs(AI->Vector.head - New.head) < 180) // Randomize Left/Right for higher level
      while (AI->Vector.head != New.head && AI->MP >= 0) {
        AI->TurnRight(); rest(MoveRest); }
    else
      while (AI->Vector.head != New.head && AI->MP >= 0) {
        AI->TurnLeft(); rest(MoveRest); }

  i=On;
  while (AI->MP >= 0 && i==On && doLos(AI->Vector.x,AI->Vector.y,bx,by) >= range) {

      rest(MoveRest);
      dx = bx - AI->Vector.x; // Change in X
      dy = by - AI->Vector.y; // Change in Y

    if (dy == 0)  // Mech is on the same Y-Axis
      if (dx < 0) New.head = 270;// Go Left
        else New.head = 90;
    if (dx == dy)  // Mech on hexside
      if (dx >= 0) New.head = 150;
        else New.head = 330;
    if (dx ==-dy)  // Mech facing on hexside
      if (dx >= 0) New.head = 30;
        else New.head = 210;

  
    if ( getMoveCost(AI->Vector,New.head) != RETURNNULL); // Path is open
    else {    // Mech must turn so it is facing a passable hex
      j =30;
      for (i=0;i<2;i++) {
        j+=60;
        g=New.head+j;
        h=New.head-j;
        if (g > 330) g-=360;
          k = getMoveCost(AI->Vector,g);
        if (h < 30)  h+=360;
          l = getMoveCost(AI->Vector,h);
        if (k >= l && k!=RETURNNULL) New.head = g;
        if (k <  l && l!=RETURNNULL) New.head = h;
        }
      }
    if ((AI->Vector.head - New.head) < 0 && abs(AI->Vector.head - New.head) < 180) // Randomize Left/Right for higher level
      while (AI->Vector.head != New.head && AI->MP >= 0) {
        AI->TurnRight(); rest(MoveRest); }
    else
      while (AI->Vector.head != New.head && AI->MP >= 0) {
        AI->TurnLeft(); rest(MoveRest); }

    i=AI->Advance();

    }

// Decide on the best forward heading

  h = MP - MH ; // + AI->MP
  ModForward = 0;
  New = AI->Vector;
  Modifier = 0;

  HexMoved=0;          // Hexes Moved
  acc=0;
  i=0;

  while (h>0) {
  h -= counterAdvance(&New);
  i ++;
  doLos(New.x,New.y,bx,by);
  acc = ProcLOSstr (LOSstring);
  doLos(bx,by,New.x,New.y);
  vul = ProcLOSstr (LOSstring);
  if (Modifier <= vul && acc >= 12) {
    ModHead = New.head;
    ModForward = i;
    ModAdvance = 0;
    Modifier = vul;
    }
  }
  i=On;
  while (ModForward > 0 &&i==On) {
  i=AI->Advance();
  ModForward--;
  rest(MoveRest);
  }

return 0;
}

// Boa 2 - Pitch Fork - Python
int Python (class Unit *AI, int bx, int by, int MP, int range) {
// Boa tries to evade enemy fire
// If enemy far away move straight in
// if close look for cover

int i,j;   // Counters
int g,h,k,l; // Avoidance

int MH;

int ModHead;    // Best Heading
int ModForward; // Hexes to move forward, then turn to ModHead
int ModAdvance; // Hexes to advance after turn

int Modifier;

int HexMoved, acc, vul;

int dx = bx - AI->Vector.x; // Change in X
int dy = by - AI->Vector.y; // Change in Y
//dx *= 2; // each hex is 2 units wide and 1 wide

range ++; // Because doLos returns 1 as minimum

//dy *= 2;
Vector New;

MH = (MP+1)/2; // use half of MP to advance
AI->MP = MH;

if (dx >= dy) {      // Move along the X
  if (dx <= 0)                //  Left
    New.head = 270;
  if (dx >= 0)                // Right
    New.head = 90;
} else {
  if (dy <= 0 && dx <= 0)     // Head Up and Left
    New.head = 330;
  if (dy <= 0 && dx >= 0)     // Head Up and Right
    New.head = 30;
  if (dy >= 0 && dx <= 0)     // Head Down and Left
    New.head = 210;
  if (dy >= 0 && dx >= 0)     // Head Down and Right
    New.head = 150;

  }
//  gotoxy(1,24);
//  Start Heading
      // if unit too close it will back up      
//    while (AI->MP >= 0 && AI->Reverse() && doLos(AI->Vector.x,AI->Vector.y,bx,by) < range);
  rest(MoveRest*2);
  if ( getMoveCost(AI->Vector,New.head) != RETURNNULL) // Path is open
    if ((AI->Vector.head - New.head) < 0 && abs(AI->Vector.head - New.head) < 180) // Randomize Left/Right for higher level
      while (AI->Vector.head != New.head && AI->MP >= 0) {
        AI->TurnRight();  rest(MoveRest);}
    else
      while (AI->Vector.head != New.head && AI->MP >= 0) {
        AI->TurnLeft();  rest(MoveRest);}

  i = On;
  while (AI->MP >= 0 && i==On && doLos(AI->Vector.x,AI->Vector.y,bx,by) > range) {

      dx = bx - AI->Vector.x; // Change in X
      dy = by - AI->Vector.y; // Change in Y

    if (dy == 0)  // Mech is on the same Y-Axis
      if (dx < 0) New.head = 270;// Go Left
        else New.head = 90;
    if (dx == dy)  // Mech on hexside
      if (dx >= 0) New.head = 150;
        else New.head = 330;
    if (dx ==-dy)  // Mech facing on hexside
      if (dx >= 0) New.head = 30;
        else New.head = 210;

  
    if ( getMoveCost(AI->Vector,New.head) != RETURNNULL); // Path is open
    else {    // Mech must turn so it is facing a passable hex
      j =30;
      for (i=0;i<2;i++) {
        j+=60;
        g=New.head+j;
        h=New.head-j;
        if (g > 330) g-=360;
          k = getMoveCost(AI->Vector,g);
        if (h < 30)  h+=360;
          l = getMoveCost(AI->Vector,h);
        if (k >= l && k!=RETURNNULL) New.head = g;
        if (k <  l && l!=RETURNNULL) New.head = h;
        }
      }
    if ((AI->Vector.head - New.head) < 0 && abs(AI->Vector.head - New.head) < 180) // Randomize Left/Right for higher level
      while (AI->Vector.head != New.head && AI->MP >= 0) {
        AI->TurnRight(); rest(MoveRest); }
    else
      while (AI->Vector.head != New.head && AI->MP >= 0) {
        AI->TurnLeft(); rest(MoveRest); }

    i=AI->Advance();

    }

// Decide on the best forward position

  h = MP - MH ; // + AI->MP
  ModHead = 0;
  ModForward = 0;
  ModAdvance = 0;
  New = AI->Vector;
  Modifier = 0;

  HexMoved=0;          // Hexes Moved
  acc=0;
  i=0;

  while (h>0) {
  h -= counterAdvance(&New);
  i ++;
  doLos(New.x,New.y,bx,by);
  acc = ProcLOSstr (LOSstring) + 4;
  doLos(bx,by,New.x,New.y);
  vul = ProcLOSstr (LOSstring) + 4;
  if (Modifier < vul && acc <= 12) {
    ModHead = New.head;
    ModForward = i;
    ModAdvance = 0;
    Modifier = vul;
    }
  }

/////////////////////////////////////////////////////////////////////////////
// Pitch Fork
// Right
//

  New = AI->Vector;

  HexMoved=0;          // Hexes Moved
  acc=0;
  i=0;

  for (j=0;j<MP-MH;j++) {
  h = MP - MH ; // + AI->MP

  for (i=0;i<j;i++)
    h -= counterAdvance(&New);

  i = 0;

  New.head += 60;//    Turn Right
  if (New.head > 360) New.head -= 360;

    while (h>0) {  // Advance
      h -= counterAdvance(&New);
      i ++;
      doLos(New.x,New.y,bx,by);
      acc = ProcLOSstr (LOSstring) + 4;
      doLos(bx,by,New.x,New.y);
      vul = ProcLOSstr (LOSstring) + 4;
      if (Modifier <= vul && acc >= 12) {
        ModHead = New.head;
        ModForward = j;
        ModAdvance = i;
        Modifier = vul;
        }
      }
    }

/////////////////////////////////////////////////////////////////////////////
// Pitch Fork
// Left
//

  New = AI->Vector;

  HexMoved=0;          // Hexes Moved
  acc=0;
  i=0;

  for (j=0;j<MP-MH;j++) {
  h = MP - MH ; // + AI->MP

  for (i=0;i<j;i++)
    h -= counterAdvance(&New);

  i = 0;

  h--;
  New.head -= 60;//    Turn Left
  if (New.head < 0) New.head += 360;

    while (h>0) {  // Advance
      h -= counterAdvance(&New);
      i ++;
      doLos(New.x,New.y,bx,by);
      acc = ProcLOSstr (LOSstring) + 4;
      doLos(bx,by,New.x,New.y);
      vul = ProcLOSstr (LOSstring) + 4;
      if (Modifier < vul && acc >= 12) {
        ModHead = New.head;
        ModForward = j;
        ModAdvance = i;
        Modifier = vul;
        }
      }
    }

  i=On;
  while (ModForward > 0 && AI->MP > 0 && i==On) {
  i=AI->Advance();
  ModForward--;
  rest(MoveRest);
  }

  New.head = ModHead;

    if ((AI->Vector.head - New.head) < 0 && abs(AI->Vector.head - New.head) < 180) // Randomize Left/Right for higher level
      while (AI->Vector.head != New.head && AI->MP >= 0) {
        AI->TurnRight(); rest(MoveRest); }
    else
      while (AI->Vector.head != New.head && AI->MP >= 0) {
        AI->TurnLeft(); rest(MoveRest); }

  i=On;
  while (ModAdvance > 0 && AI->MP > 0 && i==On) {
  i=AI->Advance();
  ModAdvance--;
  rest(MoveRest);
  }

  if (ModHead == 0)
    while (AI->MP > 0) AI->Advance();

return 0;
}

// Boa 3 - Pitch Fork - Adder
int Adder (class Unit *AI, int bx, int by, int MP, int range) {
// Adder seeks optimum firing solution
// If enemy far away move straight in
// if close look for cover

int i,j;   // Counters
int g,h,k,l; // Avoidance

int MH;

int ModHead;    // Best Heading
int ModForward; // Hexes to move forward, then turn to ModHead
int ModAdvance; // Hexes to advance after turn

int Modifier;

int HexMoved, acc, vul;

int dx = bx - AI->Vector.x; // Change in X
int dy = by - AI->Vector.y; // Change in Y
//dx *= 2; // each hex is 2 units wide and 1 wide

range ++; // Because doLos returns 1 as minimum

//dy *= 2;
Vector New;

MH = (MP+1)/2; // use half of MP to advance
AI->MP = MH;

if (dx <= dy) {      // Move along the X
  if (dx <= 0)                //  Left
    New.head = 270;
  if (dx >= 0)                // Right
    New.head = 90;
} else {
  if (dy <= 0 && dx <= 0)     // Head Up and Left
    New.head = 330;
  if (dy <= 0 && dx >= 0)     // Head Up and Right
    New.head = 30;
  if (dy >= 0 && dx <= 0)     // Head Down and Left
    New.head = 210;
  if (dy >= 0 && dx >= 0)     // Head Down and Right
    New.head = 150;

  }
//  gotoxy(1,24);
//  Start Heading
      // if unit too close it will back up      
//    while (AI->MP >= 0 && AI->Reverse() && doLos(AI->Vector.x,AI->Vector.y,bx,by) < range);
  rest(MoveRest*2);
  if ( getMoveCost(AI->Vector,New.head) != RETURNNULL) // Path is open
    if ((AI->Vector.head - New.head) < 0 && abs(AI->Vector.head - New.head) < 180) // Randomize Left/Right for higher level
      while (AI->Vector.head != New.head && AI->MP > 0) {
        AI->TurnRight(); rest(MoveRest); }
    else
      while (AI->Vector.head != New.head && AI->MP > 0) {
        AI->TurnLeft(); rest(MoveRest); }

  i=On;
  while (AI->MP >= 0 && doLos(AI->Vector.x,AI->Vector.y,bx,by) >= range && i==On) {
     rest(MoveRest);
      dx = bx - AI->Vector.x; // Change in X
      dy = by - AI->Vector.y; // Change in Y

    if (dy == 0)  // Mech is on the same Y-Axis
      if (dx < 0) New.head = 270;// Go Left
        else New.head = 90;
    if (dx == dy)  // Mech on hexside
      if (dx >= 0) New.head = 150;
        else New.head = 330;
    if (dx ==-dy)  // Mech facing on hexside
      if (dx >= 0) New.head = 30;
        else New.head = 210;

  
    if ( getMoveCost(AI->Vector,New.head) != RETURNNULL); // Path is open
    else {    // Mech must turn so it is facing a passable hex
      j =30;
      for (i=0;i<2;i++) {
        j+=60;
        g=New.head+j;
        h=New.head-j;
        if (g > 330) g-=360;
          k = getMoveCost(AI->Vector,g);
        if (h < 30)  h+=360;
          l = getMoveCost(AI->Vector,h);
        if (k >= l && k!=RETURNNULL) New.head = g;
        if (k <  l && l!=RETURNNULL) New.head = h;
        }
      }
    if ((AI->Vector.head - New.head) < 0 && abs(AI->Vector.head - New.head) < 180) // Randomize Left/Right for higher level
      while (AI->Vector.head != New.head && AI->MP > 0) {
        AI->TurnRight(); rest(MoveRest); }
    else
      while (AI->Vector.head != New.head && AI->MP > 0) {
        AI->TurnLeft(); rest(MoveRest); }

    i=AI->Advance();

    }

// Decide on the best forward position

  h = MP - MH ; // + AI->MP
  ModHead = 0;
  ModForward = 0;
  ModAdvance = 0;
  New = AI->Vector;
  Modifier = RETURNNULL;

  HexMoved=0;          // Hexes Moved
  acc=0;
  i=0;

  while (h>0) {
  h -= counterAdvance(&New);
  i ++;
  doLos(New.x,New.y,bx,by);
  acc = ProcLOSstr (LOSstring) + 4;
  doLos(bx,by,New.x,New.y);
  vul = ProcLOSstr (LOSstring) + 4;
  if (Modifier > acc) {
    ModHead = New.head;
    ModForward = i;
    ModAdvance = 0;
    Modifier = vul;
    }
  }

/////////////////////////////////////////////////////////////////////////////
// Pitch Fork
// Right
//

  New = AI->Vector;

  HexMoved=0;          // Hexes Moved
  acc=0;
  i=0;

  for (j=0;j<MP-MH;j++) {
  h = MP - MH ; // + AI->MP

  for (i=0;i<j;i++)
    h -= counterAdvance(&New);

  i = 0;

  New.head += 60;//    Turn Right
  if (New.head > 360) New.head -= 360;

    while (h>0) {  // Advance
      h -= counterAdvance(&New);
      i ++;
      doLos(New.x,New.y,bx,by);
      acc = ProcLOSstr (LOSstring) + 4;
      doLos(bx,by,New.x,New.y);
      vul = ProcLOSstr (LOSstring) + 4;
      if (Modifier > acc ) {
        ModHead = New.head;
        ModForward = j;
        ModAdvance = i;
        Modifier = vul;
        }
      }
    }

/////////////////////////////////////////////////////////////////////////////
// Pitch Fork
// Left
//

  New = AI->Vector;

  HexMoved=0;          // Hexes Moved
  acc=0;
  i=0;

  for (j=0;j<MP-MH;j++) {
  h = MP - MH ; // + AI->MP

  for (i=0;i<j;i++)
    h -= counterAdvance(&New);

  i = 0;

  h--;
  New.head -= 60;//    Turn Left
  if (New.head < 0) New.head += 360;

    while (h>0) {  // Advance
      h -= counterAdvance(&New);
      i ++;
      doLos(New.x,New.y,bx,by);
      acc = ProcLOSstr (LOSstring) + 4;
      doLos(bx,by,New.x,New.y);
      vul = ProcLOSstr (LOSstring) + 4;
      if (Modifier > acc ) {
        ModHead = New.head;
        ModForward = j;
        ModAdvance = i;
        Modifier = vul;
        }
      }
    }

//gotoxy(1,1);
//cprintf("--> F %d H %d A %d \n",ModForward,ModHead,ModAdvance);
//getkey();
  i=On;
  while (ModForward > 0 && AI->MP > 0 && i==On) {
  i=AI->Advance();
  rest(MoveRest);
  ModForward--;
  }

  New.head = ModHead;

    if ((AI->Vector.head - New.head) < 0 && abs(AI->Vector.head - New.head) < 180) // Randomize Left/Right for higher level
      while (AI->Vector.head != New.head && AI->MP > 0) {
        AI->TurnRight();  rest(MoveRest);}
    else
      while (AI->Vector.head != New.head && AI->MP > 0) {
        AI->TurnLeft();  rest(MoveRest);}

  i=On;
  while (ModAdvance > 0 && AI->MP > 0 && i==On) {
  AI->Advance();
  rest(MoveRest);
  ModAdvance--;
  }

  i = On;
  if (ModHead == 0)
    while (AI->MP > 0 && i==On) i=AI->Advance();

return 0;
}


int counterAdvance(Vector *Vector)
{
int mpc;
int MP;
int i, o, k;
int x,y,Move = On, dam;
mpc = MPH[Map.Hex[Vector->x][Vector->y].Alt];
x = Vector->x + vec[Vector->head/30].x;
y = Vector->y + vec[Vector->head/30].y;

// AdvanceOpen
for (i=0;i<Units;i++)
  if ( (x == unit[i]->Vector.x && \
        y == unit[i]->Vector.y ) ) {
	Move = Off;
	}
  // Hex Open, Unit can Advance
if (x<=0 || x >= 60) // Mech Out Off bounds
  Move = Off; // Add Retreat

if (y<=0 || y >= 20) // Mech Out Off bounds
  Move = Off; // Add Retreat

if (Move == On) {
  Vector->x = x;
  Vector->y = y;

  mpc = MPC[Map.Hex[Vector->x][Vector->y].Type] + abs(mpc - MPH[Map.Hex[Vector->x][Vector->y].Type]);

//  MoveType< 0?mpc =1:mpc; // If a Mech is Jumping, only one MP / HEX
//  Position==0?mpc+=4:mpc; // If Mech is Prone, crawl costs 4 MP

  MP = mpc;
  }

if (Move == Off) MP = RETURNNULL;

return MP;
}

// Special AI Move variant of KITE, to be used by Player's Mouse Move
int Viper (class Unit *AI, int bx, int by, int MP, int range) {

int i,j;   // Counters
int g,h,k,l; // Avoidance
int dx = bx - AI->Vector.x; // Change in X
int dy = by - AI->Vector.y; // Change in Y
//dx *= 2; // each hex is 2 units wide and 1 wide

range ++; // Because doLos returns 1 as minimum

//dy *= 2;
Vector New;
//Vector Vector;

//AI->MP = MP; // MP initialized Elsewhere

  New.head = AI->Vector.head;
  if (dy == 0)  // Mech is on the same Y-Axis
    if (dx < 0) New.head = 270;// Go Left
      else New.head = 90;
  if (dx == dy)  // Mech on hexside
    if (dx >= 0) New.head = 150;
      else New.head = 330;
  if (dx ==-dy)  // Mech facing on hexside
    if (dx >= 0) New.head = 30;
      else New.head = 210;

//  gotoxy(1,24);
//  Start Heading
      // if unit too close it will back up      
//    while (AI->MP >= 0 && AI->Reverse() && doLos(AI->Vector.x,AI->Vector.y,bx,by) < range);

  rest(PlayerTime);
//  if ( getMoveCost(AI->Vector,New.head) != RETURNNULL) // Path is open

//    textprintf(screen,font,50,50+AI->Index*16,EGAColour[7],">> %d %d\n",AI->Vector.head,New.head);
//    getkey();
    if (AI->Vector.head != New.head)
      if (AI->Vector.head-New.head > 180 || (AI->Vector.head-New.head > -180 && AI->Vector.head-New.head <= 0)) // Test for left and right
        while (AI->Vector.head != New.head && AI->MP >= 0) {
          AI->TurnRight(); rest(PlayerTime);}
      else
        while (AI->Vector.head != New.head && AI->MP >= 0) {
          AI->TurnLeft(); rest(PlayerTime);}

  i = On;
  while (AI->MP >= 0 && i==On && doLos(AI->Vector.x,AI->Vector.y,bx,by) > range) {

      rest(PlayerTime);
      dx = bx - AI->Vector.x; // Change in X
      dy = by - AI->Vector.y; // Change in Y

    if (dy == 0)  // Mech is on the same Y-Axis
      if (dx < 0) New.head = 270;// Go Left
        else New.head = 90;
    if (dx == dy)  // Mech on hexside
      if (dx >= 0) New.head = 150;
        else New.head = 330;
    if (dx ==-dy)  // Mech facing on hexside
      if (dx >= 0) New.head = 30;
        else New.head = 210;


    if ( getMoveCost(AI->Vector,New.head) != RETURNNULL); // Path is open
    else {    // Mech must turn so it is facing a passable hex
      j = 0;
      for (i=0;i<2;i++) {
        j+=60;
        g=New.head+j;
        h=New.head-j;
        if (g > 330) g-=360;
          k = getMoveCost(AI->Vector,g);
        if (h < 30)  h+=360;
          l = getMoveCost(AI->Vector,h);
        if (k >= l && k!=RETURNNULL) New.head = g, i+=3;
        if (k <  l && l!=RETURNNULL) New.head = h, i+=3;
        }
      }

    if (AI->Vector.head != New.head)
      if (AI->Vector.head-New.head > 180 || (AI->Vector.head-New.head > -180 && AI->Vector.head-New.head <= 0)) // Test for left and right
        while (AI->Vector.head != New.head && AI->MP >= 0) {
          AI->TurnRight(); rest(PlayerTime);}
      else
        while (AI->Vector.head != New.head && AI->MP >= 0) {
          AI->TurnLeft(); rest(PlayerTime);}

//    if (doLos(AI->Vector.x,AI->Vector.y,bx,by) <= range) return 0;
//      else
      i=AI->Advance();

    if (Options.HighLight == On)
      drawHighLight(AI->Vector.x,AI->Vector.y);

    }

return 0;
}

// Special Function, it just turns the mech
int MilkSnake (class Unit *AI, int bx, int by, int MP, int range) {

int i,j;   // Counters
int g,h,k,l; // Avoidance
int dx = bx - AI->Vector.x; // Change in X
int dy = by - AI->Vector.y; // Change in Y
//dx *= 2; // each hex is 2 units wide and 1 wide

range ++; // Because doLos returns 1 as minimum

//dy *= 2;
Vector New;
//Vector Vector;

//AI->MP = MP; MP initialized Elsewhere

  New.head = AI->Vector.head;
  if (dy == 0)  // Mech is on the same Y-Axis
    if (dx < 0) New.head = 270;// Go Left
      else New.head = 90;
  if (dx == dy)  // Mech on hexside
    if (dx >= 0) New.head = 150;
      else New.head = 330;
  if (dx ==-dy)  // Mech facing on hexside
    if (dx >= 0) New.head = 30;
      else New.head = 210;

//  gotoxy(1,24);
//  Start Heading
      // if unit too close it will back up      
//    while (AI->MP >= 0 && AI->Reverse() && doLos(AI->Vector.x,AI->Vector.y,bx,by) < range);

  rest(PlayerTime);
//  if ( getMoveCost(AI->Vector,New.head) != RETURNNULL) // Path is open

//    textprintf(screen,font,50,50+AI->Index*16,EGAColour[7],">> %d %d\n",AI->Vector.head,New.head);
//    getkey();
    if (AI->Vector.head != New.head)
      if (AI->Vector.head-New.head > 180 || (AI->Vector.head-New.head > -180 && AI->Vector.head-New.head <= 0)) // Test for left and right
        while (AI->Vector.head != New.head && AI->MP >= 0) {
          AI->TurnRight(); rest(PlayerTime);}
      else
        while (AI->Vector.head != New.head && AI->MP >= 0) {
          AI->TurnLeft(); rest(PlayerTime);}

    if (Options.HighLight == On)
      drawHighLight(AI->Vector.x,AI->Vector.y);

return 0;
}

