/////////////////////////////////////////////////////////////////////////////
// Weapon functions
// Named after projectile weapons
// Rock
// Atl-Atl
// Pilum
//

int Rock(class Mech *AI, int Angle)
{
int  Number;
int  i,l;
int  Hit[20];

for (i=0;i<AI->Weapons;i++)
  Hit[i] = AI->Flag[i];

AlphaFlag = 0;
//printf("%d\n",Weapons);
//textattr(07);

for (i=0;i<AI->Weapons;i++)
  AI->Flag[i] = AlphaFlag;// * Weapon[i].Status;

    AlphaFlag = 1; // Fire All Posible Weapons


    for (i=0;i<AI->Weapons;i++) {
      if ( Hit[i]<=12 && AI->Weapon[i].State==1 && ((LeftArc[AI->Weapon[i].Loc]<=Angle && RightArc[AI->Weapon[i].Loc]>=Angle) || \
       ( (LeftArc[AI->Weapon[i].Loc]>=Angle &&-RightArc[AI->Weapon[i].Loc]<=Angle) || (-LeftArc[AI->Weapon[i].Loc]<=Angle && RightArc[AI->Weapon[i].Loc]>=Angle) )))
      AI->Flag[i] = AlphaFlag;
	else AI->Flag[i] = 0;
      }
      

for (i=0;i<AI->Weapons;i++) {
  AI->Flag[i] *= AI->Weapon[i].State;
  AI->Flag[i] *= Hit[i];    }

  return 0;
}

int Pilum(class Mech *AI, int Angle)
{
int  Number;
int  i,l;
int  MaxHeat = AI->HeatDisp + 5;
int  Hit[20];

for (i=0;i<AI->Weapons;i++)
  Hit[i] = AI->Flag[i];

AlphaFlag = 0;
//printf("%d\n",Weapons);
//textattr(07);

for (i=0;i<AI->Weapons;i++)
  AI->Flag[i] = AlphaFlag;// * Weapon[i].Status;

    AlphaFlag = 1; // Fire All Posible Weapons


    for (i=0;i<AI->Weapons;i++) {
      if ( Hit[i]<=12 && AI->Weapon[i].State!=-1 && ((LeftArc[AI->Weapon[i].Loc]<=Angle && RightArc[AI->Weapon[i].Loc]>=Angle) || \
       ( (LeftArc[AI->Weapon[i].Loc]>=Angle &&-RightArc[AI->Weapon[i].Loc]<=Angle) || (-LeftArc[AI->Weapon[i].Loc]<=Angle && RightArc[AI->Weapon[i].Loc]>=Angle) )))
      AI->Flag[i] = AlphaFlag;
	else AI->Flag[i] = 0;
      }
//                      0  1  2  3  4  5  6  7  8  9 10 11 12
//                      0  0  1  2  3  4  5  6  5  4  3  2  1
int Probability[14] = {36,36,36,35,33,30,26,21,15,10, 6, 3, 1, 0x0000};
int cur,WeaponsUsed = 0;
double val[20],max;
      
    for (i=0;i<AI->Weapons;i++)
      val[i] = Probability[Hit[i]] / 36.0 * (AI->Weapon[i].Damage*(AI->Weapon[i].Missiles+1)/2)/(AI->Weapon[i].Heat) * AI->Weapon[i].State;

    for (i=0;i<AI->Weapons;i++)
      AI->Flag[i] = Off;

    while (MaxHeat > 0 && WeaponsUsed != AI->Weapons) {
      max = 0;
      cur = 16;
      for (i=0;i<AI->Weapons;i++)
        if (val[i] >= max)
          cur = i,max = 1;

        val[cur] = 0;
        AI->Flag[cur] = 1;
        WeaponsUsed ++;
        MaxHeat -= AI->Weapon[i].Heat;
      }

for (i=0;i<AI->Weapons;i++)
  if (AI->Weapon[i].State == On && AI->Flag[i] == On)
    AI->Flag[i] = Hit[i]; else AI->Flag[i] = 0;

  return 0;
}

int Javelin(class Mech *AI, int Angle)
{
int  Number;
int  i,l;
int  MaxHeat = AI->HeatSinks - AI->MoveType; // Should be generated some where
int  Hit[20];                                // Or read from some AI Struct

for (i=0;i<AI->Weapons;i++)
  Hit[i] = AI->Flag[i];

AlphaFlag = Off;
//printf("%d\n",Weapons);
//textattr(07);

for (i=0;i<AI->Weapons;i++)
  AI->Flag[i] = AlphaFlag;// * Weapon[i].Status;

    AlphaFlag = On; // Fire All Posible Weapons

    for (i=0;i<AI->Weapons;i++) {
      if ( Hit[i]<=12 && AI->Weapon[i].State!=-1 && ((LeftArc[AI->Weapon[i].Loc]<=Angle && RightArc[AI->Weapon[i].Loc]>=Angle) || \
       ( (LeftArc[AI->Weapon[i].Loc]>=Angle &&-RightArc[AI->Weapon[i].Loc]<=Angle) || (-LeftArc[AI->Weapon[i].Loc]<=Angle && RightArc[AI->Weapon[i].Loc]>=Angle) )))
      AI->Flag[i] = AlphaFlag;
	else AI->Flag[i] = 0;
      }
//                      0  1  2  3  4  5  6  7  8  9 10 11 12
//                      0  0  1  2  3  4  5  6  5  4  3  2  1
int Probability[14] = {36,36,36,35,33,30,26,21,15,10, 6, 3, 1, 0x0000};
int cur,WeaponsUsed = 0;
double val[20],max;
      
    for (i=0;i<AI->Weapons;i++)
      if (AI->Weapon[i].State == On)
        val[i] = (Probability[Hit[i]] / 36.0) * (AI->Weapon[i].Damage)/(AI->Weapon[i].Heat+1);

    for (i=0;i<AI->Weapons;i++)
      AI->Flag[i] = Off;

    while (MaxHeat > 0 && WeaponsUsed != AI->Weapons) {
      max = 0;
      cur = 16;
      for (i=0;i<AI->Weapons;i++)
        if (val[i] >= max)
          cur = i, max = val[i];

        val[cur] = 0;
        AI->Flag[cur] = On;
        WeaponsUsed ++;
        MaxHeat -= AI->Weapon[cur].Heat;

//        textprintf(screen,font,20,20+WeaponsUsed*10,0,"W%2d M%2d H%2d I%2d",WeaponsUsed,MaxHeat,AI->Weapon[cur].Heat,cur);
      }
//      for (i=0;i<AI->Weapons;i++)
//        textprintf(screen,font,320,20+i*10,0,"I%2d",AI->Flag[i]);
//      getkey();

for (i=0;i<AI->Weapons;i++)
  if (AI->Weapon[i].State == On && AI->Flag[i] == On)
    AI->Flag[i] = Hit[i]; else AI->Flag[i] = 0;

  return 0;
}

/////////////////////////////////////////////////////////////////////////////
// Shuriken
// Should fire to MaxHeat
// Target must meet mimimum probability to fire 0% - Energy 50% - Missile...
//

int Shuriken(class Mech *AI, int Angle)
{
int  Number;
int  i,l;
int  MaxHeat = AI->HeatDisp - AI->MoveType; // Should be generated some where
int  Hit[20];                               // Or read from some AI Struct



for (i=0;i<AI->Weapons;i++)
  Hit[i] = AI->Flag[i];

AlphaFlag = 0;
//printf("%d\n",Weapons);
//textattr(07);

for (i=0;i<AI->Weapons;i++)
  AI->Flag[i] = AlphaFlag;// * Weapon[i].Status;

    AlphaFlag = 1; // Fire All Posible Weapons


    for (i=0;i<AI->Weapons;i++) {
      if ( Hit[i]<=12 && AI->Weapon[i].State!=-1 && ((LeftArc[AI->Weapon[i].Loc]<=Angle && RightArc[AI->Weapon[i].Loc]>=Angle) || \
       ( (LeftArc[AI->Weapon[i].Loc]>=Angle &&-RightArc[AI->Weapon[i].Loc]<=Angle) || (-LeftArc[AI->Weapon[i].Loc]<=Angle && RightArc[AI->Weapon[i].Loc]>=Angle) )))
      AI->Flag[i] = AlphaFlag;
	else AI->Flag[i] = 0;
      }
//                      0  1  2  3  4  5  6  7  8  9 10 11 12
//                      0  0  1  2  3  4  5  6  5  4  3  2  1
int Probability[14] = {36,36,36,35,33,30,26,21,15,10, 6, 3, 1, 0x0000};
int cur,WeaponsUsed = 0;
double val[20],max;

    for (i=0;i<AI->Weapons;i++) {
      val[i] = Probability[Hit[i]] / 36.0 * (AI->Weapon[i].Damage)/(AI->Weapon[i].Heat+1) * AI->Weapon[i].State;
      val[i] *= ((Weapon[i].Type==2||Weapon[i].Type==3)&&val[i]<=.32)0:1; // Doesn't waste ammunition
      }

    cur = 0;
    while (MaxHeat >= 0 && WeaponsUsed != AI->Weapons) {
      max = 0;
      for (i=0;i<AI->Weapons;i++)
        if (val[i] >= max)
        // && (Probability[Hit[i]] / 36.0) >= MinProb[i]
          cur = i;

        val[cur] = 0;
        AI->Flag[cur] = 1;
        WeaponsUsed ++;
        MaxHeat -= WeaponTable[AI->Weapon[i].Type].Heat;
      }

for (i=0;i<AI->Weapons;i++) {
  AI->Flag[i] *= AI->Weapon[i].State;
  AI->Flag[i] *= Hit[i];    }

  return 0;
}
