////////////////////////////////////////////////////////////////////////////
// Infantry Specific Functions
// Show
// Damage
// Physical Attacks


int Elemental::Show() {

int x1 = 110, y1 = 130;
int x = x1;
int y = y1;
int col = 0;
int HeatSinkChar;
int i;
//if (HeatSinkType == 1) HeatSinkChar = 'D';
//  else HeatSinkChar = 'S';

rectfill(screen,100,120,500,360,Window.BGColour);

x += 0; y += 0;
textprintf(screen,font,x,y,col," %s \n",Name);

x += 0; y += 8;
textprintf(screen,font,x,y,col,"Ground Speed : %d   Jump Range : %d\n",Speed,Jump);

getMen();
x += 0, y = y1 + 30,
textprintf(screen,font,x,y,col,"Men  %d\n",Men);

for (i=0;i<Men;i++) {
  x += 0; y += 8;
  textprintf(screen,font,x,y,col,"[%2d] Armour : %d \n",i+1,Armour[i]);
  }

  x += 160;
for (i=0;i<Weapons;i++) {
  x += 0; y = y1 + i*8 + 30;
  textprintf(screen,font,x,y,col,"%-15s \n",Weapon[i].Name);
//  textprintf(screen,font,x,y,col,"%-3s %-15s %s \n",Weapon[i].Name);
//  textprintf(screen,font,x,y,col,"%d       \n",WeaponTable[Weapon[i].Type].Dam);
  }

for (i=0;i<Ammunitions;i++) {
  x += 0; y = y1 + (Weapons+i)*8 + 30;
  textprintf(screen,font,x,y,col,"%-15s %d \n",Ammo[i].Name,Ammo[i].Ammo);
  }

//x += 0; y += 8;
//textprintf(screen,font,x,y,col,"Total Points %d \n",Armour*Men);

  x  = 110; y = 280;
  textprintf(screen,font,x,y,col,"Squad [%s] G:%2d \n",Pilot.Name,Pilot.Gunnery);
  y += 10;
  textprintf(screen,font,x,y,col,"Leg Attacks [%s]   Swarms [%s] \n",YesNo[LegAttacks],YesNo[Swarms]);
//            y += 10;
//  textprintf(screen,font,x,y,col,"Pilot %d : %s\n",Pilot.Hits,ConsciousFlag[Pilot.Conscious]);
//  x  = 110; y = 270;
//  textprintf(screen,font,x,y,col,"E%d G%d S%d L%d\n",EngineHits,GyroHits,SensorHits,LifeSupportHits);

return 0;
}

int Elemental::getMoveType(byte ch)
{

  switch (ch) {
    case 'w'  : if(getSpeed( 1)>0) return 1; break;
    case 'W'  : if(getSpeed( 1)>0) return 1; break;
    case 'j'  : if(getSpeed(-1)>0) return-1; break;
    case 'J'  : if(getSpeed(-1)>0) return-1; break;
    case 's'  : ; return 0;
    case 'S'  : ; return 0;
    case 'a'  : ;
    case 'U'  : return Surrender(Side);
    case 128+120  : ;
    case PgUp : ScrollUp  (); break;
    case 128+121  : ;
    case PgDn : ScrollDn  (); break;
    case 128+122  : ;
    case Home : ScrollLt  (); break;
    case 128+123  : ;
    case End  : ScrollRt  (); break;
    case 128+125  : ;
    case 'i'  : getInfo   (); break;
    case 'I'  : getInfo   (); break;
    case QUIT : ExitGame (0); break;
    case 'C'  : ;
    case 'c'  : CentreMap(Vector.x,Vector.y) ;break;
    case CTRLA: ToggleFastAI         (); break;
    case CTRLG: ToggleGrid           (); break;
    case CTRLW: ToggleShowWeapons    (); break;
    case CTRLS: ToggleCentreMap      (); break;
    case CTRLH: ToggleAltitudeDisplay(); break;
    case CTRLD: ToggleMovementDice   (); break;
    case CTRLO: ShowOptions          (); break;
    case CTRLE: screen_shot          (); break;
    default   : ;break;
  }

return RETURNNULL;
}

int Elemental::Move(byte ch)
{
  switch (ch) {
//  case 'a'  : MP = 1; return 1;
  case 32   : return 2;
//  case 's'  : if (Position == 0) Stand();return 1 ; // Stand Up
//  case 'd'  : ; // Drop Down /
//  case 'p'  : if (Position == 1 && MoveType >= 0)Prone();return 1 ; // go Prone
  case 128+120  : ;
  case PgUp : ScrollUp();break;
  case 128+121  : ;
  case PgDn : ScrollDn();break;
  case 128+122  : ;
  case Home : ScrollLt();break;
  case 128+123  : ;
  case End  : ScrollRt();break;
  case 128+126  : if (Options.MouseMove==On) MouseMove(0);return 0; // Mouse Button 2
  case 128+125  : if (Options.MouseMove==On){MouseMove(1);return 0;}// Mouse Button 1
  case 'i'  : ;
  case 'I'  : getInfo  (); return 1 ;
  case Up   : Advance  (); return 1 ;
  case Left : TurnLeft (); return 1 ;
  case Right: TurnRight(); return 1 ;
  case Down : Reverse  (); return 1 ;
  case QUIT : ExitGame(0) ;break;
  case 'C'  : ;
  case 'c'  : CentreMap(Vector.x,Vector.y) ;break;
  case CTRLA: ToggleFastAI         (); break;
  case CTRLG: ToggleGrid           (); break;
  case CTRLW: ToggleShowWeapons    (); break;
  case CTRLS: ToggleCentreMap      (); break;
  case CTRLH: ToggleAltitudeDisplay(); break;
  case CTRLD: ToggleMovementDice   (); break;
  case CTRLO: ShowOptions          (); break;
  case CTRLE: screen_shot          (); break;
//  case EXAM : Exam(); return 0;break;
//  case 32   : return 0;
  default   : ;break;
  }

return 0;
}

int Elemental::Advance()
{
int mpc;
int i, o, k;
int x,y,Move = On, dam;
int BuildingHeight = 0;
int BuildingModifier = 0;

x = Vector.x + vec[Vector.head/30].x;
y = Vector.y + vec[Vector.head/30].y;

// if (AdvanceOpen())
// AdvanceOpen
int UnitsInHex=0;
for (i=0;i<Units;i++)
  if ( (x == unit[i]->Vector.x && \
        y == unit[i]->Vector.y ) ) {
        UnitsInHex ++;
        if (Options.Stacking==On) {
//          if (unit[i]->Side!=Side)
//   	    Move = Off; // Can't stack with an enemy on the ground
//          else {
            if (Stacked == Off)
              LastVector = Vector;              
            Stacked = On;
            }
        }

// Max Units in hex
//if (UnitsInHex >= 5) Move = Off, Stacked = Off;

  // Hex Open, Unit can Advance

if (x<Xmin || x >= Xmax) // Elemental Out Off bounds
  {Move = Off;MP = 0;
  if(Options.Retreat==On) Retreat(); }

if (y<Ymin || y >= Ymax) // Elemental Out Off bounds
  {Move = Off;MP = 0;
  if(Options.Retreat==On) Retreat(); }

  if(MoveType<0) // If a Mech is Jumping, can't Jump over obstacle
    if(Altitude+Jump < MPH[Map.Hex[x][y].Alt])
      Move = Off;

// Buildings
/*
  if (Map.Hex[x][y].Type == 'L') BuildingModifier = 1, BuildingHeight = 1;
  if (Map.Hex[x][y].Type == 'M') BuildingModifier = 2, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'H') BuildingModifier = 3, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'A') BuildingModifier = 5, BuildingHeight = 3;

  if (BuildingModifier != 0 && MoveType >= 0) // Buildings on Foot
    if (PilotingRoll >= genPilotModifier()+BuildingModifier) {
      Move = On;
        if (Tons > Map.Hex[x][y].Index) DamageHex(x,y,Map.Hex[x][y].Index), BuildingHeight = 0;}
      else Move = Off;
*/
  if (Position+1 <= - MPH[Map.Hex[Vector.x][Vector.y].Alt] && Map.Hex[Vector.x][Vector.y].Type == 'w') Move = Off;
//    else Submersed = Off;

  if (MPC[Map.Hex[x][y].Type] == 20 && MoveType>=0) // Impassable by Foot
    Move=Off;
  if (Map.Hex[x][y].Fire == 'f' || Map.Hex[x][y].Fire == 'F')
    Move=Off;

if (Move == On) {

  mpc = MPC[Map.Hex[x][y].Type];
  if (onRiver(x,y)) mpc ++;
  if (onRoad(Vector.x,Vector.y) && onRoad(x,y))
    mpc = 1, BuildingHeight = (RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt])>=0?(RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt]):0;

  if (Map.Hex[x][y].Type == 'L') mpc = 1;
  if (Map.Hex[x][y].Type == 'M') mpc = 1;
  if (Map.Hex[x][y].Type == 'H') mpc = 1;
  if (Map.Hex[x][y].Type == 'A') mpc = 1;

//  mpc += abs(MPH[Map.Hex[Vector.x][Vector.y].Alt] - MPH[Map.Hex[x][y].Alt]);
  mpc += 2*abs(Altitude - MPH[Map.Hex[x][y].Alt]-BuildingHeight);

  MoveType< 0?mpc =1:mpc; // If a Mech is Jumping, only one MP / HEX

//  Submersed==On?mpc+=4:mpc; // If Mech under water

  if (HexesMoved == 0 || MP >= mpc) { // Can't advance if Infantry lacks MP

    Altitude = MPH[Map.Hex[x][y].Alt] + BuildingHeight;
//      HeatTurn += 2;

    drawHex(Vector.x,Vector.y);

    Vector.x = x;
    Vector.y = y;

  if (UnitsInHex == 0) {
    if (Stacked == On)
      drawUnits();
      Stacked = Off;
      }

    drawUnit(0);
  
//    if (Carrying >= 0) Item[Carrying].Vector = Vector; // If Mech moves, Item moves with it

//    if (MoveType >= 1)
//      if (Map.Hex[Vector.x][Vector.y].Type == 'w' && PilotingRoll < (genPilotModifier()-1)) putString("Slid Fall",Colour),getkey(),Fall(0); // Mech can fall if it enters water hex
//    if ((Map.Hex[x][y].Type == 'w') && (PilotingRoll < (genPilotModifier()-1))) putString("Slid Fall",Colour),getkey(),Fall(0); // Mech can fall if it enters water hex

    MP -= mpc;
    HexesMoved ++;
    }
    else Move = Off; // Not Enough MP
  }

return Move;
}


int Elemental::Reverse()
{
int mpc;
int i, o, k;
int x,y,Move = On, dam;
int BuildingHeight = 0;
int BuildingModifier = 0;
mpc = MPH[Map.Hex[Vector.x][Vector.y].Alt];
i = Vector.head + 180;
if (i > 360) i -= 360;
if (i <   0) i += 360;
x = Vector.x + vec[i/30].x;
y = Vector.y + vec[i/30].y;

// if (AdvanceOpen())
// AdvanceOpen
if (MoveType == 1) {
int UnitsInHex=0;
for (i=0;i<Units;i++)
  if ( (x == unit[i]->Vector.x && \
        y == unit[i]->Vector.y ) ) {
        UnitsInHex ++;
        if (Options.Stacking==On)
          if (unit[i]->Side!=Side)
   	    Move = Off; // Can't stack with an enemy on the ground
          else {
            if (Stacked == Off)
              LastVector = Vector;              
            Stacked = On;
            }
        }

  // Hex Open, Unit can Advance

if (x<=Xmin || x >= Xmax) { // Elemental Out Off bounds
  Move = Off,MP = 0;
  if(Options.Retreat==On) Retreat(); }

if (y<=Ymin || y >= Ymax) { // Elemental Out Off bounds
  Move = Off,MP = 0;
  if(Options.Retreat==On) Retreat(); }

  if(MoveType<0) // If a Mech is Jumping, can't Jump over obstacle
    if(Altitude+Jump < MPH[Map.Hex[x][y].Alt])
      Move = Off;

// Buildings
/*
  if (Map.Hex[x][y].Type == 'L') BuildingModifier = 1, BuildingHeight = 1;
  if (Map.Hex[x][y].Type == 'M') BuildingModifier = 2, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'H') BuildingModifier = 3, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'A') BuildingModifier = 5, BuildingHeight = 3;

  if (BuildingModifier != 0 && MoveType >= 0) // Buildings on Foot
      Move = Off;
*/
// Water Submersion
  if (Position+1 <= - MPH[Map.Hex[Vector.x][Vector.y].Alt] && Map.Hex[Vector.x][Vector.y].Type == 'w') Move=Off;//Submersed = On;
//    else Submersed = Off;

  if (MPC[Map.Hex[x][y].Type] == 20 && MoveType>=0) // Impassable by Foot
    Move=Off;
  if (Map.Hex[x][y].Fire == 'f' || Map.Hex[x][y].Fire == 'F')
    Move=Off;
    
if (Move == On) {

  mpc = MPC[Map.Hex[x][y].Type];
  if (onRiver(x,y)) mpc ++;
  if (onRoad(Vector.x,Vector.y) && onRoad(x,y))
    mpc = 1, BuildingHeight = (RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt])>=0?(RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt]):0;
    
  if (Map.Hex[x][y].Type == 'L') mpc = 1;
  if (Map.Hex[x][y].Type == 'M') mpc = 1;
  if (Map.Hex[x][y].Type == 'H') mpc = 1;
  if (Map.Hex[x][y].Type == 'A') mpc = 1;

//  mpc += abs(MPH[Map.Hex[Vector.x][Vector.y].Alt] - MPH[Map.Hex[x][y].Alt]);
  mpc += 2*abs(Altitude - MPH[Map.Hex[x][y].Alt]-BuildingHeight);

  MoveType< 0?mpc =1:mpc; // If a Mech is Jumping, only one MP / HEX
//  Position==0?mpc+=4:mpc; // If Mech is Prone, crawl costs 4 MP
//  Submersed==On?mpc+=4:mpc; // If Mech under water

  if (HexesMoved == 0 || MP >= mpc) { // Can't advance if Mech lacks MP, MPC of 20 denotes Impassable

    Altitude = MPH[Map.Hex[x][y].Alt] + BuildingHeight;
//      HeatTurn += 2;

    drawHex(Vector.x,Vector.y);
    Vector.x = x;
    Vector.y = y;

    if (UnitsInHex == 0) {
      if (Stacked == On)
        for (i=0;i<Units;i++)
          unit[i]->drawUnit(0);
        Stacked = Off;
        }

    drawUnit(0);

//    if (Carrying != -1) Item[Carrying].Vector = Vector; // If Mech moves, Item moves with it
//    if (Map.Hex[x][y].Type == 'w' && PilotingRoll < (genPilotModifier()-1-Pilot.FallBonus)) Fall(0); // Mech can fall if it enters water hex

    MP -= mpc;
    HexesMoved ++;
    Reversed ++;
    }
    else Move = Off;
  }
}
//  else Charge(Unit[i])

return Move;
}

int Elemental::TurnLeft()
{
//if (onRoad(Vector.x,Vector.y) == On && RoadHeight(Vector.x,Vector.y) == Altitude && MoveType >= 2)
//  if (PilotingRoll < genPilotModifier()+TargetEvasion[HexesMoved]-1) Skid();

Vector.head -= 60;
if (Vector.head < 0) Vector.head += 360;
//if (MP > 0) MoveType < 0 ? MP : MP -= 1; // If unit Jumps no MP cost

  drawUnit(1);

return 1;
}

int Elemental::TurnRight()
{
//if (onRoad(Vector.x,Vector.y) == On && RoadHeight(Vector.x,Vector.y) == Altitude && MoveType >= 2)
//  if (PilotingRoll < genPilotModifier()+TargetEvasion[HexesMoved]-1) Skid();

Vector.head += 60;
if (Vector.head >= 360) Vector.head -= 360;
//if (MP > 0) MoveType < 0 ? MP : MP -= 1;// If unit Jumps no MP cost

  drawUnit(1);
  
return 1;
}

int Elemental::getSpeed(char a) {
int WP;
//int WP = Walk;
WP = Speed;


WP<=0?WP=0:WP;

switch (a) {
case 0: return  0;
case 1: return  WP;
case 2: return int ( (WP * 1.5)+.5 );
case 3: return WP*2;
case 4: return int ( (WP * 1.5)+.5 );
case-1: return Jump;

default:;break;
}
//int c = a>0?a>1?a>2?Sprint:Run : Walk :a<0?Jump:0; return c;
return WP;
};

void Elemental::WeaponSelect(int Angle,int Target)
{
char key;
char cd[256];
int  Number;
int  i,l;
int x,y,col=0;
int Hit[20];
int AngleLoc[20];
int ProneFlag = 0;
char ErrorMSG[80];

char AlphaFlag;

BITMAP *block;
block = create_bitmap(550,250);

x = 110;
y = 130;

blit    (screen,block,100,120,0,0,550,250);

ScrollLock = On;
//Bind Angle
if (Angle >  180) Angle -= 360;
if (Angle < -180) Angle += 360;
for (i=0;i<Weapons;i++)
  Hit[i] = Flag[i];

cd['1'] = 0;
cd['2'] = 1;
cd['3'] = 2;
cd['4'] = 3;
cd['5'] = 4;
cd['6'] = 5;
cd['7'] = 6;
cd['8'] = 7;
cd['9'] = 8;
cd['0'] = 9 ;
cd['q'] = 10;
cd['w'] = 11;
cd['e'] = 12;
cd['r'] = 13;
cd['t'] = 14;
cd['y'] = 15;
cd['u'] = 16;
cd['i'] = 17;
cd['o'] = 18;
cd['p'] = 19;
cd[8]   = 127;
cd[TAB] = 127;

//clrscr();

AlphaFlag = 0;
//printf("%d\n",Weapons);
//textattr(07);

for (i=0;i<Weapons;i++)
  Flag[i] = AlphaFlag;// * Weapon[i].Status;

while (key != FIRE && key != DONE && key != QUIT) {
//drawWeaponBox(vMech);
vsync();
rectfill(screen,100,120,600,360,Window.BGColour);

//sprintf(bString,"# Weapons %d   %s %d",Weapons,Weapon[0].Name,Weapon[0].Damage);
//putString(bString,EGAColour[3]);
//getkey();

for (i=0;i<Weapons;i++) { // Should Really be an If Statement
  y = i * 8 + 130;

      sprintf(ErrorMSG,"%2d ",Hit[i]);
      if (WeaponTarget[i] != -1)
        sprintf(ErrorMSG,"%2d [%s] ",Hit[i],unit[WeaponTarget[i]]->Name);

    if (Weapon[i].State == -2)
      sprintf(ErrorMSG,"Weapon Jammed");
    if (Weapon[i].State == -1)
      sprintf(ErrorMSG,"Weapon Destroyed");

    if (Hit[i] == 127)
      sprintf(ErrorMSG,"Used");
    if (Hit[i]>=24)
      sprintf(ErrorMSG,"No LOS");
    if (Hit[i]> 12)
      sprintf(ErrorMSG,"Out of Range");

    if (Weapon[i].AmmoConsumption == 0)
      textprintf(screen,font,x,y,col,"%2d >> %-20s             %3s %s\r\n",i+1,Weapon[i].Name,State[Flag[i]],ErrorMSG);
    else
      textprintf(screen,font,x,y,col,"%2d >> %-20s       <%3d> %3s %s\r\n",i+1,Weapon[i].Name,AmmoState(Weapon[i].AmmoType,0),State[Flag[i]],ErrorMSG);

  }


key = getkey();

if (key != FIRE && key != DONE && key != QUIT) {

  if (key == 125) { // Left Mouse Button
    key = ((mouse_y-130+4)/8);
    if (key < 10) key+=48;
    if (key >= 10)
      switch (key) {
      case 10: key = 'q';break;
      case 11: key = 'w';break;
      case 12: key = 'e';break;
      case 13: key = 'r';break;
      case 14: key = 't';break;
      case 15: key = 'y';break;
      case 16: key = 'u';break;
      case 17: key = 'i';break;
      case 18: key = 'o';break;
      case 19: key = 'p';break;
      default: ;break;
      }
    key < 0 ? key = 100 : key;
//    textprintf(screen,font,20,20,10,"%d %d",key,Weapons);
    }

// (  ( (LeftArc[Weapon[cd[key]].Loc]<=Angle && RightArc[Weapon[cd[key]].Loc]>=Angle) || /*Front Arc Check*/
//      (LeftArc[Weapon[cd[key]].Loc]>=Angle &&-RightArc[Weapon[cd[key]].Loc]<=Angle) ) ||
//     (-LeftArc[Weapon[cd[key]].Loc]<=Angle && RightArc[Weapon[cd[key]].Loc]>=Angle) ) /*Rear Arc Check*/

//  if (Hit[cd[key]] != 127 && Weapon[cd[key]].Status == On && AmmoState(Weapon[cd[key]].Type,0) > 0) {

  if ( Hit[cd[key]]<=12 && Weapon[cd[key]].State >= 0 \
  && AmmoState(Weapon[cd[key]].AmmoType,0) >= Weapon[cd[key]].AmmoConsumption )
    Flag[cd[key]] ^= 0x0001;

  if (cd[key] == 127) {
    AlphaFlag ^= 0x0001;

// Alpha Strike
    for (i=0;i<Weapons;i++)
      if ( Hit[i]<=12 && Weapon[i].State >= 0 \
        && AmmoState(Weapon[i].AmmoType,0) >= Weapon[i].AmmoConsumption )
          Flag[i] = AlphaFlag;
          else Flag[i] = 0;


      }
    }
  }

for (i=0;i<Weapons;i++) {

    if (Flag[i] == 1 && Options.SimultaneousWeaponFire == Off)
      WeaponTarget[i] = Target,
      Flag[i] = Hit[i];

    if (Hit[i] == 127)
      Flag[i] = 127;

    // Weapon Targeted at new Target
    if (Flag[i] == 1 && Options.SimultaneousWeaponFire == On) {
      WeaponTarget[i] = Target;
      Pilot.TargetPenalty = 1;
      Flag[i] = Hit[i];
      }
    // Preserve Weapon Target
    if (WeaponTarget[i] != -1 && Flag[i] == 0 && Hit[i] > 0 && Hit[i] <= 12 && Options.SimultaneousWeaponFire == On)
      Flag[i] = Hit[i];

//    Flag[i] *= Weapon[i].State;
  }

ScrollLock = Off;
vsync();
blit    (block,screen,0,0,100,120,550,250);
destroy_bitmap(block);
}



int Elemental::genToHit(class Unit Target) {
//i = Gunnery + Mod;
//Tohit = Gunnery + Modifier + Heat + Move + TargetMove + Range + Weather + Global;
// Add option to soften range limits
int Range,Modifier,ToHit;
float Medium = 1.0;
int i,a;
int Cover;
char bString[60];
int Hit[20];

for (i=0;i<Weapons;i++)
  Hit[i] = Flag[i];

//Range = 0 ;
Range    = doLos(Vector.x,Vector.y,Target.Vector.x,Target.Vector.y);
Modifier = ProcLOSstrALT (LOSstring,Altitude,Position,Target.Altitude,Target.Position);
Cover    = ProcCover (LOSstring,Altitude,Position,Target.Altitude,Target.Position);

ToHit  = Pilot.Gunnery;
ToHit += Pilot.TargetPenalty;
ToHit += Modifier;

if (MoveType >= 0)
  ToHit += MoveType;
else
  ToHit += 3; // Jumping Elementals

ToHit += TargetEvasion [ Target.HexesMoved ];

ToHit += HeatAcc [ Heat ];
if (Target.Immobile == On)
  ToHit += -4;

if (Target.MoveType == 3) ToHit -= 1;
if (Target.MoveType == 4 && Options.SkilledEvade == On ) ToHit  =(9 - Pilot.Piloting) / 2;
if (Target.MoveType == 4 && Options.SkilledEvade == Off) ToHit += 1;

if (Options.AngleOfAttack == On) {
  if (abs(Vector.head - Target.Vector.head) == 0) ToHit += 0;
  if (abs(Vector.head - Target.Vector.head) == 1) ToHit += 2;
  if (abs(Vector.head - Target.Vector.head) == 2) ToHit += 3;
  if (abs(Vector.head - Target.Vector.head) == 3) ToHit += 1;
  }

if (Target.Position == 0)
  if (Range == 1)
    ToHit += -1; // If unit prone and close, easier to-hit
  else
    ToHit +=  1; // If unit prone and far, tougher to-hit

for (i=0;i<Weapons;i++)
  if (Flag[i] == 0 || Options.SimultaneousWeaponFire == On) {
    Flag[i] = 1;

    Flag[i] *= ToHit;
    a = Weapon[i].Type;

    Range <=(WeaponTable[a].Minimum* Medium) ? Flag[i] +=int(WeaponTable[a].Minimum*Medium) - Range + 1 : i;
    Range > (WeaponTable[a].Short  * Medium) ? Flag[i] += 2  : i ;
    Range > (WeaponTable[a].Medium * Medium) ? Flag[i] += 2  : i ;
    Range > (WeaponTable[a].Long   * Medium) ? Flag[i] += 12 : i ;
    if (Options.ExtremeRange == On && Range > (WeaponTable[a].Long   * Medium))
    Range <=((WeaponTable[a].Medium*2)*Medium) ? Flag[i] -= 8  : i ;

    if ( Flag[i] < 2 && Options.LinearGunnery == Off)
      Flag[i] = 2;
    if ( Flag[i] < 1 && Options.LinearGunnery == On )
      Flag[i] = 1;

  }
  else {
    if ( Options.SimultaneousWeaponFire == Off )
      Flag[i] = 127; // Weapon Previosly Fired
    if ( Options.SimultaneousWeaponFire == On && Flag[i] != 0)
      Flag[i] = Hit[i];
    }

return ToHit;
}

int Elemental::SetWeaponTarget(class Unit *Target) {
int i;

for (i=0;i<Weapons;i++)
  if (Flag[i] >= 2 && Flag[i] <= 12) {
    WeaponTarget[i] = Target->Index;
    Pilot.TargetPenalty = 1;
    }

return 0;
}

int Elemental::ShowWeaponFire(int Weap, class Unit *Target) {
int i = Weap;
int x, y;
int xa, ya;
int x1 = (Vector.x-scrollx)*HexWidth+globalx+16;
int y1 = (Vector.y-scrolly)*HexHeight+globaly+18;

int x2 = (Target->Vector.x-scrollx)*HexWidth+globalx+16;
int y2 = (Target->Vector.y-scrolly)*HexHeight+globaly+18;

//for (i=0;i<Weapons;i++)
  if (Flag[i]>=1 && Flag[i]<=12 && WeaponTarget[i] == Target->Index) {

    xa  = FireCoor[UnitColour][Weapon[i].Loc].x;
    ya  = FireCoor[UnitColour][Weapon[i].Loc].y;
    
//    x  = x1 + int(x*cos((Vector.head-90)*PI/180))-int(y*sin((Vector.head-90)*PI/180));
    x   = int(xa*cos((Vector.head-90.0)*PI/180)) - int(ya*sin((Vector.head-90.0)*PI/180));
    y   = int(ya*cos((Vector.head-90.0)*PI/180)) + int(xa*sin((Vector.head-90.0)*PI/180));
    x  += x1;
    y  += y1;

    drawWeaponFire(Weapon[i].Effect,1,x,y,x2,y2);
    }
return 0;
}

int Elemental::Damage(int Loc, int Facing, int Dam) {
int Target;
int OrigMen = Men; // To check if squad has lost any Men

switch (Map.Hex[Vector.x][Vector.y].Type) {
case '.': Dam *= 2; break;
case 'L':
  DamageHex(Vector.x,Vector.y,Dam);
  Dam = int(Dam * .75 + .5);
  break;
case 'M':
  DamageHex(Vector.x,Vector.y,Dam);
  Dam = int(Dam * .5 + .5);
  break;
case 'H':
  DamageHex(Vector.x,Vector.y,Dam);
  Dam = int(Dam * .25 + .5);
  break;
case 'A':
  DamageHex(Vector.x,Vector.y,Dam);
  Dam = 0;
  break;
default: ;break;
}

getMen();

if (Men == 0) return 0;

Target = rolldx(Men); // Determines which elemental gets hit

Armour[Target] -= Dam;
if (Armour[Target] < 0) Armour[Target] = 0;

getMen();

if (Men != OrigMen) {
  if (Men <= 0) {
    readMechSprite(Index,5,SpriteName[Index]);
    readMechFallSprite(Index,6,SpriteName[Index]);
    Immobile = On;
    Status = Off;

    RemoveUnit(u);
    drawHex(Vector.x,Vector.y);
    drawUnit(0);
    }
  if (Men == 1) readMechSprite(Index,3,SpriteName[Index]);
  if (Men == 2) readMechSprite(Index,2,SpriteName[Index]);
  if (Men == 3) readMechSprite(Index,1,SpriteName[Index]);
  if (Men >= 4) readMechSprite(Index,0,SpriteName[Index]);
  }


return Loc;
}

int Elemental::ResolveWeapons(class Unit *Attacker) {
int i,j,k,r,d,l,c,a;
int MisHit; // # of Missiles that actually Connect
int x,y,col=Window.TextColour;
int PartialCover;
int Dam,DamageCluster,Cluster;
char bString[40];

sprintf(bString,"Missiles");

BITMAP *block;
block = create_bitmap(550,250);

x = 60;
y = 130;

ScrollLock = Off;

blit    (screen,block, 50,120,0,0,550,250);
vsync();
rectfill(screen, 50,120,550,360,Window.BGColour);

//PartialCover = ProcCover(LOSstring,0,2,0,2);
PartialCover = ProcCover(LOSstring,Attacker->Altitude,Attacker->Position+1,Altitude,Position+1);

for (i=0;i<Attacker->Weapons;i++) {
    r = GunneryRoll;

  if (Attacker->AmmoState(Attacker->Weapon[i].AmmoType,0) < Attacker->Weapon[i].AmmoConsumption )
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d Ammo Depleted\n",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Options.WeaponJams == On && Weapon[i].Jams == 1 && r <= Weapon[i].JamMod+(Weapon[i].RateOfFire/2))
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d Weapon Jams\n",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Attacker->Flag[i] == 0)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d OFFLINE\n",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Attacker->Flag[i] == 127)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Used\n",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Attacker->Flag[i] > 12)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Target ERROR - Shot Aborted\n",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Attacker->Flag[i] <= r) {
  Attacker->Pilot.TargetPenalty = 1; // If a weapon is fired, multiple target penalty

    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Hits",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage);
    Attacker->AmmoState(Attacker->Weapon[i].AmmoType, Attacker->Weapon[i].RateOfFire);

  HeatTurn += Attacker->Weapon[i].TargetHeat;
  Infernos += Attacker->Weapon[i].Persistence; // Inferno
  k = Attacker->Weapon[i].Missiles*Attacker->Weapon[i].RateOfFire;

  if (Options.GlancingHits == On && Attacker->Flag[i] == r)
    Cluster = -2; // Glancing Hit
  else Cluster = 0;
  if (Options.MissileBonus == On) Cluster += r - Attacker->Flag[i];

    Cluster =  roll2d6 + Attacker->Weapon[i].Cluster + Cluster; // Artemis etc.
    Cluster<0?Cluster=0:Cluster>12?Cluster=12:Cluster;// Bind Cluster

    c = Misptr[k][Cluster];
//    c<1?c=1:c;
    c<0?c=0:c;

    Dam = c * (Attacker->Weapon[i].Damage);
    DamageCluster = Attacker->Weapon[i].DamageCluster;

//    Damage(k, l, Dam );

  if (Dam == DamageCluster) { // One Hit / Med/Laser
        l = getFacing(getDamageAngle(Attacker->Vector,Vector));
            
        if (Options.GlancingHits == On && Attacker->Flag[i] == r)
  	  Damage(0, l,(Attacker->Weapon[i].Damage)/2); // Glancing Hit
        else
  	  Damage(0, l, Attacker->Weapon[i].Damage );
      }
  else {
//        y+=8;
//        textprintf(screen,font,x,y,col," %d %s Hit \n",c,bString);
        l = getFacing(getDamageAngle(Attacker->Vector,Vector));

      for (k=0;k<Dam;k+=DamageCluster) {

        Damage( 0 ,l,DamageCluster);
//        y+=8;
//        textprintf(screen,font,x,y,col,"Hits %s\n",LocationName[d+1]);
        }

      if (Dam%DamageCluster>0)
        Damage( 0 ,l,Dam%DamageCluster);
//        y+=8;
        }


  } // End if
    else {
    if (Attacker->Weapon[i].Locking == On);
    else Attacker->AmmoState(Attacker->Weapon[i].AmmoType,1);

    Pilot.TargetPenalty = 1; // If a weapon is fired, multiple target penalty
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Miss\n",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage);

    if (Map.Hex[Vector.x][Vector.y].Type=='t'||Map.Hex[Vector.x][Vector.y].Type=='T')
      if (roll2d6 <= 3)
        CreateFire(Vector.x,Vector.y);

    }
    y+=8;

  } // End for



getkey();
vsync();
ScrollLock = On;
blit    (block,screen,0,0, 50,120,550,250);
destroy_bitmap(block);
return 0;
}

int Elemental::drawUnit(int Clear) {
// 0 : Draws over Hex
// 1 : Clears Hexs

if (Hidden != On) {
  if (Clear == On) drawHex (Vector.x,Vector.y);
  drawMech(Vector,UnitColour,Position);
  }

return 0;
}

int Elemental::genToHitHex(struct Vector Target) {
int Range,Modifier,ToHit;
float Medium = 1.0;
int i,a;
int x=50,y = 100;
int col = makecol24(171,0,0);
int Ranges;
//Range = 0 ;
Ranges = doLos(Vector.x,Vector.y,Target.x,Target.y);
Modifier = ProcLOSstrALT (LOSstring,Altitude,Position+1,MPH[Map.Hex[Target.x][Target.y].Alt],TerHeight[Map.Hex[x][y].Type]+1);

ToHit  = Pilot.Gunnery;
ToHit += Modifier;
ToHit += MoveType + (MoveType - MoveType) * -2;
ToHit += HeatAcc [ Heat ];
ToHit += -4;

for (i=0;i<Weapons;i++)
  if (Flag[i] == 0) {
    Flag[i] = 1;

    Flag[i] *= ToHit;

    Range <=(WeaponTable[a].Minimum* Medium) ? Flag[i] +=int(WeaponTable[a].Minimum*Medium) - Range + 1 : i;
    Range > (WeaponTable[a].Short  * Medium) ? Flag[i] += 2  : i ;
    Range > (WeaponTable[a].Medium * Medium) ? Flag[i] += 2  : i ;
    Range > (WeaponTable[a].Long   * Medium) ? Flag[i] += 12 : i ;
    if (Options.ExtremeRange == On && Range > (WeaponTable[a].Long   * Medium))
    Range <=((WeaponTable[a].Medium*2)*Medium) ? Flag[i] -= 8  : i ;

    if ( Flag[i] < 2 && Options.LinearGunnery == Off)
      Flag[i] = 2;
    if ( Flag[i] < 1 && Options.LinearGunnery == On )
      Flag[i] = 1;

    if (Range == 1)
      Flag[i] = 2;

    if ( Flag[i] < 2)
      Flag[i] = 2;
  }
  else
    Flag[i] = 127; // Weapon Previosly Fired

return ToHit;
}

int Elemental::ResolveWeaponsHex(struct Vector Target) {
int i,j,k,r,d,l,c;
int MisHit; // # of Missiles that actually Connect
int x,y;
int col=Window.TextColour;
int PartialCover;
char String[80],bString[40];
int Dam,DamageCluster,Cluster;
sprintf(bString,"Missiles");

BITMAP *block;
block = create_bitmap(550,250);

x = 60;
y = 130;

blit    (screen,block, 50,120,0,0,550,250);
vsync();
rectfill(screen, 50,120,550,360,Window.BGColour);

for (i=0;i<Weapons;i++) {
  r = GunneryRoll;
  if (AmmoState(Weapon[i].AmmoType,0) < Weapon[i].AmmoConsumption )
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d Ammo Depleted\n",r,Flag[i], Weapon[i].Name,Weapon[i].Damage,Flag[i]);
  if (Options.WeaponJams == On && Weapon[i].Jams == 1 && r <= Weapon[i].JamMod+(Weapon[i].RateOfFire/2))
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d Weapon Jams\n",r,Flag[i], Weapon[i].Name,Weapon[i].Damage,Flag[i]);
  else
  if (Flag[i] == 0)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d OFFLINE\n",r,Flag[i], Weapon[i].Name,Weapon[i].Damage,Flag[i]);
  else
  if (Flag[i] == 127)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Used\n",r,Flag[i], Weapon[i].Name,Weapon[i].Damage,Flag[i]);
  else
  if (Flag[i] > 12)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Target ERROR - Shot Aborted\n",r,Flag[i],Weapon[i].Name,Weapon[i].Damage,Flag[i]);
  else
  if (Flag[i] <= r) {
  Pilot.TargetPenalty = 1; // If a weapon is fired, multiple target penalty

    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d ",r,Flag[i], Weapon[i].Name,Weapon[i].Damage);

    AmmoState(Weapon[i].AmmoType, Weapon[i].RateOfFire);
//  if (Weapon[i].TargetHeat > 0 || Weapon[i].Persistence > 0) // Inferno
  if (Weapon[i].Persistence > 0) // Inferno
    CreateFire(Target.x,Target.y);

  k = Weapon[i].Missiles*Weapon[i].FireMode;

  if (Options.GlancingHits == On && Flag[i] == r)
    Cluster = -2; // Glancing Hit
  else Cluster = 0;

    Cluster =  roll2d6 + Weapon[i].Cluster + Cluster; // Artemis etc.
    Cluster<0?Cluster=0:Cluster>12?Cluster=12:Cluster;// Bind Cluster

    c = Misptr[k][Cluster];
    c<0?c=0:c;

    Dam = c * Weapon[i].Damage;

        textprintf(screen,font,x+280,y,col," %d Damage Hit \n",Dam);
        l = getFacing(getDamageAngle(Vector,Vector));

        DamageHex( Target.x ,Target.y,Dam);
//        DamageHex( 8 ,4,5);

  } // End if
    else {
    if (Weapon[i].Locking == On);
    else AmmoState(Weapon[i].AmmoType, 1);

    Pilot.TargetPenalty = 1; // If a weapon is fired, multiple target penalty
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Miss\n",r,Flag[i], Weapon[i].Name,Weapon[i].Damage);

    }

    y+=8;

  } // End for


getkey();
vsync();
blit    (block,screen,0,0, 50,120,550,250);
destroy_bitmap(block);
return 0;
}

int Elemental::ResolveWeaponFire() {

int Target;
int i,j;
int x = 60;
int y = 130;
int WeapUsed = 0;
//int Angle;
char String[80];

BITMAP *block;

if (Options.SimultaneousWeaponFire == Off) return 0;

block = create_bitmap(550,250);

blit    (screen,block, 50,120,0,0,550,250);

  if (Options.ShowWeaponFire == On)
  for (i=0;i<Weapons;i++)
    if (WeaponTarget[i] != -1) {
      Target = WeaponTarget[i];
      ShowWeaponFire(i,unit[Target]);
      WeapUsed ++;
      }

if (WeapUsed > 0) {
  vsync();
  rectfill(screen, 50,120,550,360,Window.BGColour);
  }
  else return 1;
  unit[Index]->Hidden=On;

  for (i=0;i<Weapons;i++)
    if (WeaponTarget[i] != -1) {
      Target = WeaponTarget[i];
      sprintf(String,"%s fires on enemy %s",unit[Index]->Name,unit[Target]->Name);
      putString(String,Colour);
//      Flag[i] = 0;
//      Angle = getAttackAngle(Vector,unit[Target]->Vector);
//      genToHit(*unit[Target]); // Sets Flag as the To Hit
//      WeaponSelect(getAttackAngle(Vector,unit[Target]->Vector)-Turret);

      unit[Target]->Hidden=On;
      y=unit[Target]->ResolveWeapon(unit[Index],i,x,y);
      unit[Target]->Hidden=Off;
//      y += 8;
      }

  unit[Index]->Hidden=Off;

if (WeapUsed > 0) {
  getkey();
  vsync();
  blit    (block,screen,0,0, 50,120,550,250);
  destroy_bitmap(block);
  }
ScrollLock = On;

  for (i=0;i<Weapons;i++)
    if (WeaponTarget[i] != -1) {
      Target = WeaponTarget[i];
      drawHex (unit[Target]->Vector.x,unit[Target]->Vector.y);
      unit[Target]->drawUnit(0);
      }

  if (Options.TwentyPointFalls == On)
    if (TurnDamage >= 20) // Mech may fall if it takes 20 pts of Damage
      if (roll2d6 < genPilotModifier())
        Fall(Position);

return 0;
}

int Elemental::ResolveWeapon(class Unit *Attacker, int ActiveWeapon, int x, int y) {
int i,j,k,r,d,l,c,a;
int MisHit; // # of Missiles that actually Connect
int col=Window.TextColour;
int PartialCover;
int Dam,DamageCluster,Cluster;
char bString[40];

sprintf(bString,"Missiles");

ScrollLock = Off;

PartialCover = ProcCover(LOSstring,Attacker->Altitude,Attacker->Position+1,Altitude,Position+1);
i = ActiveWeapon;
//for (i=0;i<Attacker->Weapons;i++) {
    r = GunneryRoll;
  if (Attacker->AmmoState(Attacker->Weapon[i].AmmoType,0) < Attacker->Weapon[i].AmmoConsumption )
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d Ammo Depleted\n",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  if (Options.WeaponJams == On && Weapon[i].Jams == 1 && r <= Weapon[i].JamMod+(Weapon[i].RateOfFire/2))
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d Weapon Jams\n",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Attacker->Flag[i] == 0)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d OFFLINE\n",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Attacker->Flag[i] == 127)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Used\n",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Attacker->Flag[i] > 12)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Target ERROR - Shot Aborted\n",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Attacker->Flag[i] <= r) {
  Attacker->Pilot.TargetPenalty = 1; // If a weapon is fired, multiple target penalty

    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Hit",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage);
    Attacker->AmmoState(Attacker->Weapon[i].AmmoType, Attacker->Weapon[i].RateOfFire);

  HeatTurn += Attacker->Weapon[i].TargetHeat;
  Infernos += Attacker->Weapon[i].Persistence; // Inferno
  k = Attacker->Weapon[i].Missiles*Attacker->Weapon[i].RateOfFire;

  if (Options.GlancingHits == On && Attacker->Flag[i] == r)
    Cluster = -2; // Glancing Hit
  else Cluster = 0;
  if (Options.MissileBonus == On) Cluster += r - Attacker->Flag[i];

  Cluster =  roll2d6 + Attacker->Weapon[i].Cluster + Cluster; // Artemis etc.
  Cluster<0?Cluster=0:Cluster>12?Cluster=12:Cluster;// Bind Cluster

    c = Misptr[k][Cluster];
//    c<1?c=1:c;

    c<0?c=0:c;

    Dam = c * (Attacker->Weapon[i].Damage + rollxd6(Attacker->Weapon[i].InfantryDamage));
    DamageCluster = Attacker->Weapon[i].DamageCluster;

  if (Dam == DamageCluster) { // One Hit / Med/Laser
        l = getFacing(getDamageAngle(Attacker->Vector,Vector));
            
        if (Options.GlancingHits == On && Attacker->Flag[i] == r)
  	  Damage(0, l,(Dam)/2); // Glancing Hit
        else
  	  Damage(0, l, Dam );
//        y+=8;
//        textprintf(screen,font,x,y,col,"Hits %s\n",LocationName[k+1]);
      }
  else {
        l = getFacing(getDamageAngle(Attacker->Vector,Vector));

      for (k=0;k<Dam;k+=DamageCluster)
        Damage( 0 ,l,DamageCluster);
      if (Dam%DamageCluster>0)
        Damage( 0 ,l,Dam%DamageCluster);

       } // End if
  }
    else {
//      Attacker->AmmoState(Attacker->Weapon[i].AmmoType,1);
    if (Attacker->Weapon[i].Locking == On);
    else Attacker->AmmoState(Attacker->Weapon[i].AmmoType, 1);

    Attacker->Pilot.TargetPenalty = 1; // If a weapon is fired, multiple target penalty
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Miss\n",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage);

    if (Map.Hex[Vector.x][Vector.y].Type=='t'||Map.Hex[Vector.x][Vector.y].Type=='T')
      if (roll2d6 <= 3)
        CreateFire(Vector.x,Vector.y);
    }
//  }
    y+=8;
  
return y;
}

int Elemental::LegAttack() {
int i,Target;
int Loc, ToHit = 15;
char String[40];

for (i=0;i<Units;i++)
  if (Vector.x == unit[i]->Vector.x && Vector.y == unit[i]->Vector.y)
    if (Side != unit[i]->Side && unit[i]->Type == MECH && unit[i]->Carrying == -1)
      Target = i;

if (Men >= 1) ToHit =  8+genToHit(*unit[Target]);
if (Men >= 2) ToHit =  6+genToHit(*unit[Target]);
if (Men >= 3) ToHit =  3+genToHit(*unit[Target]);
if (Men >= 4) ToHit =    genToHit(*unit[Target]);

if (ToHit > 12) return 0;
if (roll2d6 > ToHit) { // Attack Succeds
  if (unit[Target]->m->Struct[RL] <= 0) Loc = LL;
  if (unit[Target]->m->Struct[LL] <= 0) Loc = RL;
  if (unit[Target]->m->Struct[RL] > 0 && unit[Target]->m->Struct[LL] > 0)
    if (rolld6 > 3) Loc = RL;
    else Loc = LL;

  i=unit[Target]->m->Critical(Loc,0);
  if (i == 0) unit[Target]->m->Damage(Loc,0,4);
  sprintf(String,"Leg Attack Succeds!");
  putString(String,Colour);
  getkey();
  }
  else {
  sprintf(String,"Leg Attack Fails");
  putString(String,Colour);
  getkey();
  }

return RETURNNULL;
}

int Elemental::Swarm() {

int Cluster, k, c, d, Dam;
int i,Target;
int Loc, ToHit = 15;
char String[40];

for (i=0;i<Units;i++)
  if (Vector.x == unit[i]->Vector.x && Vector.y == unit[i]->Vector.y)
    if (Side != unit[i]->Side && unit[i]->Type == MECH && unit[i]->Carrying == -1)
      Target = i;

if (Men >= 1) ToHit = 6+genToHit(*unit[Target]);
if (Men >= 4) ToHit = 3+genToHit(*unit[Target]);

if (ToHit > 12) return 0;
if (roll2d6 > ToHit) { // Attack Succeds

  Mounted = Target;
  unit[Target]->Carrying = Index;
  Immobile = On;

  sprintf(String,"Swarm Attack Succeds!");
  putString(String,Colour);
  getkey();

  }
  else {
  sprintf(String,"Swarm Attack Fails");
  putString(String,Colour);
  getkey();
  }
  
return RETURNNULL;
}

int Elemental::SwarmDamage() {
int i,c,d,k,Dam;

for (i=0;i<Weapons;i++) Flag[i] = 2;

WeaponSelect(0,Mounted);

for (i=0;i<Weapons;i++)
  if (Flag[i] == 2) {

  k = Weapon[i].Missiles*Weapon[i].FireMode;

  c = k;
  c<0?c=0:c;

  Dam = c * Weapon[i].Damage;

  for (k=0;k<Dam;k+=Weapon[i].DamageCluster) {
    d = SwarmLoc[roll2d6];
    unit[Mounted]->Damage(d,0,Weapon[i].DamageCluster);
    unit[Mounted]->Critical(d,0);
    }

  if (Dam%Weapon[i].DamageCluster > 0)
    d = SwarmLoc[roll2d6],
    unit[Mounted]->Damage(d,0,Dam%Weapon[i].DamageCluster),
    unit[Mounted]->Critical(d,0);
  }

return 0;
}

int Elemental::getMen() {
int i,j;
Men = 0;
for (i=0;i<10;i++)
  if (Armour[i] > 0) Men ++;
  else {
  for (j=i;j<9;j++)
    Armour[i] = Armour[i+1];
    Armour[9] = 0;
  }

// Reduce the amount of fusiliers
for (i=0;i<Weapons;i++)
  Weapon[i].RateOfFire = Men;

return Men;
}

int Elemental::SetPosition()
{
int mpc;
int i, o, k;
int x,y,Move = On, dam;
int BuildingHeight = 0;
int BuildingModifier = 0;

x = Vector.x;
y = Vector.y;

// if (AdvanceOpen())
// AdvanceOpen
int UnitsInHex=0;
for (i=0;i<Units;i++)
  if ( (x == unit[i]->Vector.x && \
        y == unit[i]->Vector.y ) ) {
        UnitsInHex ++;
        if (Options.Stacking==On) {
//          if (unit[i]->Side!=Side)
//   	    Move = Off; // Can't stack with an enemy on the ground
//          else {
            if (Stacked == Off)
              LastVector = Vector;              
            Stacked = On;
            }
        }

// Max Units in hex
//if (UnitsInHex >= 5) Move = Off, Stacked = Off;

  // Hex Open, Unit can Advance
/*
if (x<Xmin || x >= Xmax) // Mech Out Off bounds
  {Move = Off;MP = 0;
  if(Options.Retreat==On) Retreat(0); }

if (y<Ymin || y >= Ymax) // Mech Out Off bounds
  {Move = Off;MP = 0;
  if(Options.Retreat==On) Retreat(0); }
*/
  if(MoveType<0) // If a Mech is Jumping, can't Jump over obstacle
    if(Altitude+Jump < MPH[Map.Hex[x][y].Alt])
      Move = Off;

// Buildings
/*
  if (Map.Hex[x][y].Type == 'L') BuildingModifier = 1, BuildingHeight = 1;
  if (Map.Hex[x][y].Type == 'M') BuildingModifier = 2, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'H') BuildingModifier = 3, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'A') BuildingModifier = 5, BuildingHeight = 3;

  if (BuildingModifier != 0 && MoveType >= 0) // Buildings on Foot
    if (PilotingRoll >= genPilotModifier()+BuildingModifier) {
      Move = On;
        if (Tons > Map.Hex[x][y].Index) DamageHex(x,y,Map.Hex[x][y].Index), BuildingHeight = 0;}
      else Move = Off;
*/
  if (Position+1 <= - MPH[Map.Hex[Vector.x][Vector.y].Alt] && Map.Hex[Vector.x][Vector.y].Type == 'w') Move = Off;
//    else Submersed = Off;

  if (MPC[Map.Hex[x][y].Type] == 20 && MoveType>=0) // Impassable by Foot
    Move=Off;
  if (Map.Hex[x][y].Fire == 'f' || Map.Hex[x][y].Fire == 'F')
    Move=Off;

  mpc = MPC[Map.Hex[x][y].Type];
  if (onRiver(x,y)) mpc ++;
  if (onRoad(Vector.x,Vector.y) && onRoad(x,y))
    mpc = 1, BuildingHeight = (RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt])>=0?(RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt]):0;

  if (Map.Hex[x][y].Type == 'L') mpc = 1;
  if (Map.Hex[x][y].Type == 'M') mpc = 1;
  if (Map.Hex[x][y].Type == 'H') mpc = 1;
  if (Map.Hex[x][y].Type == 'A') mpc = 1;

//  mpc += abs(MPH[Map.Hex[Vector.x][Vector.y].Alt] - MPH[Map.Hex[x][y].Alt]);
  mpc += 2*abs(Altitude - MPH[Map.Hex[x][y].Alt]-BuildingHeight);

  MoveType< 0?mpc =1:mpc; // If a Mech is Jumping, only one MP / HEX

//  Submersed==On?mpc+=4:mpc; // If Mech under water

  Altitude = MPH[Map.Hex[x][y].Alt] + BuildingHeight;
//      HeatTurn += 2;

  if (UnitsInHex == 0)
    if (Stacked == On)
      Stacked = Off;

return Move;
}

int Elemental::Retreat() {
drawHex (Vector.x,Vector.y);
Vector.x = -1;
Vector.y = -1;
Status   = Off;
drawUnits();
return 0;
}

int Elemental::AmmoState(int AmmoType, int Ammount) {
int i=0,j,k = 0;

if (Ammount >= 1) Ammount = 1;

if (Options.AmmoConsumption == Off) return 1;

while (i <= Ammunitions) { // Will always consume top ammo first
  if (Ammo[i].AmmoType == AmmoType) { // Will always consume top ammo first
//    k = 0;
    if (k == 0) {
    Ammo[i].Ammo -= Ammount;
    if (Ammo[i].Ammo < 0) Ammo[i].Ammo = 0;
    }
    k += Ammo[i].Ammo;
    }
//textprintf(screen,font,300,50+i*10,0,"%d %d %d %d",i,k,Type,Ammo[i].AmmoType);
  i++;
  }

return k;
}

int Elemental::Drop(int Dam) {
// Elemental Drops off mech
  if (Mounted >= 0)
    unit[Mounted]->Carrying = -1;
  Mounted = -1;
  Immobile = Off;
  Used = On;

  Damage(0,0,Dam);

return Dam;
}

int Elemental::MouseMove(int Mode) {
int  x,y;

  x=mouse_x-globalx; y=mouse_y-globaly;
  x-=(y/HexHeight & 0x0001) * HexWidth; // Improved
  x/=HexWidth;       y/=HexHeight;
  x &= 0xFFFE;
  x += y & 0x0001;
  x += scrollx;
  y += scrolly;

if (Mode == 1)
  Viper (u,x,y,MP,-1);
if (Mode == 0)
  MilkSnake (u,x,y,MP,-1);

return 0;
}
