/////////////////////////////////////////////////////////////////////////////
// AI Reaction Phase
// AI Weapon Phase
// AI Weapon Select
// AI Physical Phase
//
//

#define         ROCK            0
#define         PILUM           1
#define         JAVELIN         2
#define         SHURIKEN        3


int Mech::AIReactionPhase() {
char ch=0;
int Angle;
int Target;

char String[50];
sprintf(String,"AI %s reacts",Name);
putString(String,Colour);
rest(ReactTime);

    Turret = 0;

    Target = Mission[Index].Target;
    Angle = getAttackAngle(Vector,unit[Target]->Vector);

    if (Angle >  60) Turret =  60;
    if (Angle < -60) Turret = -60;
    
return 0;
}

int Mech::AIWeaponPhase() {
//char String[60];
int Angle;
//class Unit *Target;
int i;
int Target;

char String[50];
sprintf(String,"AI %s Targets",Name);
putString(String,Colour);
rest(WeaponTime);

    Target = Mission[Index].Target;

    if (Target != -1) {
      sprintf(String,"Target : [%s]",unit[Target]->Name);
      putString(String,Colour);
      rest(WeaponTime);
      genToHit(*unit[Target]); // Sets Flag as the To Hit
//      Rock(AI,Angle);
      Angle = getAttackAngle(Vector,unit[Target]->Vector);
//      Pilum(m,Angle-Turret);
//      Javelin(m,Angle-Turret);
      AIWeaponSelect(Angle);
//      SetWeaponTarget(unit[Mission[Index].Target]);
      SetWeaponTarget(unit[Target]);

      if (Options.SimultaneousWeaponFire == Off) {
      if (Options.ShowWeaponFire == On)
        for (i=0;i<Weapons;i++)
          if (WeaponTarget[i] != -1) {
//            Target = WeaponTarget[i];
//            ShowWeaponFire(i,unit[Target]);
            ShowWeaponFire(i,unit[WeaponTarget[i]]);
            }

        unit[Target]->Hidden=On;
        unit[Target]->ResolveWeapons(unit[Index]);
        unit[Target]->Hidden=Off;

        drawHex (unit[Target]->Vector.x,unit[Target]->Vector.y);
        unit[Target]->drawUnit(0);
        }
      }

//getkey();
return 0;
}

int  Mech::AIWeaponSelect(int Angle) {
int  Number;
int  i,l;
int  MaxHeat;
int  Hit[20];
int  AngleLoc[20];

// LegMounted Weapons have a different arc
for (i=0;i<Weapons;i++) {
  if (Weapon[i].Loc == RL || Weapon[i].Loc == LL)
    AngleLoc[i] = Angle+Turret;
  else AngleLoc[i] = Angle;

  // Flip Arms
  if (Weapon[i].Loc == RA || Weapon[i].Loc == LA)
    if (RightArm.Length == 2 && RightArm.Length == 2) {
      if (Angle >  120)
        AngleLoc[i] = Angle - 120;
      if (Angle < -120)
        AngleLoc[i] = Angle + 120;
        }

  }


if (HeatSinkType == 0)
  HeatDisp = HeatSinks;
else
  HeatDisp = HeatSinks*2;
  HeatDisp = 40;

for (i=0;i<Weapons;i++)
  Hit[i] = Flag[i];

AlphaFlag = 0;

for (i=0;i<Weapons;i++)
  Flag[i] = AlphaFlag;// * Weapon[i].Status;

    AlphaFlag = 1; // Fire All Posible Weapons

    for (i=0;i<Weapons;i++) {
      if ( Hit[i]<=12 && Weapon[i].State==1 &&  //((LeftArc[Weapon[i].Loc]<=Angle && RightArc[Weapon[i].Loc]>=Angle) || \
//       ( (LeftArc[Weapon[i].Loc]>=Angle &&-RightArc[Weapon[i].Loc]<=Angle) || (-LeftArc[Weapon[i].Loc]<=Angle && RightArc[Weapon[i].Loc]>=Angle) )))
        ((LeftArc[Weapon[i].Loc] <= AngleLoc[i] && RightArc[Weapon[i].Loc] >= AngleLoc[i]) ^ \
     (180-LeftArc[Weapon[i].Loc] <= abs(AngleLoc[i])))                                      )
          Flag[i] = AlphaFlag;
	else Flag[i] = 0;
//      textprintf(screen,font,50,50+i*16,EGAColour[7],"%d %d\n",Flag[i],Hit[i]);
      }
//getkey();

//                      0  1  2  3  4  5  6  7  8  9 10 11 12
//                      0  0  1  2  3  4  5  6  5  4  3  2  1
int Probability[14] = {36,36,36,35,33,30,26,21,15,10, 6, 3, 1, 0x0000};
int cur,WeaponsUsed = 0;
double val[20],max;

// AI 2 ***********************************
//int AIWeapLevel = 1;
//switch (AIWeapLevel) {
switch (Pilot.AILevel) {
case ROCK:
MaxHeat = HeatDisp + 10;
      
  for (i=0;i<Weapons;i++)
    val[i] = Flag[i] * Weapon[i].State;
    ;break;
case PILUM:
// Pilum
MaxHeat = HeatDisp + 5;
      
  for (i=0;i<Weapons;i++)
    val[i] = (Probability[Hit[i]] / 36.0) * Flag[i] * Weapon[i].State;
//    val[i] = Probability[Hit[i]] / 36.0 * (Weapon[i].Damage*(Weapon[i].Missiles+1)/2)/(Weapon[i].Heat) * Weapon[i].State;
    ;break;
case JAVELIN:
// Javelin
MaxHeat = HeatDisp - abs(MoveType) + (MoveType==-1)?(HexesMoved<3?2:0):0;
      
  for (i=0;i<Weapons;i++)
    if (Weapon[i].State == On)
      val[i] = (Probability[Hit[i]] / 36.0) * (Weapon[i].Damage)/(Weapon[i].Heat+1);
      ;break;
case SHURIKEN:
// Shuriken
MaxHeat = HeatDisp - abs(MoveType) + (MoveType==-1)?(HexesMoved<3?2:0):0;

    for (i=0;i<Weapons;i++) {
      val[i] = (Probability[Hit[i]] / 36.0) * (Weapon[i].Damage)/(Weapon[i].Heat+1) * Weapon[i].State * Flag[i];
      val[i] *= ((Weapon[i].Type==2||Weapon[i].Type==3)&&val[i]<=.32)?0:1; // Doesn't waste ammunition
      }
      ;break;

default:;break;
}

    for (i=0;i<Weapons;i++)
      Flag[i] = Off;

    while (MaxHeat > 0 && WeaponsUsed != Weapons) {
      max = 0;
      cur = 16;
      for (i=0;i<Weapons;i++)
        if (val[i] > max)
          cur = i,max = val[i];

        val[cur] = 0;
        Flag[cur] = On;
        WeaponsUsed ++;
        MaxHeat -= Weapon[i].Heat;
      }


// && Hit[i] <= 12
/// End Set Weapons
for (i=0;i<Weapons;i++)
  if (Weapon[i].State == On && Flag[i] == On)
    Flag[i] = Hit[i]; else Flag[i] = 0;

return 0;
}

/////////////////////////////////////////////////////////////////////////////
// Physical Phase
//
//
//

int Mech::AIPhysicalPhase() {
char String[50];

int RightPunchFlag=0, LeftPunchFlag = 0, KickFlag=0, PushFlag=0, ChargeFlag=0,LeftHatchetFlag=0,RightHatchetFlag=0; // Default OFF
int TargetsInRange = 0;

int Target;
int TargetValue = 0;
int Val;
int Angle;
int AltDiff;
int Reach = (RightArm.Length==5||LeftArm.Length==5)?1:0; // 2 if Hatchet or Club
int Range,Modifier,ToHit;

int i;
char ch=0;

int PunchDamage = Tons/10;
int KickDamage  = Tons/5;
int ChargeDamage=(Tons*HexesMoved)/10;

for (i=0;i<Units;i++) {
  Angle = getAttackAngle(Vector,unit[i]->Vector);
  Range = doLos(Vector.x,Vector.y,unit[i]->Vector.x,unit[i]->Vector.y);
  AltDiff = (Altitude+(Position)) - (unit[i]->Altitude+(unit[i]->Position));
  if (unit[i]->Side!=Side && Range == 1 && Angle <=60 && Angle >=-60 && (AltDiff>=-1 && AltDiff<=Reach)) {
    TargetsInRange ++;
      if (AltDiff == 0 || AltDiff == unit[i]->Position) // 1 for BattleMechs, 0 for Vehicles
        KickFlag = 1;
      if (AltDiff == 0 || AltDiff ==-unit[i]->Position || AltDiff == -(unit[i]->Position+Reach)) { // 1 for BattleMechs, 0 for Vehicles
        RightPunchFlag = 1; LeftPunchFlag = 1;
      if (abs(Angle) <= 5) PushFlag = 1, ChargeFlag = 1; // If Target Straight Ahead
        }
    }

  }

if (doLos(Vector.x,Vector.y,unit[Mission[Index].Target]->Vector.x,unit[Mission[Index].Target]->Vector.y) != 1) return 1;


if (TargetsInRange < 1) {
  if (Options.HighLight == On)
    drawLowLight(Vector.x,Vector.y);
      return 1;
      }

  Cursor.x = Vector.x;   Cursor.y = Vector.y;
  if (LeftLeg.Hip       == Off || RightLeg.Hip       == Off) KickFlag = 0;

if (Position != STANDING) {
  ChargeFlag = 0;
  PushFlag = 0;
  KickFlag = 0;
  RightPunchFlag = 0;
  LeftPunchFlag = 0;
  RightHatchetFlag = 0;
  LeftHatchetFlag = 0;
  if (Struct[RA] > 0 && Struct[LA] > 0) RightPunchFlag = 1;
  }
if (Reversed != 0) ChargeFlag = 0;

//if (Options.PhysAttacks == On) TargetsInRange = 1; // Allowed to attack buildings

// Unit cannot punch if arm mounted weapons have fired
// Unit cannot kick  if leg mounted weapons have fired
// Unit cannot push  if any arm weapons have fired
// Unit cannot charge if any weapons have fired

  CentreMap(Vector.x,Vector.y);
  if (Options.HighLight == On)
    drawHighLight(Vector.x,Vector.y);

for (i=0;i<Weapons;i++)
  if (Flag[i] > 1 && Flag[i] <= 12 || Flag[i] == 127) {
    if (Weapon[i].Loc == RA || Struct[RA] == 0 ) RightPunchFlag = 0, PushFlag = 0;
    if (Weapon[i].Loc == LA || Struct[LA] == 0 ) LeftPunchFlag  = 0, PushFlag = 0;
    if (Weapon[i].Loc == RL || Struct[RL] == 0 ) KickFlag = 0;
    if (Weapon[i].Loc == LL || Struct[LL] == 0 ) KickFlag = 0;
    ChargeFlag = 0;
    }

  if (RightPunchFlag == 1 && RightArm.Length == 5)
    RightHatchetFlag = 1, RightPunchFlag = 0;
  if (LeftPunchFlag  == 1 && LeftArm.Length  == 5)
    LeftHatchetFlag  = 1, LeftPunchFlag  = 0;

  if (RightPunchFlag == 0 && LeftPunchFlag == 0 && KickFlag == 0)
    ch = 127;

// Select Target
//  Target = SelectTarget(*u);

  if (Options.HighLight == On)
    drawLowLight(Vector.x,Vector.y);

Val = 0;
for (i=0;i<Units;i++) { // Select Target and Attack
  Angle = getAttackAngle(Vector,unit[i]->Vector);
  Range = doLos(Vector.x,Vector.y,unit[i]->Vector.x,unit[i]->Vector.y);
  AltDiff = (Altitude+(Position)) - (unit[i]->Altitude+(unit[i]->Position));
  TargetValue = 0;
  if (unit[i]->Side!=Side && Range == 1 && Angle <=60 && Angle >=-60 && (AltDiff>=-1 && AltDiff<=Reach)) {
    TargetsInRange ++;

      if (AltDiff == 0 || AltDiff ==-unit[i]->Position || AltDiff == -(unit[i]->Position+Reach)) { // 1 for BattleMechs, 0 for Vehicles
        if (ChargeFlag     == On) TargetValue += ChargeDamage; // Weigh different Phys attack options
        if (RightPunchFlag == On) TargetValue += PunchDamage;
        if (LeftPunchFlag  == On) TargetValue += PunchDamage;
        if (RightHatchetFlag==On) TargetValue += 2*PunchDamage;
        if (LeftHatchetFlag ==On) TargetValue += 2*PunchDamage;
        }

      if (AltDiff == 0 || AltDiff == unit[i]->Position) // 1 for BattleMechs, 0 for Vehicles
        if (KickFlag       == On) TargetValue += KickDamage-(PunchDamage/2);
        
        if (TargetValue > Val) {
          Target = i; // Select Physical Target
          Val = TargetValue;
            }
       }
  }
// Physical Preference - Double Punch / Kick / Punch

  if (ChargeFlag == 1) {
    Charge(unit[Target]);
    RightPunchFlag = 0;
    LeftPunchFlag  = 0;
    KickFlag       = 0;
    }

  if (RightHatchetFlag == 1) {
    Club(unit[Target],RightHatchetType,RA);
    KickFlag       = 0;
    }

  if (LeftHatchetFlag == 1) {
    Club(unit[Target],LeftHatchetType,LA);
    KickFlag       = 0;
    }
    
  if (RightPunchFlag == 1 && LeftPunchFlag == 1 && Holding != -1) {
    Club(unit[Target],Holding,0);
    RightPunchFlag = 0;
    LeftPunchFlag  = 0;
    KickFlag       = 0;
    }

  if (RightPunchFlag == 1) {
    Punch(unit[Target],RA);
    KickFlag       = 0;
    }

  if (LeftPunchFlag == 1) {
    Punch(unit[Target],LA);
    KickFlag       = 0;
    }

  if (KickFlag == 1)
    Kick(unit[Target]);

return 0;
}
