/*
typedef struct WeaponData {
char Type;  // SMLS / MDLS
int  Loc ;
int  Ammo;  // -1 Energy
int  Damage;
char Status;
};

typedef struct MechCriticals {
char Class;  // Engine / Actuators / Weapons / Ammo
char Type;   // SMLS / MDLS .. etc
char Size;
char Status;  // 0 = OnLine, 1 .. 8 OffLine
};
*/
//char isDigit(char input);
long ConvertString(char *string);
/*
int readString(char *String, FILE *ReadFile)
{
char ch = 0;
int  i = 0;
while (ch != 10 && ch != 13) {
  ch = fgetc(ReadFile);
  String[i] = ch;
  i++;
  }

  String[i-1] = 0;
return i;
}
*/
int readCrit(char *String);

int Nulls = 4, Weaps = 122, Acts = 14, Equips = 10, Ammunits = 38, Continues = 41;

char *Null []   = {
			"Empty",
			"Ferro Fibre      ",
			"Endo Steel       ",
			"TSM",
			0x0000 };

char *NullShort []   = {
			"Empty",
			"Ferro Fibre",
			"Endo Steel",
			"TSM",
			0x0000 };

char *Actuator []   = {
			"Shoulder",
			"Upper Arm",
			"Lower Arm",
			"Hand",
			"Hip",
			"Upper Leg",
			"Lower Leg",
			"Foot",
			"Engine",
			"Gyro",
			"Life Support",
			"CockPit",
			"Sensors",
			"XL Engine",
			0x0000
			};

char *ActLong  []   = {
			"Shoulder         ",
			"Upper Arm        ",
			"Lower Arm        ",
			"Hand             ",
			"Hip              ",
			"Upper Leg        ",
			"Lower Leg        ",
			"Foot             ",
			"Engine           ",
			"Gyro             ",
			"Life Support     ",
			"CockPit          ",
			"Sensors          ",
			"XL Engine        ",
			0x0000
			};

char *Equipment[] = {
			"Heat Sink        ",
			"Jump Jet         ",
			"CASE             ",
			"Artemis IV FCS   ",
			"Hatchet          ",
			"Targeting Compute",
			"ECM Suite        ",
			"Active Probe     ",
			"Anti-Personnel Po",
			"MASC             ",
			"OverFlow         ",
			0x0000
			} ;

char *ShortEquipment[] = {
			"Heat Sink",
			"Jump Jet",
			"CASE",
			"Artemis IV FCS",
			"Hatchet",
			"Targeting Compute",
			"ECM Suite",
			"Active Probe",
			"Anti-Personnel Po",
			"MASC",
			"OverFlow",
			0x0000
			} ;

char *Weap[] = {
"Flamer           ",
"Large Laser      ",
"Medium Laser     ",
"Small Laser      ",
"PPC              ",
"Auto Cannon/2    ",
"Auto Cannon/5    ",
"Auto Cannon/10   ",
"Auto Cannon/20   ",
"Machine Gun      ",
"LRM-5            ",
"LRM-10           ",
"LRM-15           ",
"LRM-20           ",
"SRM-2            ",
"SRM-4            ",
"SRM-6            ",
"ER Large Laser   ",
"ER Medium Laser  ",
"ER Small Laser   ",
"ER PPC           ",
"Pulse Large Laser",
"Pulse Med Laser  ",
"Pulse Small Laser",
"Anti-Missile Syst",
"Vehicle Flamer   ",
"Heavy Gauss Rifle",
"Gauss Rifle      ",
"Light Gauss Rifle",
"LB 2-X AC        ",
"LB 5-X AC        ",
"LB 10-X AC       ",
"LB 20-X AC       ",
"Rotary AC/2      ",
"Rotary AC/5      ",
"Rotary AC/10     ",
"Rotary AC/20     ",
"Ultra AC/2       ",
"Ultra AC/5       ",
"Ultra AC/10      ",
"Ultra AC/20      ",
"Narc Beacon      ",
"iNarc Beacon     ",
"MRM-10           ",
"MRM-20           ",
"MRM-30           ",
"MRM-40           ",
"RocketLauncher-10",
"RocketLauncher-15",
"RocketLauncher-20",
"Streak SRM-2     ",
"Streak SRM-4     ",
"Streak SRM-6     ",

"Arrow IV      ",
"Long Tom      ",
"Sniper        ",
"Thumper       ",
"Laser AMS     ",
"X-Pulse Large Laser",
"X-Pulse Medium Laser",
"X-Pulse Small Laser",
"Grenade Launcher",
"Heavy Flamer  ",
"Light AutoCannon/2",
"Light AutoCannon/5",
"Light AutoCannon/10",
"Light AutoCannon/20",
"Long Tom Cannon",
"Sniper Cannon ",
"Thumper Cannon",
"ThunderBolt 5 ",
"ThunderBolt 10",
"ThunderBolt 15",
"ThunderBolt 20",

"Hyper Velocity AC/2",
"Hyper Velocity AC/5",
"Hyper Velocity AC/10",
"Hyper Velocity AC/20",
"iHeavy Gauss Rifle",
"iLight Gauss Rifle",

"ER PPC           ",
"ER Large Laser   ",
"ER Medium Laser  ",
"ER Small Laser   ",
"ER Micro Laser   ",
"Pulse Large Laser",
"Pulse Med Laser  ",
"Pulse Small Laser",
"Pulse Micro Laser",
"Heavy Large Laser",
"Heavy Med Laser  ",
"Heavy Small Laser",
"Flamer           ",
"Anti-Missile Sys ",
"Vehicle Flamer   ",
"Gauss Rifle      ",
"LB 2-X AC        ",
"LB 5-X AC        ",
"LB 10-X AC       ",
"LB 20-X AC       ",
"Ultra AC/2       ",
"Ultra AC/5       ",
"Ultra AC/10      ",
"Ultra AC/20      ",
"Machine Gun      ",
"Heavy Machine Gun",
"Light Machine Gun",
"NARC             ",
"ATM-3            ",
"ATM-6            ",
"ATM-9            ",
"ATM-12           ",
"LRM-5            ",
"LRM-10           ",
"LRM-15           ",
"LRM-20           ",
"SRM-2            ",
"SRM-4            ",
"SRM-6            ",
"Streak SRM-2     ",
"Streak SRM-4     ",
"Streak SRM-6     ",

0x0000
};

char *ShortWeap[] = {
"Flamer",
"Large Laser",
"Medium Laser",
"Small Laser",
"PPC",
"Auto Cannon/2",
"Auto Cannon/5",
"Auto Cannon/10",
"Auto Cannon/20",
"Machine Gun",
"LRM-5",
"LRM-10",
"LRM-15",
"LRM-20",
"SRM-2",
"SRM-4",
"SRM-6",
"ER Large Laser",
"ER Medium Laser",
"ER Small Laser",
"ER PPC",
"Pulse Large Laser",
"Pulse Med Laser",
"Pulse Small Laser",
"Anti-Missile Syst",
"Vehicle Flamer",
"Heavy Gauss Rifle",
"Gauss Rifle",
"Light Gauss Rifle",
"LB 2-X AC",
"LB 5-X AC",
"LB 10-X AC",
"LB 20-X AC",
"Rotary AC/2",
"Rotary AC/5",
"Rotary AC/10",
"Rotary AC/20",
"Ultra AC/2",
"Ultra AC/5",
"Ultra AC/10",
"Ultra AC/20",
"Narc Beacon",
"iNarc Beacon",
"MRM-10",
"MRM-20",
"MRM-30",
"MRM-40",
"RocketLauncher-10",
"RocketLauncher-15",
"RocketLauncher-20",
"Streak SRM-2",
"Streak SRM-4",
"Streak SRM-6",

"Arrow IV      ",
"Long Tom      ",
"Sniper        ",
"Thumper       ",
"Laser AMS     ",
"X-Pulse Large Laser",
"X-Pulse Medium Laser",
"X-Pulse Small Laser",
"Grenade Launcher",
"Heavy Flamer  ",
"Light AutoCannon/2",
"Light AutoCannon/5",
"Light AutoCannon/10",
"Light AutoCannon/20",
"Long Tom Cannon",
"Sniper Cannon ",
"Thumper Cannon",
"ThunderBolt 5 ",
"ThunderBolt 10",
"ThunderBolt 15",
"ThunderBolt 20",

"Hyper Velocity AC/2",
"Hyper Velocity AC/5",
"Hyper Velocity AC/10",
"Hyper Velocity AC/20",
"iHeavy Gauss Rifle",
"iLight Gauss Rifle",

"ER PPC",
"ER Large Laser",
"ER Medium Laser",
"ER Small Laser",
"ER Micro Laser",
"Pulse Large Laser",
"Pulse Med Laser",
"Pulse Small Laser",
"Pulse Micro Laser",
"Heavy Large Laser",
"Heavy Med Laser",
"Heavy Small Laser",
"Flamer",
"Anti-Missile Sys",
"Vehicle Flamer",
"Gauss Rifle",
"LB 2-X AC",
"LB 5-X AC",
"LB 10-X AC",
"LB 20-X AC",
"Ultra AC/2",
"Ultra AC/5",
"Ultra AC/10",
"Ultra AC/20",
"Machine Gun",
"Heavy Machine Gun",
"Light Machine Gun",
"NARC",
"ATM-3",
"ATM-6",
"ATM-9",
"ATM-12",
"LRM-5",
"LRM-10",
"LRM-15",
"LRM-20",
"SRM-2",
"SRM-4",
"SRM-6",
"Streak SRM-2",
"Streak SRM-4",
"Streak SRM-6",

0x0000
};

char *RearWeap[] = {
"Flamer           ",
"Large Laser      ",
"(R) Medium Laser",
"Small Laser      ",
"PPC              ",
"Auto Cannon/2    ",
"Auto Cannon/5    ",
"Auto Cannon/10   ",
"Auto Cannon/20   ",
"Machine Gun      ",
"LRM-5            ",
"LRM-10           ",
"LRM-15           ",
"LRM-20           ",
"SRM-2            ",
"SRM-4            ",
"SRM-6            ",
"ER Large Laser   ",
"ER Medium Laser  ",
"ER Small Laser   ",
"ER PPC           ",
"Pulse Large Laser",
"(R) Pulse Med Las",
"Pulse Small Laser",
"Anti-Missile Syst",
"Vehicle Flamer   ",
"Heavy Gauss Rifle",
"Gauss Rifle      ",
"Light Gauss Rifle",
"LB 2-X AC        ",
"LB 5-X AC        ",
"LB 10-X AC       ",
"LB 20-X AC       ",
"Rotary AC/2      ",
"Rotary AC/5      ",
"Rotary AC/10     ",
"Rotary AC/20     ",
"Ultra AC/2       ",
"Ultra AC/5       ",
"Ultra AC/10      ",
"Ultra AC/20      ",
"Narc Beacon      ",
"iNarc Beacon     ",
"MRM-10           ",
"MRM-20           ",
"MRM-30           ",
"MRM-40           ",
"RocketLauncher-10",
"RocketLauncher-15",
"RocketLauncher-20",
"Streak SRM-2     ",
"Streak SRM-4     ",
"Streak SRM-6     ",

"Arrow IV      ",
"Long Tom      ",
"Sniper        ",
"Thumper       ",
"Laser AMS     ",
"X-Pulse Large Laser",
"X-Pulse Medium Laser",
"X-Pulse Small Laser",
"Grenade Launcher",
"Heavy Flamer  ",
"Light AutoCannon/2",
"Light AutoCannon/5",
"Light AutoCannon/10",
"Light AutoCannon/20",
"Long Tom Cannon",
"Sniper Cannon ",
"Thumper Cannon",
"ThunderBolt 5 ",
"ThunderBolt 10",
"ThunderBolt 15",
"ThunderBolt 20",

"Hyper Velocity AC/2",
"Hyper Velocity AC/5",
"Hyper Velocity AC/10",
"Hyper Velocity AC/20",
"iHeavy Gauss Rifle",
"iLight Gauss Rifle",

"ER PPC           ",
"ER Large Laser   ",
"(R) ER Medium Laser",
"ER Small Laser   ",
"ER Micro Laser   ",
"Pulse Large Laser",
"(R) Pulse Med Laser",
"Pulse Small Laser",
"Pulse Micro Laser",
"Heavy Large Laser",
"Heavy Med Laser  ",
"Heavy Small Laser",
"Flamer           ",
"Anti-Missile Sys ",
"Vehicle Flamer   ",
"Gauss Rifle      ",
"LB 2-X AC        ",
"LB 5-X AC        ",
"LB 10-X AC       ",
"LB 20-X AC       ",
"Ultra AC/2       ",
"Ultra AC/5       ",
"Ultra AC/10      ",
"Ultra AC/20      ",
"Machine Gun      ",
"Heavy Machine Gun",
"Light Machine Gun",
"NARC             ",
"ATM-3            ",
"ATM-6            ",
"ATM-9            ",
"ATM-12           ",
"LRM 5            ",
"LRM 10           ",
"LRM 15           ",
"LRM 20           ",
"SRM 2            ",
"SRM 4            ",
"SRM 6            ",
"Streak SRM 2     ",
"Streak SRM 4     ",
"Streak SRM 6     ",

0x0000
};

char *Continue[] = {
		    "Flamer           ",
		    "Large Laser      ",
		    "Medium Laser     ",
		    "Small Laser      ",
		    "PPC              ",
		    "Auto Cannon/2    ",
		    "Auto Cannon/5    ",
		    "Auto Cannon/10   ",
		    "(C)Auto Cannon/20",
"LRM-5            ",
"LRM-10           ",
"LRM-15           ",
"LRM-20           ",
"SRM-2            ",
"SRM-4            ",
"SRM-6            ",
"ER Large Laser   ",
"ER Medium Laser  ",
"ER Small Laser   ",
"ER PPC           ",
"Pulse Large Laser",
"(R) Pulse Med Las",
"Pulse Small Laser",
"Anti-Missile Syst",
"Vehicle Flamer   ",
"Heavy Gauss Rifle",
"Gauss Rifle      ",
"Light Gauss Rifle",
"LB 2-X AC        ",
"LB 5-X AC        ",
"LB 10-X AC       ",
"LB 20-X AC       ",
"Rotary AC/2      ",
"Rotary AC/5      ",
"Rotary AC/10     ",
"Rotary AC/20     ",
"Ultra AC/2       ",
"Ultra AC/5       ",
"Ultra AC/10      ",
"(C) Ultra AC/20  ",
"RocketLauncher-10",
"RocketLauncher-15",
"RocketLauncher-20",
"Streak SRM-2     ",
"Streak SRM-4     ",
"Streak SRM-6     ",
"RocketLauncher-10",
"RocketLauncher-15",
"RocketLauncher-20",
"Streak SRM-2     ",
"Streak SRM-4     ",
"Streak SRM-6     ",
"RocketLauncher-10",
"RocketLauncher-15",
"RocketLauncher-20",
"Streak SRM-2     ",
"Streak SRM-4     ",
"Streak SRM-6     ",

"Hyper Velocity AC/2",
"Hyper Velocity AC/5",
"Hyper Velocity AC/10",
"Hyper Velocity AC/20",
"iHeavy Gauss Rifle",
"iLight Gauss Rifle",
"ER PPC           ",
"ER Large Laser   ",
"ER Medium Laser  ",
"ER Small Laser   ",
"ER Micro Laser   ",
"Pulse Large Laser",
"Pulse Med Laser  ",
"Pulse Small Laser",
"Pulse Micro Laser",
"Heavy Large Laser",
"Heavy Med Laser  ",
"Heavy Small Laser",
"Flamer           ",
"Anti-Missile Sys ",
"Vehicle Flamer   ",
"Gauss Rifle      ",
"LB 2-X AC        ",
"LB 5-X AC        ",
"LB 10-X AC       ",
"(C) LB 20-X AC   ",
"Ultra AC/2       ",
"Ultra AC/5       ",
"Ultra AC/10      ",
"(C) Ultra AC/20  ",
"Machine Gun      ",
"Heavy Machine Gun",
"Light Machine Gun",
"NARC             ",
"ATM-3            ",
"ATM-6            ",
"ATM-9            ",
"ATM-12           ",
"LRM 5            ",
"LRM 10           ",
"LRM 15           ",
"LRM 20           ",
"SRM 2            ",
"SRM 4            ",
"SRM 6            ",
"Streak SRM 2     ",
"Streak SRM 4     ",
"Streak SRM 6     ",

		    0x0000};

	       //                                                      3050                 AMS                           RA/C
int WeapSizeTable[] = { 1, 2, 1, 1, 3, 1, 4, 7, 10, 1, 1, 2, 3, 5, 1, 1, 2, 2, 1, 1, 3, 2, 1, 1 , 1, 1, 11, 7, 5, 4, 5, 8, 11, 3, 6, 9, 12, 3, 5, 7, 10, 2, 3, 2, 3, 5, 7, 1, 2, 3, 1, 1, 2, 15, 30, 20, 15, 1, 2, 1, 1, 1, 1, 1, 2, 3, 5, 15, 10, 7, 1, 2, 3, 5, 1, 4, 7, 10, 11, 5,\
/*Clan Tech*/           2, 1, 1, 1, 1, 2, 1, 1,  1, 3, 2, 1, 1, 1, 1, 6, 3, 4, 5, 9, 2, 3, 4, 8,  1, 1, 1,  2, 3, 4, 5, 1,  1, 2, 4, 1,  1, 1, 1, 1,  2, \
0x0000};

char *Ammo[] = {
" Ammo AC/2       ",
" Ammo AC/5       ",
" Ammo AC/10      ",
" Ammo AC/20      ",
" Ammo MG - Full  ",
" Ammo LRM-5      ",
" Ammo LRM-10     ",
" Ammo LRM-15     ",
" Ammo LRM-20     ",
" Ammo SRM-2      ",
" Ammo SRM-4      ",
" Ammo SRM-6      ",
" Ammo AMS        ",
" Ammo Flamer     ",
" Ammo Heavy Gauss",
" Ammo Gauss      ",
" Ammo Light Gauss",
" Ammo 2-X        ",
" Ammo 5-X        ",
" Ammo 10-X       ",
" Ammo 20-X       ",
" Ammo Rotary AC/2",
" Ammo Rotary AC/5",
" Ammo RotaryAC/10",
" Ammo RotaryAC/20",
" Ammo Ultra AC/2 ",
" Ammo Ultra AC/5 ",
" Ammo Ultra AC/10",
" Ammo Ultra AC/20",
" Ammo Narc       ",
" Ammo iNarc      ",
" Ammo MRM-10     ",
" Ammo MRM-20     ",
" Ammo MRM-30     ",
" Ammo MRM-40     ",
" Ammo Streak-2   ",
" Ammo Streak-4   ",
" Ammo Streak-6   ",

0x0000
};

char *ShortAmmo[] = {
" Ammo AC/2",
" Ammo AC/5",
" Ammo AC/10",
" Ammo AC/20",
" Ammo MG - Full",
" Ammo LRM-5",
" Ammo LRM-10",
" Ammo LRM-15",
" Ammo LRM-20",
" Ammo SRM-2",
" Ammo SRM-4",
" Ammo SRM-6",
" Ammo AMS",
" Ammo Flamer",
" Ammo Heavy Gauss",
" Ammo Gauss",
" Ammo Light Gauss",
" Ammo 2-X",
" Ammo 5-X",
" Ammo 10-X",
" Ammo 20-X",
" Ammo Rotary AC/2",
" Ammo Rotary AC/5",
" Ammo RotaryAC/10",
" Ammo RotaryAC/20",
" Ammo Ultra AC/2",
" Ammo Ultra AC/5",
" Ammo Ultra AC/10",
" Ammo Ultra AC/20",
" Ammo Narc",
" Ammo iNarc",
" Ammo MRM-10",
" Ammo MRM-20",
" Ammo MRM-30",
" Ammo MRM-40",
" Ammo Streak-2",
" Ammo Streak-4",
" Ammo Streak-6",
0x0000
};

char *ConAmmo[] = {
"Ammo AC/2",
"Ammo AC/5",
"Ammo AC/10",
"Ammo AC/20",
"Ammo MG - Full",
"Ammo LRM-5",
"Ammo LRM-10",
"Ammo LRM-15",
"Ammo LRM-20",
"Ammo SRM-2",
"Ammo SRM-4",
"Ammo SRM-6",
"Ammo AMS",
"Ammo Flamer",
"Ammo Heavy Gauss",
"Ammo Gauss",
"Ammo Light Gauss",
"Ammo 2-X",
"Ammo 5-X",
"Ammo 10-X",
"Ammo 20-X",
"Ammo Rotary AC/2",
"Ammo Rotary AC/5",
"Ammo RotaryAC/10",
"Ammo RotaryAC/20",
"Ammo Ultra AC/2",
"Ammo Ultra AC/5",
"Ammo Ultra AC/10",
"Ammo Ultra AC/20",
"Ammo Narc",
"Ammo iNarc",
"Ammo MRM-10",
"Ammo MRM-20",
"Ammo MRM-30",
"Ammo MRM-40",
"Ammo Streak-2",
"Ammo Streak-4",
"Ammo Streak-6",
0x0000
};

int AmmoState[] = {45,20,10, 5,200,24,12,8,6,50,25,15,12,50, 4, 8, 16, 45,20,10, 5,45,20,10, 5,45,20,10, 5, 6, 6,  24, 12, 8, 6,50, 25, 15, 0x0000};
