//#include <stdio.h>
//#include <conio.h>

char Opts  [80];
char String[80];

int LoadPilot(class Pilot &Pilot, char *Name);
int LoadAI   (class Pilot &Pilot, char *Name);
int loadMaps();

/*
int readString(char *String, FILE *ReadFile)
{
char ch = 0;
int  i = 0;
while (ch != 10 && ch != 13 && i != 100) {
  ch = fgetc(ReadFile);
  String[i] = ch;
  i++;
  }

  String[i-1] = 0;
return i;
}
*/
char *getFileExtension(char *String) {
int i=0,j=0;
while (String[i]!='.' && String[i]!=0x0000) i++;
while (String[j]!=0x0000)                 { String[j]=String[j+i]; j++; }
String[j]=0x0000;
return String;
}

char isLetter(char input)
{
if ((input >= 97) && (input <=122) || (input >= 65) && (input <=90))
  return 1;

return 0;
}

char isDigit(char input)
{
if ((input >= 48) && (input <=57))
  return 1;

return 0;
}


int strlength(char *String) {
int i=0;
while (String[i] != 0x0000) i++;

return i;
}

int strcomp(char *String, char *Comp) {

int i,j=0;
int l = strlength(Comp);

  for (i=0;i<l;i++) {

    if (String[i] == Comp[i]) j++;
      else {
    if (isLetter(String[i]) == 1 && String[i] == Comp[i] + lcase) j++;
    if (isLetter(String[i]) == 1 && String[i] == Comp[i] + ucase) j++; }

  }

return !(l-j);
}


int procNumber(char *String) {
int i=0,len,num=0;
  len = strlength(String);

  while (String[i] != '=' && i <= len) i++;
    if (i >= len) i = 0;
  while (!isDigit ( String[i] ) ) i++;
  while (String[i] != 0x0000 && isDigit(String[i])) num *= 10, num += String[i] - 48, i++;

return num;
}

int getData(char *String,int Offset) {
//int a,b,c,d,e;
int num;
int i=0,j;

for (j=0;j<6;j++) {
  num = 0;
  while (String[i] != 0x0000 && !isDigit(String[i])) i++;
  while (String[i] != 0x0000 &&  isDigit(String[i])) num *= 10, num += String[i] - 48, i++;
  Array[Offset][j] = num;
  }

return 0;
}

int readMission(int argc, char argv[]) {
int i,j;
char AI1[4];
char AI2[4];
char optr=0;
char Scenario[80];

FILE *OpFile;

  if (argc != 2) {
    printf("Defaulting to Mission.dat\n");
    sprintf(Scenario,"mission.dat");
  } else {
    sprintf(Scenario,"%s.SCN",argv);
    OpFile = fopen(Scenario,"r+");
    if (OpFile==NULL)
      sprintf(Scenario,"SCEN\\%s.SCN",argv);
    }

OpFile = fopen(Scenario,"r+");
  checkFile(OpFile,3);


i = 0;
//while (!eof(OpFile) && i != 5) {
while (i != 50 && optr != MAXOPTIONS && !feof(OpFile)) {
//while (i != 50 && optr != MAXOPTIONS) {
  readString(String,OpFile);
  if (strcomp(String,";"));// printf ("OFF>\n"); // Discard

  if (strcomp(String,"MAPS")) {
    Maps = procNumber(String);
    for (j=0;j<Maps;j++) { // Reads in Map Names
      readString(String,OpFile);
      while (strlength(String) == 0) readString(String,OpFile);
      sprintf(MapName[j],"%s",String);
      readString(String,OpFile); // Read Mask
      while (strlength(String) == 0) readString(String,OpFile);
      sprintf(MaskName[j],"%s",String);

	}
    }

  if (strcomp(String,"UNITS")) {
    Mechs = procNumber(String);
    if (Mechs > MAXMECHS) Mechs = MAXMECHS;
    for (j=0;j<Mechs;j++) { // Reads in Mech Names
      readString(String,OpFile);
      while (strlength(String) == 0) readString(String,OpFile);
      UnitType[j] = getUnitType(String); // Determines whether or not file is Mech/Vehicle/Infantry
      readString(String,OpFile);
      while (strlength(String) == 0) readString(String,OpFile);
      getData(String,j);
//      printf("%s\n",String);
      readString(String,OpFile); // Read Mech Name
      while (strlength(String) == 0) readString(String,OpFile);
      sprintf(MechName[j],"%s",String);
      printf("%d %s\n",j,String);

      readString(String,OpFile); // Read sprites
      while (strlength(String) == 0) readString(String,OpFile);
      sprintf(SpriteName[j],"%s",String);
//      printf("%d %s\n",j,String);

      readString(String,OpFile); // Read Pilot Name
      while (strlength(String) == 0) readString(String,OpFile);
      sprintf(PilotName[j],"%s",String);
//      printf("%d %s\n",j,String);

      readString(String,OpFile); // Read AI Type
      while (strlength(String) == 0) readString(String,OpFile);
      sprintf(AIName[j],"%s",String);
//      printf("%d %s\n",j,String);
	}
    fclose(OpFile);
    return 0;
    }
  i++;
  }
/*
  if (strcomp(String,"PILOTS")) {
//    printf("Pilot Data\n");

    for (j=0;j<MechsSide1;j++) { // Reads in Pilot Names
      readString(String,OpFile);
      while (strlength(String) == 0) readString(String,OpFile);
	sprintf(Pil1Name[j],"%s",String);

      readString(String,OpFile);
      while (strlength(String) == 0) readString(String,OpFile);
	sprintf(AI1Name[j],"%s",String);
	}
*/
/*
    for (j=0;j<MechsSide2;j++) { // Reads in Pilot Names
      readString(String,OpFile);
      while (strlength(String) == 0) readString(String,OpFile);
	sprintf(Pil2Name[j],"%s",String);

      readString(String,OpFile);
      while (strlength(String) == 0) readString(String,OpFile);
	sprintf(AI2Name[j],"%s",String);
	}

    }
*/
/*
  if (strcomp(String,"TRUE")) {
    Opts[optr] = 't';
    optr ++;
    }

  if (strcomp(String,"FALSE")) {
    Opts[optr] = 'f';
    optr ++;
    }
*/
//  i++;
//  }

  fclose(OpFile); // Close File
/*
    printf(">> %d <<\n",MechsSide1);
    for (i=0;i<MechsSide1;i++)
      printf(">> %s <<\n",Mech1Name[i]);
*/
}


int LoadMap(char *MapName, OldMapData *Loadmap, int x, int y)
{
int i,j;
unsigned char c;

FILE *MapIn;
MapIn = fopen(MapName,"r+");
checkFile(MapIn,4);

Loadmap->x1 = 0;
Loadmap->y1 = 0;

c = 0;
j = 0;
c = 0;
while (c != 255) {
Loadmap->x2 = i-2+x;
i = 0;
c = 0;
  while (c != 10 && c != 255) {
    c = fgetc(MapIn);
    Loadmap->hex[i+x][j+y] = c;
    i++;
//    printf("%c",c);
  }
j ++;
}
Loadmap->y2 = j-1+y;

fclose(MapIn);
return 0;
}

int ConvertMap (OldMapData oldmap,int x,int y) {
int i,j;

  for (j=0;j<16;j++)
    for (i=0;i<34;i++) // Make Variable?
      if (Hex(i,j)) {
        Map.Hex[i+x][j+y].Type = oldmap.hex[i  ][j];
        Map.Hex[i+x][j+y].Alt  = oldmap.hex[i+1][j];
          }

return 0;
}

int ConvertMask (OldMapData oldmap,int x,int y) {
int i,j;

  for (j=0;j<16;j++)
    for (i=0;i<34;i++) // Make Variable?
      if (Hex(i,j)) {
        Map.Hex[i+x][j+y].Cond = oldmap.hex[i  ][j];
        Map.Hex[i+x][j+y].Road = oldmap.hex[i+1][j];
          }

return 0;
}

int loadUnits() {
int i,k;

//printf("%s\n",MapName[0]);
//printf("1:%d  \n",Mechs);
//printf("%s\n",MechName[0]);
//printf("%s\n",MechName[1]);
//printf("%s\n",Pil1Name[0]);
//printf("%s\n",Pil1Name[1]);

Units = 0;
//MechsSide1 = 1;

for (i=0;i<Mechs;i++) {
//  readMCWMech(MCW,Mech1Name[i]);
//  ConvertMCW(Mech[i],MCW);
  switch (UnitType[i]) {
  case MECH:
  Mech[i].Type = MECH;
  LoadMech(Mech[i],MechName[i]);
  readMechSprite    (i,0,SpriteName[i]);
  readMechFallSprite(i,5,SpriteName[i]);
  LoadPilot(Mech[i].Pilot,PilotName[i]);
  LoadAI   (Mech[i].Pilot,AIName[i]);
//  Mech[i].Pilot.Gunnery  = 4;
//  Mech[i].Pilot.Piloting = 5;
  Mech[i].Side           = Array[i][0];
//  Mech[i].Colour         = makecol24(EGA[k].r,EGA[k].g,EGA[k].b);
  Mech[i].Colour         = makecol24(EGA[Array[i][1]].r,EGA[Array[i][1]].g,EGA[Array[i][1]].b);
  Mech[i].UnitColour     = Array[i][2];
  Mech[i].Vector.x       = Array[i][3];
  Mech[i].Vector.y       = Array[i][4];
  Mech[i].Vector.head    = Array[i][5];

  Mech[i].Heat           = 0;
  Mech[i].Immobile       = Off;

  Mech[i].Index  = i;
  Mech[i].m     = &Mech[i];
  unit[Units]   = &Mech[i];
  unit[Units]->u = unit[Units];

  Mech[i].genAmmoTable();
  Mech[i].SetPosition();

  Units++;
  break;

  case VEHICLE:
  Vehicle[i].Type  = VEHICLE;
  LoadVehicle(Vehicle[i],MechName[i]);
  readMechSprite    (i,0,SpriteName[i]);
  readMechFallSprite(i,1,SpriteName[i]); // Vehicles use the Fall Sprite for the Turret
  LoadPilot(Vehicle[i].Pilot,PilotName[i]);
  LoadAI   (Vehicle[i].Pilot,AIName[i]);

//  Mech[i].Pilot.Gunnery  = 4;
//  Mech[i].Pilot.Piloting = 5;
  Vehicle[i].Side           = Array[i][0];
//  Mech[i].Colour           = makecol24(EGA[k].r,EGA[k].g,EGA[k].b);
  Vehicle[i].Colour         = makecol24(EGA[Array[i][1]].r,EGA[Array[i][1]].g,EGA[Array[i][1]].b);
  Vehicle[i].UnitColour     = Array[i][2];
  Vehicle[i].Vector.x       = Array[i][3];
  Vehicle[i].Vector.y       = Array[i][4];
  Vehicle[i].Vector.head    = Array[i][5];

  Vehicle[i].Size           = 1;
  Vehicle[i].Position       = 1;
  Vehicle[i].Heat           = 0;
  Vehicle[i].Immobile       = Off;

  Vehicle[i].Index      = i;
  Vehicle[i].v          = &Vehicle[i];
  unit[Units]           = &Vehicle[i];
  unit[Units]->u        = unit[Units];

  Vehicle[i].SetPosition();

  Units++;
  break;

  case INFANTRY:
  Infantry[i].Type = INFANTRY;
  LoadInfantry(Infantry[i],MechName[i]);
  readMechSprite    (i,0,SpriteName[i]);
  readMechFallSprite(i,5,SpriteName[i]);
  LoadPilot(Infantry[i].Pilot,PilotName[i]);
  LoadAI   (Infantry[i].Pilot,AIName[i]);
//  Mech[i].Pilot.Gunnery  = 4;
//  Mech[i].Pilot.Piloting = 5;
  Infantry[i].Side           = Array[i][0];
//  Mech[i].Colour           = makecol24(EGA[k].r,EGA[k].g,EGA[k].b);
  Infantry[i].Colour         = makecol24(EGA[Array[i][1]].r,EGA[Array[i][1]].g,EGA[Array[i][1]].b);
  Infantry[i].UnitColour     = Array[i][2];
  Infantry[i].Vector.x       = Array[i][3];
  Infantry[i].Vector.y       = Array[i][4];
  Infantry[i].Vector.head    = Array[i][5];

  Infantry[i].Size           = 1;
  Infantry[i].Position       = 1;
  Infantry[i].Heat           = 0;
  Infantry[i].Immobile       = Off;

  Infantry[i].Index  = i;
  Infantry[i].i      = &Infantry[i];
  unit[Units]        = &Infantry[i];
  unit[Units]->u     = unit[Units];

  Infantry[i].SetPosition();

  Units++;
  break;

  case ELEMENTAL:
  Elemental[i].Type = ELEMENTAL;
  LoadElemental(Elemental[i],MechName[i]);
  readMechSprite    (i,0,SpriteName[i]);
  readMechFallSprite(i,5,SpriteName[i]);
  LoadPilot(Elemental[i].Pilot,PilotName[i]);
  LoadAI   (Elemental[i].Pilot,AIName[i]);

//  Mech[i].Pilot.Gunnery  = 4;
//  Mech[i].Pilot.Piloting = 5;
  Elemental[i].Side           = Array[i][0];
//  Mech[i].Colour           = makecol24(EGA[k].r,EGA[k].g,EGA[k].b);
  Elemental[i].Colour         = makecol24(EGA[Array[i][1]].r,EGA[Array[i][1]].g,EGA[Array[i][1]].b);
  Elemental[i].UnitColour     = Array[i][2];
  Elemental[i].Vector.x       = Array[i][3];
  Elemental[i].Vector.y       = Array[i][4];
  Elemental[i].Vector.head    = Array[i][5];

  Elemental[i].Size           = 1;
  Elemental[i].Position       = 1;
  Elemental[i].Heat           = 0;
  Elemental[i].Immobile       = Off;

  Elemental[i].Index    = i;
  Elemental[i].e        = &Elemental[i];
  unit[Units]           = &Elemental[i];
  unit[Units]->u        = unit[Units];

  Elemental[i].SetPosition();

  Units++;
  break;

  default: ;break;
  }

  }

return 0;
}

int LoadPilot(class Pilot &Pilot, char *Name)
{
char String[30];
FILE *MechOut;

sprintf(String,"%s.plt",Name);

MechOut = fopen(String,"r+");
if (MechOut == NULL) {
  sprintf(Pilot.Name,"Default");
  Pilot.Gunnery  = 4;
  Pilot.Piloting = 5;
  Pilot.Build    = 6;
  Pilot.Reflexes = 5;
  Pilot.Conscious= On;
  return 1; }


fscanf(MechOut,"%s",&Pilot.Name);
fscanf(MechOut,"%d",&Pilot.Gunnery);
fscanf(MechOut,"%d",&Pilot.Piloting);
fscanf(MechOut,"%d",&Pilot.Build);
fscanf(MechOut,"%d",&Pilot.Reflexes);

Pilot.Conscious = On;
//printf("%s\n",Pilot.Name);
//getch();
if (Options.AllSprint == On)
  Pilot.Sprint    = On;
if (Options.AllEvade  == On)
  Pilot.Evade     = On;

fclose(MechOut);
return 0;
}

int LoadAI(class Pilot &Pilot, char *Name)
{
char String[30];
int i=0,j=0;
while (Name[i] != '=') i++; // Scan Right to Equals
while (Name[i] == 32) i++;  // Scan Right to Name
while (Name[j+i] != 0x0000) String[j] = Name[j+i], j++;
String[j] = 0x0000;

while (String[i] >= '9' && String[i] != 0x0000) i++; // Scan Right to Equals
//textprintf(screen,font,20,20+Pilot.Gunnery*10,255,">%s<",String);

if (String[i] <= '9' && String[i] >= '0') {
  Pilot.Target           = 0;
  Pilot.AILevel          = String[i]-'0';
  Pilot.AIInitiativePhase= On;
  Pilot.AIMovePhase      = On;
  Pilot.AIReactionPhase  = On;
  Pilot.AIWeaponPhase    = On;
  Pilot.AIPhysicalPhase  = On;
  }


return 0;
}


int loadMaps() {

Xmin=0;Xmax=0;
Ymin=0;Ymax=0;


if (Maps > MapMax) Maps = MapMax;

switch (Maps) {
case 1:
LoadMap(MapName[0], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 0);
LoadMap(MaskName[0], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 0);
Xmax = 34; Ymax = 16;
;break;
case 2:
LoadMap(MapName[0], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 0);
LoadMap(MapName[1], &hexmap,0 , 0);
ConvertMap(hexmap,34, 0);

LoadMap(MaskName[0], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 0);
LoadMap(MaskName[1], &hexmap,0 , 0);
ConvertMask(hexmap,34, 0);

Xmax = 68; Ymax = 16;
;break;
case 3:
LoadMap(MapName[0], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 0);
LoadMap(MapName[1], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 16);
LoadMap(MapName[2], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 32);

LoadMap(MaskName[0], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 0);
LoadMap(MaskName[1], &hexmap,0 , 0);
ConvertMask(hexmap, 0,16);
LoadMap(MaskName[2], &hexmap,0 , 0);
ConvertMask(hexmap, 0,32);

Xmax = 34; Ymax = 48;
;break;
case 4:
LoadMap(MapName[0], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 0);
LoadMap(MapName[1], &hexmap,0 , 0);
ConvertMap(hexmap,34, 0);
LoadMap(MapName[2], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 16);
LoadMap(MapName[3], &hexmap,0 , 0);
ConvertMap(hexmap,34, 16);

LoadMap(MaskName[0], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 0);
LoadMap(MaskName[1], &hexmap,0 , 0);
ConvertMask(hexmap,34, 0);
LoadMap(MaskName[2], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 16);
LoadMap(MaskName[3], &hexmap,0 , 0);
ConvertMask(hexmap,34, 16);

Xmax = 68; Ymax = 32;
;break;
case 6:
LoadMap(MapName[0], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 0);
LoadMap(MapName[1], &hexmap,0 , 0);
ConvertMap(hexmap,34, 0);
LoadMap(MapName[2], &hexmap,0 , 0);
ConvertMap(hexmap,68, 0);
LoadMap(MapName[3], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 16);
LoadMap(MapName[4], &hexmap,0 , 0);
ConvertMap(hexmap,34, 16);
LoadMap(MapName[5], &hexmap,0 , 0);
ConvertMap(hexmap,68, 16);

LoadMap(MaskName[0], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 0);
LoadMap(MaskName[1], &hexmap,0 , 0);
ConvertMask(hexmap,34, 0);
LoadMap(MaskName[2], &hexmap,0 , 0);
ConvertMask(hexmap,68, 0);
LoadMap(MaskName[3], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 16);
LoadMap(MaskName[4], &hexmap,0 , 0);
ConvertMask(hexmap,34, 16);
LoadMap(MaskName[5], &hexmap,0 , 0);
ConvertMask(hexmap,68, 16);

Xmax = 102; Ymax = 32;
;break;
case 8:
LoadMap(MapName[0], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 0);
LoadMap(MapName[1], &hexmap,0 , 0);
ConvertMap(hexmap,34, 0);
LoadMap(MapName[2], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 16);
LoadMap(MapName[3], &hexmap,0 , 0);
ConvertMap(hexmap,34, 16);
LoadMap(MapName[4], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 32);
LoadMap(MapName[5], &hexmap,0 , 0);
ConvertMap(hexmap,34, 32);
LoadMap(MapName[6], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 48);
LoadMap(MapName[7], &hexmap,0 , 0);
ConvertMap(hexmap,34, 48);

LoadMap(MaskName[0], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 0);
LoadMap(MaskName[1], &hexmap,0 , 0);
ConvertMask(hexmap,34, 0);
LoadMap(MaskName[2], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 16);
LoadMap(MaskName[3], &hexmap,0 , 0);
ConvertMask(hexmap,34, 16);
LoadMap(MaskName[4], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 32);
LoadMap(MaskName[5], &hexmap,0 , 0);
ConvertMask(hexmap,34, 32);
LoadMap(MaskName[6], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 48);
LoadMap(MaskName[7], &hexmap,0 , 0);
ConvertMask(hexmap,34, 48);

Xmax = 68; Ymax = 64;
;break;
case 9:
LoadMap(MapName[0], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 0);
LoadMap(MapName[1], &hexmap,0 , 0);
ConvertMap(hexmap,34, 0);
LoadMap(MapName[2], &hexmap,0 , 0);
ConvertMap(hexmap,68, 0);
LoadMap(MapName[3], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 16);
LoadMap(MapName[4], &hexmap,0 , 0);
ConvertMap(hexmap,34, 16);
LoadMap(MapName[5], &hexmap,0 , 0);
ConvertMap(hexmap,68, 16);
LoadMap(MapName[6], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 32);
LoadMap(MapName[7], &hexmap,0 , 0);
ConvertMap(hexmap,34, 32);
LoadMap(MapName[8], &hexmap,0 , 0);
ConvertMap(hexmap,68, 32);

LoadMap(MaskName[0], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 0);
LoadMap(MaskName[1], &hexmap,0 , 0);
ConvertMask(hexmap,34, 0);
LoadMap(MaskName[2], &hexmap,0 , 0);
ConvertMask(hexmap,68, 0);
LoadMap(MaskName[3], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 16);
LoadMap(MaskName[4], &hexmap,0 , 0);
ConvertMask(hexmap,34, 16);
LoadMap(MaskName[5], &hexmap,0 , 0);
ConvertMask(hexmap,68, 16);
LoadMap(MaskName[6], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 32);
LoadMap(MaskName[7], &hexmap,0 , 0);
ConvertMask(hexmap,34, 32);
LoadMap(MaskName[8], &hexmap,0 , 0);
ConvertMask(hexmap,68, 32);

Xmax = 102; Ymax = 48;
;break;
case 12:
LoadMap(MapName[0], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 0);
LoadMap(MapName[1], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 16);
LoadMap(MapName[2], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 32);
LoadMap(MapName[3], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 48);

LoadMap(MapName[4], &hexmap,0 , 0);
ConvertMap(hexmap,34, 0);
LoadMap(MapName[5], &hexmap,0 , 0);
ConvertMap(hexmap,34, 16);
LoadMap(MapName[6], &hexmap,0 , 0);
ConvertMap(hexmap,34, 32);
LoadMap(MapName[7], &hexmap,0 , 0);
ConvertMap(hexmap,34, 48);

LoadMap(MapName[8], &hexmap,0 , 0);
ConvertMap(hexmap,68, 0);
LoadMap(MapName[9], &hexmap,0 , 0);
ConvertMap(hexmap,68, 16);
LoadMap(MapName[10], &hexmap,0 , 0);
ConvertMap(hexmap,68, 32);
LoadMap(MapName[11], &hexmap,0 , 0);
ConvertMap(hexmap,68, 48);

LoadMap(MaskName[0], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 0);
LoadMap(MaskName[1], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 16);
LoadMap(MaskName[2], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 32);
LoadMap(MaskName[3], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 48);

LoadMap(MaskName[4], &hexmap,0 , 0);
ConvertMask(hexmap,34, 0);
LoadMap(MaskName[5], &hexmap,0 , 0);
ConvertMask(hexmap,34, 16);
LoadMap(MaskName[6], &hexmap,0 , 0);
ConvertMask(hexmap,34, 32);
LoadMap(MaskName[7], &hexmap,0 , 0);
ConvertMask(hexmap,34, 48);

LoadMap(MaskName[8], &hexmap,0 , 0);
ConvertMask(hexmap,68, 0);
LoadMap(MaskName[9], &hexmap,0 , 0);
ConvertMask(hexmap,68, 16);
LoadMap(MaskName[10], &hexmap,0 , 0);
ConvertMask(hexmap,68, 32);
LoadMap(MaskName[11], &hexmap,0 , 0);
ConvertMask(hexmap,68, 48);

Xmax =102; Ymax = 64;
break;
case 16: // Biggest Map
LoadMap(MapName[0], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 0);
LoadMap(MapName[1], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 16);
LoadMap(MapName[2], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 32);
LoadMap(MapName[3], &hexmap,0 , 0);
ConvertMap(hexmap, 0, 48);

LoadMap(MapName[4], &hexmap,0 , 0);
ConvertMap(hexmap,34, 0);
LoadMap(MapName[5], &hexmap,0 , 0);
ConvertMap(hexmap,34, 16);
LoadMap(MapName[6], &hexmap,0 , 0);
ConvertMap(hexmap,34, 32);
LoadMap(MapName[7], &hexmap,0 , 0);
ConvertMap(hexmap,34, 48);

LoadMap(MapName[8], &hexmap,0 , 0);
ConvertMap(hexmap,68, 0);
LoadMap(MapName[9], &hexmap,0 , 0);
ConvertMap(hexmap,68, 16);
LoadMap(MapName[10], &hexmap,0 , 0);
ConvertMap(hexmap,68, 32);
LoadMap(MapName[11], &hexmap,0 , 0);
ConvertMap(hexmap,68, 48);

LoadMap(MapName[12], &hexmap,0 , 0);
ConvertMap(hexmap,102, 0);
LoadMap(MapName[13], &hexmap,0 , 0);
ConvertMap(hexmap,102, 16);
LoadMap(MapName[14], &hexmap,0 , 0);
ConvertMap(hexmap,102, 32);
LoadMap(MapName[15], &hexmap,0 , 0);
ConvertMap(hexmap,102, 48);

LoadMap(MaskName[0], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 0);
LoadMap(MaskName[1], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 16);
LoadMap(MaskName[2], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 32);
LoadMap(MaskName[3], &hexmap,0 , 0);
ConvertMask(hexmap, 0, 48);

LoadMap(MaskName[4], &hexmap,0 , 0);
ConvertMask(hexmap,34, 0);
LoadMap(MaskName[5], &hexmap,0 , 0);
ConvertMask(hexmap,34, 16);
LoadMap(MaskName[6], &hexmap,0 , 0);
ConvertMask(hexmap,34, 32);
LoadMap(MaskName[7], &hexmap,0 , 0);
ConvertMask(hexmap,34, 48);

LoadMap(MaskName[8], &hexmap,0 , 0);
ConvertMask(hexmap,68, 0);
LoadMap(MaskName[9], &hexmap,0 , 0);
ConvertMask(hexmap,68, 16);
LoadMap(MaskName[10], &hexmap,0 , 0);
ConvertMask(hexmap,68, 32);
LoadMap(MaskName[11], &hexmap,0 , 0);
ConvertMask(hexmap,68, 48);

LoadMap(MaskName[12], &hexmap,0 , 0);
ConvertMask(hexmap,102, 0);
LoadMap(MaskName[13], &hexmap,0 , 0);
ConvertMask(hexmap,102, 16);
LoadMap(MaskName[14], &hexmap,0 , 0);
ConvertMask(hexmap,102, 32);
LoadMap(MaskName[15], &hexmap,0 , 0);
ConvertMask(hexmap,102, 48);

Xmax =136; Ymax = 64;
break;
default : AbortGame(3); break;
}

}

int procVar(char *String, int opt) {
int Val = -1;
int i;

while (String[i]==32) i++;

if (String[i] == 't') Val = On;
if (String[i] == 'T') Val = On;
if (String[i] == 'f') Val = Off;
if (String[i] == 'F') Val = Off;
if (String[i] == 'v') Val = On;
if (String[i] == 'V') Val = On;

if (Val != -1)
  Opts[opt] = Val;

return Val;
}


int readOptions(int argc, char argv[]) {
int i,j;
char AI1[4];
char AI2[4];
char optr=0;
char Options[80];

FILE *OpFile;

  if (argc != 2) {
    printf("Defaulting to Options.dat\n");
    sprintf(Options,"options.dat");
  } else {
    sprintf(Options,"%s.OPT",argv);
    OpFile = fopen(Options,"r+");
    if (OpFile==NULL)
      sprintf(Options,"SCEN\\%s.OPT",argv);
    }

OpFile = fopen(Options,"r+");
//OpFile = fopen("OPTIONS.DAT","r+");
  checkFile(OpFile,6);

i = 0;
//while (!eof(OpFile) && i != 5) {
while (i != 100 && optr != MAXOPTIONS ) {
  readString(String,OpFile);
  if (strcomp(String,";") || strlen(String) == 0);// printf ("OFF>\n"); // Discard
    else {
      j = procVar (String,optr);
      if (j != -1) {
//        printf("<%s> %d <%d>\n",String,j,optr);
        optr ++;
        }
      }
  i++;
  }

  fclose(OpFile); // Close File
}

int setOptions() {
int i;
//getch();
//for (i=0;i<MAXOPTIONS;i++)
//  printf("Value %d %d\n",i,Opts[i]);


Options.InitiativePhase         = Opts[ 0];
Options.MovePhase               = Opts[ 1];
Options.ReactionPhase           = Opts[ 2];
Options.WeaponPhase             = Opts[ 3];
Options.PhysicalPhase           = Opts[ 4];
Options.HeatPhase               = Opts[ 5];
Options.EndPhase                = Opts[ 6];
Options.ChargeMoves             = Opts[ 7];
Options.DrawGrid                = Opts[ 8];
Options.HighLight               = Opts[ 9];
Options.CreateFire              = Opts[10];
Options.CentreMap               = Opts[11];
Options.ShowWeaponFire          = Opts[12];
Options.AmmoExplosions          = Opts[13];
Options.AmmoConsumption         = Opts[14];
Options.ModeratedAmmoExplosions = Opts[15];
Options.SaveBattleReport        = Opts[16];
Options.ShowTargetTerrain       = Opts[17];
Options.Stacking                = Opts[18];
Options.FloatingCrits           = Opts[19];
Options.TransferDamage          = Opts[20];
Options.GlancingHits            = Opts[21];
Options.Retreat                 = Opts[22];
Options.AltitudeDisplay         = Opts[23];
Options.FastAI                  = Opts[24];
Options.LOSBlock                = Opts[25];
Options.LinearGunnery           = Opts[26];
Options.LinearPiloting          = Opts[27];
Options.ExtremeRange            = Opts[28];
Options.CriticalHits            = Opts[29];
Options.ElectronicLOS           = Opts[30];

Options.SimultaneousWeaponFire     = Opts[31];
Options.SimultaneousPhysicalAttacks= Opts[32];
Options.InitiativeBySide           = Opts[33];
Options.CompressReactionPhase      = Opts[34];

Options.RedrawLowLights            = Opts[35];
Options.AimedShots                 = Opts[36];
Options.CalledShots                = Opts[37];
Options.AutoPick                   = Opts[38];
Options.MASCLocks                  = Opts[39];
Options.HeadShots                  = Opts[40];

Options.GlancingHeadHits           = Opts[41];
Options.AllSprint                  = Opts[42];
Options.AllEvade                   = Opts[43];

Options.ShowShore                  = Opts[44];
Options.ShowHills                  = Opts[45];
Options.TwentyPointFalls           = Opts[46];
Options.AngleOfAttack              = Opts[47];
Options.HexFacings                 = Opts[48];
Options.MoveUnitsBySide            = Opts[49];
Options.MissileBonus               = Opts[50];
Options.CumulativeTwentyPointFalls = Opts[51];
Options.FractionalCover            = Opts[52];
Options.RunInWater                 = Opts[53];
Options.AltChangeLimit             = Opts[54];
Options.Level3VehicleCrits         = Opts[54];
Options.MouseMove                  = Opts[55];


//getch();
return 0;
}
