////////////////////////////////////////////////////////////////////////////
// Line Of Sight Functions
//
//

// To Handle Smoke
#define            MapType       (Map.Hex[x][y].Fire=='s'||Map.Hex[x][y].Fire=='F')?SmokeMask[Map.Hex[x][y].Type]:Map.Hex[x][y].Type

int ProcLOSstr  (char *String) {return 0;};//Pass Unit Height/Altitude Latter
//int drawGrid();
int doLos (int x1, int y1, int x2, int y2);
int getHex(int x, int y);

////////////////////////////////////////////////////////////////////////////
//
//     330     30
//
//  270     *      90
//
//     210     150
//


int doLos(int x1, int y1, int x2, int y2)
{

double ax, xa;
double d1,d2;
double dx = x2 - x1 ,dy = y2 - y1;
int i = 0;

int sx;
int sy;
int x,y,OldHex = 0;

//straight Horizontal Line Catch
////////////////////////////////////////////////////////////////////////////
// Main Switch
//
//

if (dy != 0.00 && dx != 0.00) {

  sx = abs(x2-x1)/(x2-x1);
  sy = abs(y2-y1)/(y2-y1);

  ax = dx/dy;
  xa = 1/ax;
  dx = x2 - x1;
  dy = y2 - y1;

  if (fabs(ax) >= 1) {
  ////////////////////////////////////////////////////////////////////////////
  // Horizontal
  //
  //
  dx = x1;
  dy = y1 + .5;
  OldHex = 0;
  while (dx != x2 && i != MAXLENGTH) {
    dx += sx;
    dy += sx*xa;

    x = int(dx); y = int(dy);

    if (Hex(int(dx),int(dy)) );
    else
      x += sx;

    if (OldHex != getHex(x,y)) {
      LOSstring[(i<<1)+1] = Map.Hex[x][y].Alt; // Altitude
      LOSstring[(i<<1)] = MapType;
      OldHex = getHex(x,y); i++;
      }

    }
  } else {
  ////////////////////////////////////////////////////////////////////////////
  // Vertical
  //
  //

  dx = x1 + .5;
  dy = y1;

  while (dy != y2 && i != MAXLENGTH) {
    dx += sy*ax;
    dy += sy*1.0;

    x = int(dx); y = int(dy);

    if (Hex(int(dx),int(dy)) );
    else
      y += sy;

      if (OldHex != getHex(x,y)) {
      LOSstring[(i<<1)+1] = Map.Hex[x][y].Alt;
      LOSstring[(i<<1)] = MapType;
      OldHex = getHex(x,y); i++;
      }

    }

  }
  }
else {
////////////////////////////////////////////////////////////////////////////
// Zero Divide Switches
//
//

if (dx != 0.0) {
  dx = x1;
  dy = y1;
  sx = abs(x2-x1)/(x2-x1);
  while (dx != x2 && i != MAXLENGTH) {
    dx += sx;
    x = int(dx); y = int(dy);

    if (Hex(int(dx),int(dy)) );
    else
      x += sx;

    if (OldHex != getHex(x,y)) {
      LOSstring[(i<<1)+1] = Map.Hex[x][y].Alt;
      LOSstring[(i<<1)] = MapType;
      OldHex = getHex(x,y); i++;
      }

  }
} else {
//  printf("ZERO DIVIDE!");
//  getch();

  if (dy != 0.0 && y2-y1 != 0) sy = abs(y2-y1)/(y2-y1); // IF dx=0 & dy=0, then you go no where
    else sy = 0;

  dx = x1 + .5;
  dy = y1;
  while (dy != y2 && i != MAXLENGTH) {
//  dx += sy*ax;
    dy += sy*1.0;

    x = int(dx); y = int(dy);

    if (Hex(int(dx),int(dy)) );
    else
      y += sy;

    if (OldHex != getHex(x,y)) {
      LOSstring[(i<<1)+1] = Map.Hex[x][y].Alt;
      LOSstring[(i<<1)] = MapType;
      OldHex = getHex(x,y);
      }
  i++;
  }
}

}

//textprintf(screen,font,20,40,10,"%s",LOSstring);

LOSstring[(i<<1)  ] = 0x0000;
LOSstring[(i<<1)+1] = 0x0000;
return i;
}


int getHex(int x, int y)
{
int value = (x * 100) + y;
return value;
}

int ProcLOSstrALT ( char *String,int Alt1, int Height1, int Alt2, int Height2)
{
//  Right now standardize for current Map set
char Hex[128];
char HexDepth[128];
char Depth[128];
int i,j;
int Modifier = 0;
//int Height = 2;
for (i=0;i<128;i++) { // Set to Zero
  Hex[i] = 0;
  HexDepth[i] = 0;
  Depth[i] = 0;
  }

// Firstly do for obscurment by terrain (ie trees)

Hex['.'] = 0;
Hex['t'] = 1;
Hex['T'] = 2;
Hex['U'] = 3;
Hex['j'] = 3;
Hex['J'] = 4;
Hex['V'] = 5;
Hex['s'] = 6;
Hex['S'] = 7;

Hex['p'] = 0;
Hex['R'] = 0;
Hex['L'] = 12; // Buildings obscure LOS
Hex['M'] = 12;
Hex['H'] = 12;
Hex['A'] = 12;

Hex['w'] = 0;
Hex['%'] = 0;

// Height of the obstacle
HexDepth['.'] = 0;
HexDepth['t'] = 2;
HexDepth['T'] = 2;
HexDepth['U'] = 3;
HexDepth['j'] = 2;
HexDepth['J'] = 2;
HexDepth['V'] = 3;
HexDepth['s'] = 2;
HexDepth['S'] = 2;

HexDepth['p'] = 0;
HexDepth['R'] = 0;
HexDepth['L'] = 1;
HexDepth['M'] = 2;
HexDepth['H'] = 2;
HexDepth['A'] = 3;

HexDepth['w'] = 0;
HexDepth['%'] = 0;

Depth[44 ] =-4;
Depth[45 ] =-3;
Depth[46 ] =-2;
Depth[47 ] =-1;
Depth['0'] = 0;
Depth['1'] = 1;
Depth['2'] = 2;
Depth['3'] = 3;
Depth['4'] = 4;
Depth['5'] = 5;
Depth['s'] = -1;
Depth['m'] = -2;
Depth['d'] = -3;

// If Target is in the same hex, ToHit 0
i=0;
while (String[(i<<1)+1]!=0x0000) i++;
if (i==0) return 0;

// Pre Process String
i=0;
while (String[(i<<1)+1]!=0x0000) {
  if (Hex[String[(i<<1)]] >= 12) {
    String[(i<<1)+1] = String[(i<<1)+1] + HexDepth[ String[(i<<1)+0] ];
    String[(i<<1)  ] = '.';

    if (String[(i<<1)+1] == 's') String[(i<<1)+1] == 47;
    if (String[(i<<1)+1] == 'm') String[(i<<1)+1] == 46;
    if (String[(i<<1)+1] == 'd') String[(i<<1)+1] == 45;

    }
//  textprintf(screen,font,20,20+i*10,makecol24(171,171,171),"<%2c><%2c>",String[(i<<1)],String[(i<<1)+1]);
  i++;
  }

//getkey();
//int Altitude = depth[Map.Hex[uptr->Vector.x][uptr->Vector.y]]

int Altitude = Alt1;
int QuarterCover = Off;
int HalfCover    = Off;
int ThreeQuarterCover = Off;
int FullCover = Off;

int m = i+1;
float incl, cheight, obs; // Incline, Current Height, and Obscurment

incl = float(((Alt2+Height2+.5) - (Altitude+Height1+.5)) / float(m));
// Height 1 gets a small bonus

i=0;

//textprintf(screen,font,20,30,10,"%d %d %d %d",Alt1,Height1,Alt2,Height2);
//textprintf(screen,font,20,40,10,"%s",String);
//  textprintf(screen,font,20,40,makecol24(171,171,171),"Str Dpt obs cht ht2");

// Stops short on hex because last hex only effects Modifier
while (String[(i<<1)+2]!=0x0000) {

  cheight = Altitude + Height1 + (incl * (i+1));

  obs = -Depth[String[(i<<1)+1]] + cheight;

//  textprintf(screen,font,50,50+i*10,makecol24(171,171,171),"<%c> %d %f %f %d ",String[(i<<1)+1],Depth[String[(i<<1)+1]],obs,cheight,Height2);
  if (-obs >=-(.25*Height2)) QuarterCover      = On;
  if (-obs >= (.0 *Height2)) HalfCover         = On;
  if (-obs >= (.25*Height2)) ThreeQuarterCover = On;
  if (-obs >= (.48*Height2)) FullCover         = On;
  // Should be .5
  // Then obstacle in LOS
  if ((Depth[String[(i<<1)+1]]+HexDepth[String[(i<<1)]]) > cheight)
    Modifier += Hex[String[(i<<1)]];
    
  i++;
  }

  if ((Depth[String[(i<<1)+1]]+HexDepth[String[(i<<1)]]) > cheight)
    Modifier += Hex[String[(i<<1)]];

  i--;
if (Hex[String[(i<<1)]] == 'w') Modifier -= 1; // Target in Water

if (FullCover == Off && Hex[String[(i<<1)]] == 'L') Modifier -= 12; // Target in Building
if (FullCover == Off && Hex[String[(i<<1)]] == 'M') Modifier -= 12; // Target in Building
if (FullCover == Off && Hex[String[(i<<1)]] == 'H') Modifier -= 12; // Target in Building
if (FullCover == Off && Hex[String[(i<<1)]] == 'A') Modifier -= 12; // Target in Building

//Using Height allows the same calculation to work on all units
//Mech Height = 2 = 12m = 40'
  if (Options.ElectronicLOS == On) Modifier = 0; // Sees through smoke / Trees
  if (Options.LOSBlock == On && Modifier >= 4) FullCover = On;

  if (HalfCover 	== On) Modifier += 3;
  if (FullCover 	== On) Modifier += 24;
//getch();
  if (Options.FractionalCover == On) {
    if (QuarterCover      == On) Modifier += 1;
    if (ThreeQuarterCover == On) Modifier += 6;
    }

return Modifier;
}

//Get Partial Cover
int ProcCover ( char *String,int Alt1, int Height1, int Alt2, int Height2)
{
//  Right now standardize for current Map set
char Hex[255];
char HexDepth[255];
char Depth[255];
int i,j;
int Modifier = 0;
//int Height = 2;

for (i=0;i<256;i++) Hex[i] = 0, HexDepth[i] = 0, Depth[i] = 0; // Set to Zero

// Firstly do for obscurment by terrain (ie trees)

Hex['.'] = 0;
Hex['t'] = 1;
Hex['T'] = 2;
Hex['U'] = 3;
Hex['j'] = 3;
Hex['J'] = 4;
Hex['V'] = 5;
Hex['s'] = 6;
Hex['S'] = 7;

Hex['p'] = 0;
Hex['R'] = 0;
Hex['L'] = 12; // Buildings obscure LOS
Hex['M'] = 12;
Hex['H'] = 12;
Hex['A'] = 12;

Hex['w'] = 0;
Hex['%'] = 0;

// Height of the obstacle
HexDepth['.'] = 0;
HexDepth['t'] = 2;
HexDepth['T'] = 2;
HexDepth['U'] = 3;
HexDepth['j'] = 2;
HexDepth['J'] = 2;
HexDepth['V'] = 3;
HexDepth['s'] = 2;
HexDepth['S'] = 2;

HexDepth['p'] = 0;
HexDepth['R'] = 0;
HexDepth['L'] = 1;
HexDepth['M'] = 2;
HexDepth['H'] = 2;
HexDepth['A'] = 3;

HexDepth['w'] = 0;
HexDepth['%'] = 0;

Depth[44 ] =-4;
Depth[45 ] =-3;
Depth[46 ] =-2;
Depth[47 ] =-1;
Depth['0'] = 0;
Depth['1'] = 1;
Depth['2'] = 2;
Depth['3'] = 3;
Depth['4'] = 4;
Depth['5'] = 5;
Depth['s'] = -1;
Depth['m'] = -2;
Depth['d'] = -3;


// PreProcess String
i=0;
while (String[(i<<1)+1]!=0x0000) {
  if (Hex[String[(i<<1)]] >= 12) {
    String[(i<<1)+1] = String[(i<<1)+1] + HexDepth[ String[(i<<1)+0] ];
    String[(i<<1)  ] = '.';

    if (String[(i<<1)+1] == 's') String[(i<<1)+i] == 47;
    if (String[(i<<1)+1] == 'm') String[(i<<1)+i] == 46;
    if (String[(i<<1)+1] == 'd') String[(i<<1)+i] == 45;

    }
  i++;
  }

//int Altitude = depth[Map.Hex[uptr->Vector.x][uptr->Vector.y]]

int Altitude = Alt1;
int QuarterCover = Off;
int HalfCover    = Off;
int ThreeQuarterCover = Off;
int FullCover = Off;

int m = i+1;
float incl, cheight, obs; // Incline, Current Height, and Obscurment

incl = float(((Alt2+Height2) - (Altitude+Height1+.5)) / float(m));

i=0;

//textprintf(screen,font,20,30,10,"%d %d %d %d",Alt1,Height1,Alt2,Height2);
//textprintf(screen,font,20,40,10,"%s",String);
//Stops one hex short because target hex does not effect Cover
while (String[(i<<1)+2]!=0x0000) {

  cheight = Altitude + Height1 + (incl * (i+1));

  obs = -Depth[String[(i<<1)+1]] + cheight;

//  textprintf(screen,font,50,50+i*10,makecol24(171,171,171),"<%c> %d %f %f %d ",String[(i<<1)+1],Depth[String[(i<<1)+1]],obs,cheight,Height2);

  if (-obs >=-(.25*Height2)) QuarterCover      = On;
  if (-obs >= (.0 *Height2)) HalfCover         = On;
  if (-obs >= (.25*Height2)) ThreeQuarterCover = On;
  if (-obs >= (.5 *Height2)) FullCover         = On;

  // Then obstacle in LOS
  if ((Depth[String[(i<<1)+1]]+HexDepth[String[(i<<1)]]) > cheight)
    Modifier += Hex[String[(i<<1)]];
    
  i++;
  }

//Using Height allows the same calculation to work on all units
//Mech Height = 2 = 12m = 40'
  if (Options.LOSBlock == On && Modifier >= 3) FullCover = On;

  i--;
  if (String[(i<<1)] == 'w' && Depth[String[(i<<1)+1]] == -1) HalfCover = On;
  if (String[(i<<1)] == 'w' && Depth[String[(i<<1)+1]]  < -1) FullCover = On;

  Modifier = 0;
//  if (QuarterCover 	== On) Modifier = 1;
  if (HalfCover 	== On) Modifier = 1;
//  if (ThreeQuarterCover == On) Modifier = 3;
  if (FullCover 	== On) Modifier = 2;

//  textprintf(screen,font,20,20,10,"Cover %d",Modifier);

return Modifier;
}

