////////////////////////////////////////////////////////////////////////////
// BattleMech Specific Functions
// Show
// Damage
// Physical Attacks


int Mech::Show() {

char *DestroyedFlag[] = {"DESTROYED",
                         " ",
                         " ",
                         " ",
                         0x0000};

char *ConsciousFlag[] = {"UnConcscious",
                          "Concscious",
                          0x0000};

char *ShutDownFlag[] =   {"",
                          "- ShutDown",
                          0x0000};

int x1 = 110, y1 = 130;
int x = x1;
int y = y1;
int col = 0;
int HeatSinkChar;

if (HeatSinkType == 1) HeatSinkChar = 'D';
  else HeatSinkChar = 'S';

rectfill(screen,100,120,500,360,Window.BGColour);

x += 0; y += 0;
if (TechBase > 3)
  textprintf(screen,font,x,y,col," %s ",Name);
else
  textprintf(screen,font,x,y,col,"%s : %s ",Code,Name);

x += 0; y += 8;
textprintf(screen,font,x,y,col,"Tons %d Walk %d Run %d Jump %d HS %c %d Heat : %d",Tons,Walk,Run,Jump,HeatSinkChar,HeatSinks,Heat);

  x += 0, y = y1 + 30,
  textprintf(screen,font,x,y,col,"Loc Arm Str  ");
int i;
for (i=0;i<8;i++)
  x += 0, y = y1 + i*8 + 38,
  textprintf(screen,font,x,y,col,"%3s  %2d  %2d  ",LocName[i],Armour[i],Struct[i]);

for (i=8;i<11;i++)
  x += 0, y = y1 + i*8 + 38,
  textprintf(screen,font,x,y,col,"%3s  %2d   ",LocName[i],Armour[i]);

  x += 120;
for (i=0;i<Weapons;i++) {
  x += 0; y = y1 + i*8 + 30;
  textprintf(screen,font,x,y,col,"%-3s %-15s %s ",LocName[abs(Weapon[i].Loc)],Weapon[i].Name,DestroyedFlag[Weapon[i].State+1]);
//  textprintf(screen,font,x,y,col,"%d       ",WeaponTable[Weapon[i].Type].Dam);
  }

for (i=0;i<Ammunitions;i++) {
  x += 0; y = y1 + (Weapons+i)*8 + 30;
  textprintf(screen,font,x,y,col,"%-3s %-15s %d ",LocName[abs(Ammo[i].Loc)],Ammo[i].Name,Ammo[i].Ammo);
  }

  x -= 20; y = 345;
  textprintf(screen,font,x,y,col,"%s",Functional[Status]);
  x += 100; y = 150;
  textprintf(screen,font,x,y,col,"%s",ShutDownFlag[ShutDown]);


  x  = 110; y = 280;
  textprintf(screen,font,x,y,col,"Pilot [%s] G:%2d P:%2d ",Pilot.Name,Pilot.Gunnery,Pilot.Piloting);
            y += 10;
  textprintf(screen,font,x,y,col,"Pilot %d : %s",Pilot.Hits,ConsciousFlag[Pilot.Conscious]);
  x  = 110; y = 270;
  textprintf(screen,font,x,y,col,"E%d G%d S%d L%d",EngineHits,GyroHits,SensorHits,LifeSupportHits);
//getch();

  textprintf(screen,font,450,345,0,"[M]ore");
return 0;
}

int Mech::ShowCrits() {

int i,j,k,x,y,col;

int CritArea[8] = {6,12,12,12,12,12,6,6};
int xk[8] = {260,260,335,185,410,110,335,185};
int yk[8] = {130,190,190,190,190,190,300,300};

  BITMAP *block;
  block = create_bitmap(500,300);

x = 260;
y = 130;
col = 0;

  blit(screen,block, 100,120,0,0,550,300);
  rectfill(screen, 100,120,500,380,Window.BGColour);

for (k=0;k<8;k++) {
  x = xk[k];
  y = yk[k];
  col = Window.TextColour;
  textprintf(screen,font,x,y-8,col,"%5s",LocName[k]);
  for (i=0;i<CritSlot[k];i++)
    for (j=0;j<Crit[k][i].Size;j++) {
    if (Crit[k][i].State >= 0) col = Window.TextColour;
      else col = Window.TextHighLightColour;

    if (Crit[k][i].Class == 1) // Weapon
      textprintf(screen,font,x,y,col,"<%-7s>",WeaponTable[Crit[k][i].Type].Code);
    else
    if (Crit[k][i].Class == 2) // Ammo
//      textprintf(screen,font,x,y,col,"<2 %d>",Crit[k][i].Type);
      textprintf(screen,font,x,y,col,"<%-7s>",AmmoTable[Crit[k][i].Type].Code);
    else
    if (Crit[k][i].Class == 6) // Weapon Continue
      textprintf(screen,font,x,y,col,"<%-7s>",WeaponTable[Crit[k][i].Type].Code);
    else
      textprintf(screen,font,x,y,col,"<%s>",CritName[Crit[k][i].Class][Crit[k][i].Type]);

    y+= 8;
    }
  }
  getkey();
  blit(block,screen,0,0,100,120,550,300);
  
return 0;
}


int Mech::Damage(int Loc, int Facing, int Dam) {
int srt=Struct[RT],slt=Struct[LT],srl=Struct[RL],sll=Struct[LL],sra=Struct[RA],sla=Struct[LA];
int i;

  TurnDamage += Dam;

  if (Loc == 0  && Options.HeadShots == Off) Loc = 1;
  if (Loc == 15 && Options.HeadShots == Off) Loc = 8;

if ( Loc == 0 ) { // Head

  if (Options.GlancingHeadHits == On)
    Dam ++, Dam /= 2;

  Pilot.Hits ++;
  ConcRoll();
  }

if ( Loc == 15) { // Back of the Head
  Pilot.Hits ++;
  ConcRoll();
  Loc = 0;
  }
// -4 equals Roll for Location
if ( Loc ==  -1) { // 0 = Head, -1 equals Crit
    if (Options.FloatingCrits == On)
      Loc = abs(HitLoc[Facing][roll2d6]);
    else Loc = HitLoc[Facing][7];
    Critical( Loc , 0);
    }

if ( Loc ==  -2) return Dam; // -2 equal wasted shot

if (Loc < 8) { // Frontal Armour
  Armour[Loc] -= Dam;

  if (Armour[Loc] < 0) {

    Struct[Loc] += Armour[Loc];
    Armour[Loc] = 0;
    Critical(Loc, 0);
  }

  if (Struct[Loc] <= 0) {
    if (TransferDamage[Loc] != -1 && Options.TransferDamage == On)
      Damage(TransferDamage[Loc],Facing,-Struct[Loc]);
//    else
//      Damage(TransferDamage[Loc],Facing,Struct[Loc]);
    Struct[Loc] = 0;

  }
} else {

  if (Loc < 11) // Torso
    Armour[Loc  ] -= Dam;
  else
    Armour[Loc-7] -= Dam;

  if (Armour[Loc] < 0 && Loc < 11) {
    Struct[Loc-7] += Armour[Loc];
    Armour[Loc] = 0;
    Critical(Loc-7, 0);
  }

  if (Armour[Loc-7] < 0 && Loc > 10) {
    Struct[Loc-7] += Armour[Loc-7];
    Armour[Loc-7] = 0;
    Critical(Loc-7, 0);
  }

  if (Struct[Loc-7] <= 0) {
    if (TransferDamage[Loc] != -1 && Options.TransferDamage == On)
      Damage(TransferDamage[Loc],Facing, -Struct[Loc-7]);
    Struct[Loc-7] = 0;

    // Deactivate all weapons in Location
    // Move To other Function later
//    for (i=0;i<Weapons;i++)
//      if (Weapon[i].Loc == Loc-7) Weapon[i].Status = 0;
  }
}

if (Submersed == On)
  if (roll2d6 >= 10) Destroy(Loc); // Hull Breach

if (Struct[HD] <= 0) Pilot.Hits += 6, ConcRoll();
if (Struct[CT] <= 0 || Struct[HD] <= 0) {Position = 0; drawUnit(1); Status = Off; Immobile = On;}
if (Struct[RT] <= 0 && srt > 0) Armour[RT]=0,Armour[RTr]=0, Destroy(RT);
if (Struct[LT] <= 0 && slt > 0) Armour[LT]=0,Armour[LTr]=0, Destroy(LT);
if (Struct[RT] <= 0 && srt > 0 && Struct[RA] > 0) Sever(RA); // Arm Blown Off
if (Struct[LT] <= 0 && slt > 0 && Struct[LA] > 0) Sever(LA);
if (Struct[RA] <= 0 && sra > 0) Destroy(RA);
if (Struct[LA] <= 0 && sla > 0) Destroy(LA);
if (Struct[RL] <= 0 && srl > 0) { Destroy(RL); if (Position == 1) Fall(1); }
if (Struct[LL] <= 0 && sll > 0) { Destroy(LL); if (Position == 1) Fall(1); }

  if (Struct[RA] == 0) if (Struct[RA] == 0 && Struct[LA] == 0) readMechSprite(Index,3,SpriteName[Index]);
    else readMechSprite(Index,1,SpriteName[Index]);
  else if (Struct[LA] == 0) readMechSprite(Index,2,SpriteName[Index]);
  if (Status == Off) {
    readMechSprite(Index,7,SpriteName[Index]);
    readMechFallSprite(Index,6,SpriteName[Index]);}
  
return Loc;
}

int Mech::Destroy(int Loc) {
int i,j,Pos;
/*  for (i=0;i<CritSlot[Loc];i++)
    if (Crit[Loc][i].Class == 2) { // Ammo Critical
//      for (j=0;j<Ammunitions;j++)
//        if (Ammo[j].Loc == Loc && Ammo[j].Pos == i) Ammo[j].Ammo = 0;
//      Crit[Loc][i].Status = -1;
        }
        */
  Armour[Loc] = 0;
  Armour[Loc+7]=0; // Rear Armour
  Struct[Loc] = 0;

  for (i=0;i<CritSlot[Loc];i++) {
  Pos = i;
  j = Crit[Loc][Pos].State; // Ammo Catch
      Crit[Loc][Pos].State = -1; // Equipment OffLine

  switch (Crit[Loc][Pos].Class) {
  case 1: WeaponDisable(Loc,Crit[Loc][Pos].Type);break; // Weapons
//  case 2: AmmoExplosion(Loc,Pos);return 2; // Ammo
  case 2: AmmoState(AmmoTable[Crit[Loc][Pos].Type].AmmoType,j);
            Crit[Loc][Pos].State = -1; // Equipment OffLine
            break;
  case 3:// Equipment
    if (Crit[Loc][Pos].Type  == 0) // HeatSinks
      HeatSinks --;
    if (Crit[Loc][Pos].Type  == 1) // JumpJets
      Jump --;
    if (Crit[Loc][Pos].Type  == 3) // Artemis IV
      for (i=0;i<Weapons;i++)
        if (Weapon[i].Linked == 3 && Weapon[i].Loc == Loc) {
          Weapon[i].Linked = 0;
          Weapon[i].Cluster = 0;
          i+=Weapons; // Quit Loop
          }          
    if (Crit[Loc][Pos].Type  == 4) // Hatchet
      if (Loc == RA) RightHatchetType = 0;
        else
      if (Loc == LA) LeftHatchetType  = 0;

      break;
  case 4: // Equipment / Actuators
  if (Crit[Loc][Pos].Type  == 0) // Shoulder
       if (Loc == 4) RightArm.Shoulder = Off;
       else if (Loc == 5) LeftArm.Shoulder  = Off;
  if (Crit[Loc][Pos].Type  == 1) // Upper Arm
       if (Loc == 4) RightArm.UpperArm = Off;
       else if (Loc == 5) LeftArm.UpperArm  = Off;
  if (Crit[Loc][Pos].Type  == 2) // Lower Arm
       if (Loc == 4) RightArm.LowerArm = Off;
       else if (Loc == 5) LeftArm.LowerArm  = Off;
  if (Crit[Loc][Pos].Type  == 3) // Hand
       if (Loc == 4) RightArm.Hand = Off;
       else if (Loc == 5) LeftArm.Hand  = Off;
  if (Crit[Loc][Pos].Type  == 4) // Hip
       if (Loc == 6) RightLeg.Hip = Off;
       else if (Loc == 7) LeftLeg.Hip  = Off;
  if (Crit[Loc][Pos].Type  == 5) // Upper Leg
       if (Loc == 6) RightLeg.UpperLeg = Off;
       else if (Loc == 7) LeftLeg.UpperLeg  = Off;
  if (Crit[Loc][Pos].Type  == 6) // Lower Leg
       if (Loc == 6) RightLeg.LowerLeg = Off;
       else if (Loc == 7) LeftLeg.LowerLeg  = Off;
  if (Crit[Loc][Pos].Type  == 7) // Foot
       if (Loc == 6) RightLeg.Foot = Off;
       else if (Loc == 7) LeftLeg.Foot  = Off;

  if (Crit[Loc][Pos].Type  == 8) // Engine
       EngineHits ++;
  if (EngineHits >= 3) Immobile = On;
  if (Crit[Loc][Pos].Type  == 9) // Gyro
       { GyroHits ++; if (PilotingRoll < genPilotModifier()-Pilot.FallBonus) Fall(1); }
  if (Crit[Loc][Pos].Type  ==10) // Life Support
       LifeSupportHits ++;
  if (Crit[Loc][Pos].Type  ==12) // Sensors
       SensorHits ++;
  if (Crit[Loc][Pos].Type  ==11) // Cockpit
       Immobile = On, Pilot.Hits += 6,Status = Off; // Mech Destroyed
  if (Crit[Loc][Pos].Type  ==13) // XL Engine
       EngineHits ++;
     break;
  default :;break;
      }
    }

return 1;
}

int Mech::Sever(int Loc) {
int i;
  // Arm Droped, Create Item
  if (Items < ItemLimit) {

    sprintf(Item[Items].Name,"Arm");
    Item[Items].Type   = 1;
    Item[Items].Club   = 1;
    Item[Items].Armour = Armour[Loc];
    Item[Items].Struct = Struct[Loc];
    Item[Items].Vector = Vector;
    Item[Items].Colour = UnitColour;

    Items++;
    }
  // Deactivate all weapons in Location
  // Move To other Function later
//  for (i=0;i<Weapons;i++)
//    if (Weapon[i].Loc == Loc) Weapon[i].Status = -1;

  Destroy(Loc);
  Armour[Loc] = 0;
  Struct[Loc] = 0;

return 3;
}

int Mech::Critical(int Loc,int Modifier) {
//             0 1 2 3 4 5 6 7 8 91112
int CMP[13] = {0,0,0,0,0,0,0,1,1,2,2,3}; // Critical Hits
int Crits;
int pos;
int i,j,m;
char CritOffset;
char CritBank[30];
char String[40];

Loc = abs(Loc);

if (Options.CriticalHits == Off) return 0;

Crits = CMP[roll2d6 + Modifier];

 // Sever Limbs
if (Crits == 3 && Loc == RA) {
  sprintf(String,"Attack severs %s's %s",Name,LocationName[RA+1]); putString(String,Colour);
    getkey(); return Sever(RA); }
    
if (Crits == 3 && Loc == LA) {
  sprintf(String,"Attack severs %s's %s",Name,LocationName[LA+1]); putString(String,Colour);
    getkey(); return Sever(LA); }

if (Crits == 3 && Loc == RL) {
  sprintf(String,"Attack severs %s's %s",Name,LocationName[RL+1]); putString(String,Colour);
    getkey(); return Sever(RL); }

if (Crits == 3 && Loc == LL) {
  sprintf(String,"Attack severs %s's %s",Name,LocationName[LL+1]); putString(String,Colour);
    getkey(); return Sever(LL); }

if (Crits == 3 && Loc == HD) {
  sprintf(String,"Attack destroys %s's %s",Name,LocationName[HD+1]); putString(String,Colour);
    getkey(); return Destroy(HD); }

m = 1;

for (i=0;i<CritSlot[Loc];i++)
  for (j=0;j<Crit[Loc][m].Size;j++) {
  CritBank[m] = i;
  m ++;
  }

for (i=0;i<Crits;i++) {
//  pos = rolldx(CritSlot[Loc])-1;
  pos = CritBank[rolldx(m)];
  pos > 12? pos=12:pos;
  pos <  0? pos= 0:pos;
  CriticalDamage(Loc,pos);
  }

return Crits;
};

int Mech::CriticalDamage(int Loc, int Pos) {
int i,j;
  if (Pos < 0) Pos = 0;
  if (Pos > CritSlot[Loc]) Pos = CritSlot[Loc];

  if (Crit[Loc][Pos].State != -1)
    Crit[Loc][Pos].State = -1; // Equipment OffLine
  else return TransferCrit(Loc,Pos);

  switch (Crit[Loc][Pos].Class) {
  case 1: WeaponDisable(Loc,Crit[Loc][Pos].Type);return 1; // Weapons
  case 2: AmmoExplosion(Loc,Pos); return 2; // Ammo
  case 3:// Equipment
    if (Crit[Loc][Pos].Type  == 0) // HeatSinks
      HeatSinks --;
    if (Crit[Loc][Pos].Type  == 1) // JumpJets
      Jump --;
    if (Crit[Loc][Pos].Type  == 3) // Artemis IV
      for (i=0;i<Weapons;i++)
        if (Weapon[i].Linked == 3 && Weapon[i].Loc == Loc) {
          Weapon[i].Linked = 0;
          Weapon[i].Cluster = 0;
          i+=Weapons; // Quit Loop
          }          
    if (Crit[Loc][Pos].Type  == 4) // Hatchet
      if (Loc == RA) RightHatchetType = 0;
        else
      if (Loc == LA) LeftHatchetType  = 0;

      return 3;
  case 4: // Equipment / Actuators
  if (Crit[Loc][Pos].Type  == 0) // Shoulder
       if (Loc == 4) RightArm.Shoulder = Off;
       else if (Loc == 5) LeftArm.Shoulder  = Off;
  if (Crit[Loc][Pos].Type  == 1) // Upper Arm
       if (Loc == 4) RightArm.UpperArm = Off;
       else if (Loc == 5) LeftArm.UpperArm  = Off;
  if (Crit[Loc][Pos].Type  == 2) // Lower Arm
       if (Loc == 4) RightArm.LowerArm = Off;
       else if (Loc == 5) LeftArm.LowerArm  = Off;
  if (Crit[Loc][Pos].Type  == 3) // Hand
       if (Loc == 4) RightArm.Hand = Off;
       else if (Loc == 5) LeftArm.Hand  = Off;
  if (Crit[Loc][Pos].Type  == 4) // Hip
       if (Loc == 6) RightLeg.Hip = Off;
       else if (Loc == 7) LeftLeg.Hip  = Off;
  if (Crit[Loc][Pos].Type  == 5) // Upper Leg
       if (Loc == 6) RightLeg.UpperLeg = Off;
       else if (Loc == 7) LeftLeg.UpperLeg  = Off;
  if (Crit[Loc][Pos].Type  == 6) // Lower Leg
       if (Loc == 6) RightLeg.LowerLeg = Off;
       else if (Loc == 7) LeftLeg.LowerLeg  = Off;
  if (Crit[Loc][Pos].Type  == 7) // Foot
       if (Loc == 6) RightLeg.Foot = Off;
       else if (Loc == 7) LeftLeg.Foot  = Off;

  if (Crit[Loc][Pos].Type  == 8) // Engine
       EngineHits ++;
  if (EngineHits >= 3) Immobile = On;
  if (Crit[Loc][Pos].Type  == 9) // Gyro
       { GyroHits ++; if (PilotingRoll < genPilotModifier()-Pilot.FallBonus) Fall(1); }
  if (Crit[Loc][Pos].Type  ==10) // Life Support
       LifeSupportHits ++;
  if (Crit[Loc][Pos].Type  ==12) // Sensors
       SensorHits ++;
  if (Crit[Loc][Pos].Type  ==11) // Cockpit
       Immobile = On, Pilot.Hits += 6,Status = Off; // Mech Destroyed
  if (Crit[Loc][Pos].Type  ==13) // XL Engine
       EngineHits ++;
     return 4;
  default : ;break;
  };

return 0;
}

int Mech::TransferCrit(int Loc, int Pos) {
int i,j;

  for (i=Pos;i<CritSlot[Loc];i++) // Scrolls Down the crit Struct
    if (Crit[Loc][i].State != -1)
      return CriticalDamage(Loc,i);

  for (i=0;i<Pos;i++) // Scrolls Down the crit Struct from top
    if (Crit[Loc][i].State != -1)
      return CriticalDamage(Loc,i);

  i = TransferDamage[Loc];
  if (CritSlot[i] == 0)
    CriticalDamage(i,0);
    else
  if (i != -1)
    CriticalDamage(i,rolldx(CritSlot[i]));

//    CriticalDamage(i,j);

return 0;
}

int Mech::getSpeed(char a) {
int WP;
//int WP = Walk;
WP = Walk - HeatSlow[Heat];

if (RightLeg.Hip == Off && LeftLeg.Hip == Off)  // Leg Damage
  WP +=3, WP /= 4;
  else
  if (RightLeg.Hip == Off || LeftLeg.Hip == Off)  // Leg Damage
    WP ++, WP /= 2;
  else {
    if (RightLeg.UpperLeg == Off) WP --;
    if (RightLeg.LowerLeg == Off) WP --;
    if (RightLeg.Foot     == Off) WP --;
    if (LeftLeg.UpperLeg  == Off) WP --;
    if (LeftLeg.LowerLeg  == Off) WP --;
    if (LeftLeg.Foot      == Off) WP --;
      }

WP<=0?WP=0:WP;
TSMState==On?WP+=2:WP; // Engage TSM

if ((Struct[LL] == 0 || Struct[RL] == 0) && a > 0 ) return 1;

switch (a) {
case 0: return  0;
case 1: return  WP;
case 2: if(MASCState==On)return WP*2;
          else return int ( (WP * 1.5)+.5 );
case 3: if(Pilot.Sprint != On) return 0;
        if(MASCState==On)return int((WP * 2.5)+.5);
          else return WP*2;
case 4: if(Pilot.Evade  != On) return 0;
        if(MASCState==On)return WP*2;
          else return int ( (WP * 1.5)+.5 );
case-1: return Jump;

default:;break;
}
//int c = a>0?a>1?a>2?Sprint:Run : Walk :a<0?Jump:0; return c;
return WP;
};

int Mech::Club(class Unit *Target, int ClubType,int Arm) {
int Range, Modifier,r,loc,f;
int ToHit;
int PunchDamage;
char String[40];
int Table;
int AltDiff = Altitude - Target->Altitude + Size-1-Position  -Target->Size-1-Target->Position;
//Melee Weapon Types - 0 - None 1-Club 2-Hatchet 3-Sword 4-Mace 5-Claw
switch (ClubType) {
  case  NOMELEE: PunchDamage = ( Tons + 5 ) / 10;     ToHit = +0 ; break; // None
  case  CLUB   : PunchDamage = Tons / 5         ;     ToHit = -1 ; break; // Club
  case  HATCHET: PunchDamage = Tons / 5         ;     ToHit = -1 ; break; //Hatchet
  case  SWORD  : PunchDamage = ( Tons + 5 ) / 10 + 1; ToHit = -3 ; break; // Sword
  case  MACE   : PunchDamage = 2*Tons / 5      ;      ToHit = +1 ; break; //Mace
  case  CLAW   : PunchDamage = Tons / 5  /*Grapple*/; ToHit = +0 ; break; // Claw
  default: PunchDamage = ( Tons + 5 ) / 10;           ToHit = +0 ; break;
  }

if (Arm == RA || Arm == 0)
  if (RightArm.Shoulder == Off) ToHit += 4, PunchDamage /= 2;
    else
  if (RightArm.UpperArm == Off) ToHit += 2, PunchDamage /= 2;
    else
  if (RightArm.LowerArm == Off) ToHit += 2, PunchDamage /= 2;
    else
  if (RightArm.Hand     == Off) ToHit += 1;
if (Arm == LA || Arm == 0)
  if (LeftArm.Shoulder  == Off) ToHit += 4, PunchDamage /= 2;
    else
  if (LeftArm.UpperArm  == Off) ToHit += 2, PunchDamage /= 2;
    else
  if (LeftArm.LowerArm  == Off) ToHit += 2, PunchDamage /= 2;
    else
  if (LeftArm.Hand      == Off) ToHit += 1;

if (Submersed == On) PunchDamage /= 2;
if (TSMState  == On) PunchDamage *= 2;

Range = doLos(Vector.x,Vector.y,Target->Vector.x,Target->Vector.y);
Modifier = ProcLOSstrALT (LOSstring,Altitude,Position+1,Target->Altitude,Target->Position+1);

ToHit += Pilot.Piloting;
ToHit += Modifier;
if (MoveType >= 0) ToHit += MoveType;
else ToHit += 3; // Jumping Mechs
ToHit += TargetEvasion [ Target->HexesMoved ];
ToHit += HeatAcc [ Heat ];
if (Target->Immobile == On)
  ToHit += -4;

if (Target->Position == 0)
  if (Range == 1)
    ToHit += -1; // If unit prone and close, easier to-hit
  else
    ToHit +=  1; // If unit prone and far, tougher to-hit

r = PilotingRoll;
f = getFacing(getDamageAngle(Vector,Target->Vector));
loc = PunchLoc[f][rolld6];
// Can't Punch Above
if (AltDiff == 0) // Face To Face
  if (Options.ClubHitsPunch == On) Table = FrontPunch + f,loc = PunchLoc[f][rolld6];
    else Table = FrontHit + f,loc = HitLoc[f][roll2d6];
  else
if (AltDiff ==  1) // Face To Face
  if (Options.ClubHitsPunch == On) Table = FrontPunch + f,loc = PunchLoc[f][rolld6];
    else Table = FrontHit + f,loc = HitLoc[f][roll2d6];
  else
if (AltDiff == -1) { // Face To Foot
  Table = FrontKick + f,loc = KickLoc[f][rolld6];
  if (Target->Position == 0)
    Table = FrontHit + f,loc = HitLoc[f][roll2d6]; }
  else
  loc = -2; // Wrong Altitude - No Damage

if (PilotingRoll >= ToHit && loc != -2) {
  if (Options.SimultaneousPhysicalAttacks == On) {
    PhysAttack[PhysAttacks].Target = Target->Index;
    PhysAttack[PhysAttacks].Damage = PunchDamage;
    PhysAttack[PhysAttacks].Group  = PunchDamage;
    PhysAttack[PhysAttacks].Table  = Table;
    PhysAttack[PhysAttacks].Fall   = 0;
    PhysAttacks ++;
    }
  else
    Target->Damage( loc , f ,PunchDamage);
  if (Target->Type != MECH) sprintf(String,"%s Connects ! ",MeleeWeapon[ClubType]);
  else sprintf(String,"%s Connects >> %s ",MeleeWeapon[ClubType],LocationName[loc+1]);
  }
  else
    sprintf(String,"%s Missed ",MeleeWeapon[ClubType]);

putString(String,Colour);
getkey();
return 0;
}

int Mech::Punch(class Unit *Target, int Arm) {
int Range, Modifier,r,loc,f;
int ToHit;
int PunchDamage;
int AltDiff = Altitude - Target->Altitude + Size-1-Position  -Target->Size-1-Target->Position;
int Table;
char String[40];
PunchDamage = ( Tons + 5 ) / 10;

if (Submersed == On) PunchDamage /= 2;
if (TSMState  == On) PunchDamage *= 2;

Range = doLos(Vector.x,Vector.y,Target->Vector.x,Target->Vector.y);
Modifier = ProcLOSstrALT (LOSstring,Altitude,Position+1,Target->Altitude,Target->Position+1);

ToHit  = Pilot.Piloting -1;
ToHit += Modifier;
if (MoveType >= 0) ToHit += MoveType;
else ToHit += 3; // Jumping Mechs
ToHit += TargetEvasion [ Target->HexesMoved ];
ToHit += HeatAcc [ Heat ];
if (Target->Immobile == On)
  ToHit += -4;

if (Target->Position == 0)
  if (Range == 1)
    ToHit += -1; // If unit prone and close, easier to-hit
  else
    ToHit +=  1; // If unit prone and far, tougher to-hit

if (Arm == RA)
  if (RightArm.Shoulder == Off) ToHit += 4, PunchDamage /= 2;
    else
  if (RightArm.UpperArm == Off) ToHit += 2, PunchDamage /= 2;
    else
  if (RightArm.LowerArm == Off) ToHit += 2, PunchDamage /= 2;
    else
  if (RightArm.Hand     == Off) ToHit += 1;
else
  if (LeftArm.Shoulder  == Off) ToHit += 4, PunchDamage /= 2;
    else
  if (LeftArm.UpperArm  == Off) ToHit += 2, PunchDamage /= 2;
    else
  if (LeftArm.LowerArm  == Off) ToHit += 2, PunchDamage /= 2;
    else
  if (LeftArm.Hand      == Off) ToHit += 1;

r = PilotingRoll;
f = getFacing(getDamageAngle(Vector,Target->Vector));

// Can't Punch Above
if (AltDiff == 0) // Face To Face
  Table = FrontPunch + f, loc = PunchLoc[f][rolld6];
  else
if (AltDiff == -1) { // Face To Foot
  Table = FrontKick + f , loc = KickLoc[f][rolld6];
  if (Target->Position == 0)
    Table = FrontHit + f, loc = HitLoc[f][rolld6]; }
  else
  loc = -2; // Wrong Altitude - No Damage
  
if (r >= ToHit && loc != -2) {
  if (Options.SimultaneousPhysicalAttacks == On) {
    PhysAttack[PhysAttacks].Target = Target->Index;
    PhysAttack[PhysAttacks].Damage = PunchDamage;
    PhysAttack[PhysAttacks].Group  = PunchDamage;
    PhysAttack[PhysAttacks].Table  = Table;
    PhysAttack[PhysAttacks].Fall   = 0;
    PhysAttacks ++;
    }
  else
    Target->Damage( loc , f ,PunchDamage);
  if (Target->Type != MECH) sprintf(String,"Punch Connects !");
  else sprintf(String,"Punch Connects >> %s ",LocationName[loc+1]);
  }
  else
  sprintf(String,"Punch Missed ");

  putString(String,Colour);
//  getch();
getkey();
return 0;
}

int Mech::Kick(class Unit *Target) {
int Range, Modifier,r,loc,f;
int ToHit;
int KickDamage;
int AltDiff = Altitude - Target->Altitude;
int Table;
char String[40];

KickDamage =  Tons/5;

if (Submersed == On) KickDamage /= 2;
if (TSMState  == On) KickDamage *= 2;
if (Position  == 0 ) return 0;       // Can't kick while prone

Range = doLos(Vector.x,Vector.y,Target->Vector.x,Target->Vector.y);
Modifier = ProcLOSstrALT (LOSstring,Altitude,Position+1,Target->Altitude,Target->Position+1);

ToHit  = Pilot.Piloting -1;
ToHit += Modifier;
//if (MoveType >= 0) ToHit += MoveType;
//else ToHit += 3; // Jumping Mechs
ToHit += TargetEvasion [ Target->HexesMoved ];
ToHit += HeatAcc [ Heat ];
if (Target->Immobile == On)
  ToHit += -4;

if (Target->Position == 0)
  if (Range == 1)
    ToHit += -1; // If unit prone and close, easier to-hit
  else
    ToHit +=  1; // If unit prone and far, tougher to-hit

  if (LeftLeg.Hip       == Off || RightLeg.Hip       == Off) ToHit += 4, KickDamage /= 2;
    else
  if (LeftLeg.UpperLeg  == Off || RightLeg.UpperLeg  == Off) ToHit += 2, KickDamage /= 2;
    else
  if (LeftLeg.LowerLeg  == Off || RightLeg.LowerLeg  == Off) ToHit += 2, KickDamage /= 2;
    else
  if (LeftLeg.Foot      == Off || RightLeg.Foot      == Off) ToHit += 1;

r = PilotingRoll;
f = getFacing(getDamageAngle(Vector,Target->Vector));
loc = KickLoc[f][rolld6];

// Can't Kick Above
if (AltDiff+Size-Target->Size == 0) { // Foot To Foot
  Table = FrontKick + f,loc = KickLoc[f][rolld6];
  if (Target->Position == 0)
    Table = FrontHit + f,loc = HitLoc[f][rolld6];
  }
  else
if (AltDiff+Size-Target->Size == 1) // Foot To Face
  Table = FrontPunch + f,loc = PunchLoc[f][rolld6];
  else
  loc = -2; // Wrong Altitude - No Damage

if (PilotingRoll >= ToHit && loc!=-2) {
  if (Options.SimultaneousPhysicalAttacks == On) {
    PhysAttack[PhysAttacks].Target = Target->Index;
    PhysAttack[PhysAttacks].Damage = KickDamage;
    PhysAttack[PhysAttacks].Group  = KickDamage;
    PhysAttack[PhysAttacks].Table  = Table;
    PhysAttack[PhysAttacks].Fall   = 0;
    PhysAttacks ++;
    }
  else
  Target->Damage(loc, f ,KickDamage);
  if (Target->Type != MECH) sprintf(String,"Kick Connects !");
  else sprintf(String,"Kick Connects >> %s",LocationName[loc+1]);

  }
  else {
  sprintf(String,"Kick Misses ");
  if (PilotingRoll<genPilotModifier()-Pilot.FallBonus) Fall(Altitude);
  }

  putString(String,Colour);
  getkey();

return 0;
}

int Mech::Fall(int Height) {
// Unit Falls Down
char String[40];
int FallDamage,i;
int Levels = MPH[Map.Hex[Vector.x][Vector.y].Alt] - Height + Position; // Level
(Submersed==On||Map.Hex[Vector.x][Vector.y].Type=='w') ? FallDamage = (Tons * Levels) / 10 : FallDamage = Tons / 20;
if (Position == 0) return 0; // Only fall once
Position = 0;
MP = 0;      // If during Movement Phase, no more MP
//Vector.head = rolld6*60 + 30;
// Should be random facing
for (i=0;i<FallDamage-5;i+=5)
  Damage(HitLoc[0][roll2d6],0,5); // Distribute damage in 5 point clusters

  Damage(HitLoc[0][roll2d6],0,FallDamage%5); // Allocate Remaining;

if (Pilot.Piloting > roll2d6) { // If Piloting roll fails, pilot takes a hit
  Pilot.Hits ++;
  ConcRoll();
  }

//Battlemech carrying Infantry
  if (Carrying >= 0) // Battlemech Carrying a unit
    if (unit[Carrying]->Side != Side && unit[Carrying]->Type == INFANTRY)
      unit[Carrying]->Drop(11); // Infantry Drops off into hex

Vector.head = ((rolld6 - 1) * 60) + 30;
Altitude = MPH[Map.Hex[Vector.x][Vector.y].Alt];
//drawHex (Vector.x,Vector.y);
drawUnit(1);

sprintf(String,"%s falls down!",Name);
putString(String,Colour);
getkey();
return 0;
}

int Mech::Stand() {
// Unit Stands Down
char String[40];
Position = 1;
int MPO = MP - 2;      // If during Movement Phase, no more MP
//Vector.head = rolld6*60 + 30;

if (PilotingRoll >= genPilotModifier()-Pilot.StandBonus) {

//  drawHex (Vector.x,Vector.y);
  drawUnit(1);

  sprintf(String,"%s Stands Up!",Name);
  putString(String,Colour);  
//  getkey();
  } else Fall(1);
  MP = MPO;

return 0;
}

int Mech::Prone() {
// Unit goes down
char String[40];
Position = 0;
MP -= 1;      // If during Movement Phase

  drawUnit(1);

  sprintf(String,"%s Goes Prone",Name);
  putString(String,Colour);  
  getkey();

// Battlemech Carrying Infantry
  if (Carrying >= 0) // Battlemech Carrying a unit
    if (unit[Carrying]->Side != Side && unit[Carrying]->Type == INFANTRY)
      if (PilotingRoll >= genPilotModifier())
        unit[Carrying]->Drop(0); // Infantry Drops off into hex
      else
        Fall(1); // Mech falls down (goes boom)

return 0;
}

int Mech::Push(class Unit *Target) {
int Range, Modifier,r,loc,f;
int ToHit;
char String[40];
Range = doLos(Vector.x,Vector.y,Target->Vector.x,Target->Vector.y);
Modifier = ProcLOSstrALT (LOSstring,Altitude,Position,Target->Altitude,Target->Position);

ToHit  = Pilot.Piloting -1;
ToHit += Modifier;
if (MoveType >= 0) ToHit += MoveType;
else ToHit += 3; // Jumping Mechs
ToHit += TargetEvasion [ Target->HexesMoved ];
ToHit += HeatAcc [ Heat ];
if (Target->Immobile == On)
  ToHit += -4;

if (Target->Position == 0)
  if (Range == 1)
    ToHit += -1; // If unit prone and close, easier to-hit
  else
    ToHit +=  1; // If unit prone and far, tougher to-hit

if (PilotingRoll >= ToHit) {

  if (Options.ChargeMoves == 1)
    if(Target->Shoved(Vector.head) == On)
      Forward();


  sprintf(String,"Push Connects");
  putString(String,Colour);

  ToHit = genPilotModifier(); // Falling

  if (PilotingRoll < Target->genPilotModifier()-Target->Pilot.FallBonus)
    if (Options.SimultaneousPhysicalAttacks == On) {
      PhysAttack[PhysAttacks].Target = Target->Index;
      PhysAttack[PhysAttacks].Damage = 0;
      PhysAttack[PhysAttacks].Group  = 0;
      PhysAttack[PhysAttacks].Table  = FrontHit+f;
      PhysAttack[PhysAttacks].Fall   = 0;
      PhysAttack[PhysAttacks].Fall = Target->Altitude+Target->Position + 1;
      PhysAttacks++;
      }
    else
      Target->Fall(1);

  }
  else {
  sprintf(String,"Push Missed ");
  putString(String,Colour);
  }

getkey();
return 0;
}

int Mech::Charge(class Unit *Target) {
int Range, Modifier,r,loc,i,f;
int ToHit;
int ChargeDamage = (HexesMoved * Tons) / 10;
int ImpactDamage = Target->getTons() / 10;
char String[40];
Range = doLos(Vector.x,Vector.y,Target->Vector.x,Target->Vector.y);
Modifier = ProcLOSstrALT (LOSstring,Altitude,Position,Target->Altitude,Target->Position);

ToHit  = Pilot.Piloting -1;
ToHit += Modifier;
if (MoveType >= 0) ToHit += MoveType;
else ToHit += 3; // Jumping Mechs
ToHit += TargetEvasion [ Target->HexesMoved ];
ToHit += HeatAcc [ Heat ];
if (Target->Immobile == On)
  ToHit += -4;

if (Target->Position == 0)
  if (Range == 1)
    ToHit += -1; // If unit prone and close, easier to-hit
  else
    ToHit +=  1; // If unit prone and far, tougher to-hit

if (PilotingRoll >= ToHit) { // Charge Hits

  if (Options.ChargeMoves == 1) {
      Target->Shoved(Vector.head);
      Forward();
      }

  sprintf(String,"Charge Connects");
  putString(String,Colour);
  getkey();

  Damage(RA,0,ImpactDamage);
  Damage(LA,0,ImpactDamage);



  f = getFacing(getDamageAngle(Vector,Target->Vector));
  if (Options.SimultaneousPhysicalAttacks == On) {
    PhysAttack[PhysAttacks].Target = Target->Index;
    PhysAttack[PhysAttacks].Damage = ChargeDamage;
    PhysAttack[PhysAttacks].Group  = 5;
    PhysAttack[PhysAttacks].Table  = FrontHit+f;
    PhysAttack[PhysAttacks].Fall   = 0;

    if (PilotingRoll >= Target->genPilotModifier()-Target->Pilot.FallBonus)
    PhysAttack[PhysAttacks].Fall = Target->Altitude+Target->Position + 1;

    PhysAttacks ++;
    }
    else {
  for (i=0;i<ChargeDamage-5;i+=5)
    Target->Damage(HitLoc[f][roll2d6],f,5); // Distribute damage in 5 point clusters

    Target->Damage(HitLoc[f][roll2d6],f,ChargeDamage%5); // Allocate Remaining;

  if (PilotingRoll >= Target->genPilotModifier()-Target->Pilot.FallBonus)
    Target->Fall(Target->Altitude+Target->Position);

    }
  }
  else {
  sprintf(String,"Charge Missed ");
  putString(String,Colour);
  getkey();

  ToHit = genPilotModifier(); // Falling

  if (PilotingRoll >= ToHit-Pilot.FallBonus)
    Fall(1);
  }

getkey();
return 0;
}

int Mech::DFA(class Unit *Target) {
int Range, Modifier,r,loc,i,f;
int ToHit;
int DFADamage = (3 * Tons) / 10;
int ImpactDamage = Tons / 10;
char String[40];
Range = doLos(Vector.x,Vector.y,Target->Vector.x,Target->Vector.y);
Modifier = ProcLOSstrALT (LOSstring,Altitude,Position,Target->Altitude,Target->Position);

ToHit  = Pilot.Piloting -1;
ToHit += Modifier;
if (MoveType >= 0) ToHit += MoveType;
else ToHit += 3; // Jumping Mechs
ToHit += TargetEvasion [ Target->HexesMoved ];
ToHit += HeatAcc [ Heat ];
if (Target->Immobile == On)
  ToHit += -4;

if (Target->Position == 0)
  if (Range == 1)
    ToHit += -1; // If unit prone and close, easier to-hit
  else
    ToHit +=  1; // If unit prone and far, tougher to-hit

if (PilotingRoll >= ToHit) { // DFA Connects

  if (Options.ChargeMoves == 1) {
      Target->Shoved(Vector.head);
      Forward();
      }

  sprintf(String,"DFA Connects");
  putString(String,Colour);
  getkey();

  f = getFacing(getDamageAngle(Vector,Target->Vector));

  if (Options.SimultaneousPhysicalAttacks == On) {
    PhysAttack[PhysAttacks].Target = Target->Index;
    PhysAttack[PhysAttacks].Damage = DFADamage;
    PhysAttack[PhysAttacks].Group  = 5;
    PhysAttack[PhysAttacks].Table  = FrontPunch+f;
    PhysAttack[PhysAttacks].Fall   = 0;

    if (Options.SimultaneousPhysicalAttacks == On)
      PhysAttack[PhysAttacks].Fall = Target->Altitude+Target->Position + 1;

    PhysAttacks ++; }
  else {
  for (i=0;i<DFADamage-5;i+=5)
    Target->Damage(PunchLoc[f][rolld6],f,5); // Distribute damage in 5 point clusters

    Target->Damage(PunchLoc[f][rolld6],f,DFADamage%5); // Allocate Remaining;

    if (PilotingRoll < Target->genPilotModifier()+4-Target->Pilot.FallBonus)
      Target->Fall(1);

    }

  }
  else {
  sprintf(String,"DFA Missed ");
  putString(String,Colour);
  getkey();

  if (PilotingRoll < genPilotModifier()+2-Target->Pilot.FallBonus)
    Fall(1);

  }

return 0;
}

int Mech::Shoved(int Angle) {
int newHead, oldHead;

  newHead = Angle;
//  newHead = getAttackAngle(Vector,Target->Vector)+Vector.head; // Get Angle of Pushed Mech
  oldHead = Vector.head;
  Vector.head = newHead;

int mpc;
int i, o, k;
int x,y,Move = On, dam;
int BuildingHeight = 0;
int BuildingModifier = 0;
x = Vector.x + vec[Vector.head/30].x;
y = Vector.y + vec[Vector.head/30].y;

// if (AdvanceOpen())
// AdvanceOpen
for (i=0;i<Units;i++)
  if ( (x == unit[i]->Vector.x && \
        y == unit[i]->Vector.y ) ) {
	Move = Off;
        }

  // Hex Open, Unit can Advance
if (x<Xmin || x > Xmax) { // Mech Out Off bounds
  Move = Off; // Add King of the Ring
  if(Options.Retreat==On) Retreat(); }

if (y<Ymin || y > Ymax) { // Mech Out Off bounds
  Move = Off; // Add King of the Ring
  if(Options.Retreat==On) Retreat(); }

// Buildings
  if (Map.Hex[x][y].Type == 'L') BuildingModifier = 1, BuildingHeight = 1;
  if (Map.Hex[x][y].Type == 'M') BuildingModifier = 2, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'H') BuildingModifier = 3, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'A') BuildingModifier = 5, BuildingHeight = 3;

  if (BuildingModifier != 0 && MoveType >= 0) // Buildings on Foot
      Move = Off;
// Water Submersion
  if (Position+1 <= - MPH[Map.Hex[Vector.x][Vector.y].Alt] && Map.Hex[Vector.x][Vector.y].Type == 'w') Submersed = On;
    else Submersed = Off;

if (Move == On) {

  mpc = MPC[Map.Hex[x][y].Type];
  if (onRiver(x,y)) mpc ++;
  if (onRoad(Vector.x,Vector.y) && onRoad(x,y))
    mpc = 1, BuildingHeight = (RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt])>=0?(RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt]):0;
  /*
  if (onRoad(Vector.x,Vector.y) && onRoad(x,y))
    mpc = 1, OnRoad = On, BuildingHeight = (RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt])>=0?(RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt]):0;
  else
    OnRoad = Off;
  */
//  mpc += abs(MPH[Map.Hex[Vector.x][Vector.y].Alt] - MPH[Map.Hex[x][y].Alt]);
  mpc += abs(Altitude - MPH[Map.Hex[x][y].Alt]-BuildingHeight);
  Altitude = MPH[Map.Hex[x][y].Alt] + BuildingHeight;

  if (Map.Hex[x][y].Fire == 'f' || Map.Hex[x][y].Fire == 'F')
    HeatTurn += 2;

    drawHex(Vector.x,Vector.y);
    Vector.x = x;
    Vector.y = y;
    Vector.head = oldHead;
    drawUnit(0);
  
    if (Holding >= 0) Item[Holding].Vector = Vector; // If Mech moves, Item moves with it
    if (MoveType >= 0 && Map.Hex[x][y].Type == 'w' && PilotingRoll < (genPilotModifier()-1-Pilot.FallBonus )) Fall(0); // Mech can fall if it enters water hex

  }

return Move;
}

int Mech::Forward() {

int mpc;
int i, o, k;
int x,y,Move = On, dam;
int BuildingHeight = 0;
int BuildingModifier = 0;
x = Vector.x + vec[Vector.head/30].x;
y = Vector.y + vec[Vector.head/30].y;

// if (AdvanceOpen())
// AdvanceOpen
for (i=0;i<Units;i++)
  if ( (x == unit[i]->Vector.x && \
        y == unit[i]->Vector.y ) ) {
	Move = Off;
        }

  // Hex Open, Unit can Advance
if (x<=Xmin || x >= Xmax) { // Mech Out Off bounds
  Move = Off;
  if(Options.Retreat==On) Retreat(); }

if (y<=Ymin || y >= Ymax) { // Mech Out Off bounds
  Move = Off;
  if(Options.Retreat==On) Retreat(); }

  if(MoveType<0) // If a Mech is Jumping, can't Jump over obstacle
    if(Altitude+Jump < MPH[Map.Hex[x][y].Alt])
      Move = Off;

// Buildings
  if (Map.Hex[x][y].Type == 'L') BuildingModifier = 1, BuildingHeight = 1;
  if (Map.Hex[x][y].Type == 'M') BuildingModifier = 2, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'H') BuildingModifier = 3, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'A') BuildingModifier = 5, BuildingHeight = 3;

  if (BuildingModifier != 0 && MoveType >= 0) // Buildings on Foot
      Move = Off;
// Water Submersion
  if (Position+1 <= - MPH[Map.Hex[Vector.x][Vector.y].Alt] && Map.Hex[Vector.x][Vector.y].Type == 'w') Submersed = On;
    else Submersed = Off;

  if (MPC[Map.Hex[x][y].Type] == 20 && MoveType>=0) // Impassable by Foot
    Move=Off;

if (Move == On) {

  mpc = MPC[Map.Hex[x][y].Type];
  if (onRiver(x,y)) mpc ++;
  if (onRoad(Vector.x,Vector.y) && onRoad(x,y))
    mpc = 1, BuildingHeight = (RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt])>=0?(RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt]):0;

//  mpc += abs(MPH[Map.Hex[Vector.x][Vector.y].Alt] - MPH[Map.Hex[x][y].Alt]);
  mpc += abs(Altitude - MPH[Map.Hex[x][y].Alt]-BuildingHeight);

  MoveType< 0?mpc =1:mpc; // If a Mech is Jumping, only one MP / HEX

  if (mpc <= 2) { // Can't advance if terrain to difficult

//    if (onRoad(x,y)) OnRoad = On;
//      else OnRoad = Off;

    Altitude = MPH[Map.Hex[x][y].Alt] + BuildingHeight;
    if (Map.Hex[x][y].Fire == 'f' || Map.Hex[x][y].Fire == 'F')
      HeatTurn += 2;

  if (Vector.x - scrollx <= MapWidth)
    drawHex(Vector.x,Vector.y);
    Vector.x = x;
    Vector.y = y;

    if (Holding  >= 0) Item[Holding ].Vector  = Vector; // If Mech moves, Item moves with it
    if (Carrying >= 0) unit[Carrying]->Vector = Vector; // If Mech moves, Carried unit moves with it

    drawUnit(0);

    if (Map.Hex[x][y].Fire == 'f' || Map.Hex[x][y].Fire == 'F')
      HeatTurn += 2;

    if (MoveType >= 0 && Map.Hex[x][y].Type == 'w' && PilotingRoll < (genPilotModifier()-1-Pilot.FallBonus)) Fall(0); // Mech can fall if it enters water hex

    }
  }

return 1;
}

int Mech::ConcRoll () {
int MechWar[8] = {0,3,5,7,10,11,13,0x0000};

  if (roll2d6 >= MechWar[Pilot.Hits]);// Pilot.Conscious = On,Pilot.Stun = 0;
    else Pilot.Conscious = Off, Immobile = On,Pilot.Stun = 1;

  if (ShutDown == 0 && Pilot.Conscious == On) Immobile = Off;

  if (Pilot.Hits >= Pilot.Build)
    Status = Off,Pilot.Conscious = Off, Immobile = On;

return 0;
}

int Mech::Advance()
{
int mpc;
int i, o, k;
int x,y,Move = On, dam;
int BuildingHeight = 0;
int BuildingModifier = 0;

x = Vector.x + vec[Vector.head/30].x;
y = Vector.y + vec[Vector.head/30].y;

// if (AdvanceOpen())
// AdvanceOpen
int UnitsInHex=0;
for (i=0;i<Units;i++)
  if ( (x == unit[i]->Vector.x && \
        y == unit[i]->Vector.y ) ) {
        UnitsInHex ++;
        if (Options.Stacking==On)
          if (unit[i]->Side!=Side&&unit[i]->Type<INFANTRY&&MoveType>=0)
   	    Move = Off; // Can't stack with an enemy on the ground
          else {
            if (Stacked == Off)
              LastVector = Vector;              
            Stacked = On;
            }
        }

// Max Units in hex
//if (UnitsInHex >= 5) Move = Off, Stacked = Off;

  // Hex Open, Unit can Advance
if (x<Xmin || x >= Xmax) // Mech Out Off bounds
  {Move = Off;MP = 0;
  if(Options.Retreat==On) Retreat(); }

if (y<Ymin || y >= Ymax) // Mech Out Off bounds
  {Move = Off;MP = 0;
  if(Options.Retreat==On) Retreat(); }

  if(MoveType<0) // If a Mech is Jumping, can't Jump over obstacle
    if(Altitude+Jump < MPH[Map.Hex[x][y].Alt])
      Move = Off;

// Buildings
  if (Map.Hex[x][y].Type == 'L') BuildingModifier = 1, BuildingHeight = 1;
  if (Map.Hex[x][y].Type == 'M') BuildingModifier = 2, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'H') BuildingModifier = 3, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'A') BuildingModifier = 5, BuildingHeight = 3;

  if (BuildingModifier != 0 && MoveType >= 0) // Buildings on Foot
    if (PilotingRoll >= genPilotModifier()+BuildingModifier) {
      Move = On;
        if (Tons > Map.Hex[x][y].Index) DamageHex(x,y,Map.Hex[x][y].Index), BuildingHeight = 0;}
      else Move = Off;
// BuildingDamage
// Water Submersion
  if (Position+1 <= - MPH[Map.Hex[Vector.x][Vector.y].Alt] && Map.Hex[Vector.x][Vector.y].Type == 'w') Submersed = On;
    else Submersed = Off;

  if (MPC[Map.Hex[x][y].Type] == 20 && MoveType>=0) // Impassable by Foot
    Move=Off;
  if (Options.AltChangeLimit == On) // Limit Altitude change per hex
    if (abs(Altitude - MPH[Map.Hex[x][y].Alt]-BuildingHeight) > 2)
      Move=Off;

  if (Options.RunInWater == Off)
  if (MoveType >= 1)
    if (Map.Hex[x][y].Type == 'w' && MPH[Map.Hex[x][y].Alt] > '0') Move = Off; // If water deeper then a number

if (Move == On) {

  mpc = MPC[Map.Hex[x][y].Type];
  if (onRiver(x,y)) mpc ++;
  if (onRoad(Vector.x,Vector.y) && onRoad(x,y))
    mpc = 1, BuildingHeight = (RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt])>=0?(RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt]):0;

//  mpc += abs(MPH[Map.Hex[Vector.x][Vector.y].Alt] - MPH[Map.Hex[x][y].Alt]);
  mpc += abs(Altitude - MPH[Map.Hex[x][y].Alt]-BuildingHeight);

  MoveType< 0?mpc =1:mpc; // If a Mech is Jumping, only one MP / HEX
  Position==0?mpc+=4:mpc; // If Mech is Prone, crawl costs 4 MP

  Submersed==On?mpc+=4:mpc; // If Mech under water

  if (MoveType < 0 && Jump >= MPH[Map.Hex[x][y].Alt]+BuildingHeight - Altitude) mpc = 1;

  if (HexesMoved == 0 || MP >= mpc) { // Can't advance if Mech lacks MP

    Altitude = MPH[Map.Hex[x][y].Alt] + BuildingHeight;
    if (Map.Hex[x][y].Fire == 'f' || Map.Hex[x][y].Fire == 'F')
      HeatTurn += 2;

  if (Vector.x - scrollx <= MapWidth)
    drawHex(Vector.x,Vector.y);

    Vector.x = x;
    Vector.y = y;

    if (Holding  >= 0) Item[Holding ].Vector  = Vector; // If Mech moves, Item moves with it
    if (Carrying >= 0) unit[Carrying]->Vector = Vector; // If Mech moves, Carried unit moves with it

  if (UnitsInHex == 0) {
    if (Stacked == On)
      drawUnits();
      Stacked = Off;
      }

  if (MoveType >= 1)
    if ((Map.Hex[x][y].Type == 'w') && (PilotingRoll < (genPilotModifier()-1))) putString("Slid Fall",Colour),Fall(0); // Mech can fall if it enters water hex

    drawUnit(0);

    MP -= mpc;
    HexesMoved ++;
    }
    else Move = Off; // Not Enough MP
  }

HullIntegrity();
return Move;
}


int Mech::Reverse()
{
int mpc;
int i, o, k;
int x,y,Move = On, dam;
int BuildingHeight = 0;
int BuildingModifier = 0;
mpc = MPH[Map.Hex[Vector.x][Vector.y].Alt];
i = Vector.head + 180;
if (i > 360) i -= 360;
if (i <   0) i += 360;
x = Vector.x + vec[i/30].x;
y = Vector.y + vec[i/30].y;

 // if (AdvanceOpen())
// AdvanceOpen
if (MoveType == 1) {
int UnitsInHex=0;
for (i=0;i<Units;i++)
  if ( (x == unit[i]->Vector.x && \
        y == unit[i]->Vector.y ) ) {
        UnitsInHex ++;
        if (Options.Stacking==On)
          if (unit[i]->Side!=Side&&MoveType>=0)
   	    Move = Off; // Can't stack with an enemy on the ground
          else {
            if (Stacked == Off)
              LastVector = Vector;              
            Stacked = On;
            }
        }

  // Hex Open, Unit can Advance

if (x<=Xmin || x >= Xmax) { // Mech Out Off bounds
  Move = Off,MP = 0;
  if(Options.Retreat==On) Retreat(); }

if (y<=Ymin || y >= Ymax) { // Mech Out Off bounds
  Move = Off,MP = 0;
  if(Options.Retreat==On) Retreat(); }

  if(MoveType<0) // If a Mech is Jumping, can't Jump over obstacle
    if(Altitude+Jump < MPH[Map.Hex[x][y].Alt])
      Move = Off;

// Buildings
  if (Map.Hex[x][y].Type == 'L') BuildingModifier = 1, BuildingHeight = 1;
  if (Map.Hex[x][y].Type == 'M') BuildingModifier = 2, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'H') BuildingModifier = 3, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'A') BuildingModifier = 5, BuildingHeight = 3;

  if (BuildingModifier != 0 && MoveType >= 0) // Buildings on Foot
      Move = Off;

// Water Submersion
  if (Position+1 <= - MPH[Map.Hex[Vector.x][Vector.y].Alt] && Map.Hex[Vector.x][Vector.y].Type == 'w') Submersed = On;
    else Submersed = Off;

  if (MPC[Map.Hex[x][y].Type] == 20 && MoveType>=0) // Impassable by Foot
    Move=Off;

if (Move == On) {

  mpc = MPC[Map.Hex[x][y].Type];
  if (onRiver(x,y)) mpc ++;
  if (onRoad(Vector.x,Vector.y) && onRoad(x,y))
    mpc = 1, BuildingHeight = (RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt])>=0?(RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt]):0;
    
//  mpc += abs(MPH[Map.Hex[Vector.x][Vector.y].Alt] - MPH[Map.Hex[x][y].Alt]);
  mpc += abs(Altitude - MPH[Map.Hex[x][y].Alt]-BuildingHeight);

  MoveType< 0?mpc =1:mpc; // If a Mech is Jumping, only one MP / HEX
  Position==0?mpc+=4:mpc; // If Mech is Prone, crawl costs 4 MP
  Submersed==On?mpc+=4:mpc; // If Mech under water

  if (HexesMoved == 0 || MP >= mpc) { // Can't advance if Mech lacks MP, MPC of 20 denotes Impassable

    Altitude = MPH[Map.Hex[x][y].Alt] + BuildingHeight;
    if (Map.Hex[x][y].Fire == 'f' || Map.Hex[x][y].Fire == 'F')
      HeatTurn += 2;

  if (Vector.x - scrollx <= MapWidth)
    drawHex(Vector.x,Vector.y);
    Vector.x = x;
    Vector.y = y;

    if (Holding  >= 0) Item[Holding ].Vector  = Vector; // If Mech moves, Item moves with it
    if (Carrying >= 0) unit[Carrying]->Vector = Vector; // If Mech moves, Carried unit moves with it

    if (UnitsInHex == 0) {
      if (Stacked == On)
        for (i=0;i<Units;i++)
          unit[i]->drawUnit(0);
        Stacked = Off;
        }

    drawUnit(0);

    if (Map.Hex[x][y].Type == 'w' && PilotingRoll < (genPilotModifier()-1-Pilot.FallBonus)) Fall(0); // Mech can fall if it enters water hex

    MP -= mpc;
    HexesMoved ++;
    Reversed ++;
    }
    else Move = Off;
  }
}
//  else Charge(Unit[i])

return Move;
}

int Mech::TurnLeft()
{
if (onRoad(Vector.x,Vector.y) == On && RoadHeight(Vector.x,Vector.y) == Altitude && MoveType >= 2)
  if (PilotingRoll < genPilotModifier()+TargetEvasion[HexesMoved]-1) Skid();

Vector.head -= 60;
if (Vector.head < 0) Vector.head += 360;
if (MP > 0) MoveType < 0 ? MP : MP -= 1; // If unit Jumps no MP cost

  drawHex(Vector.x,Vector.y);
  drawUnit(0);

return 1;
}

int Mech::TurnRight()
{
if (onRoad(Vector.x,Vector.y) == On && RoadHeight(Vector.x,Vector.y) == Altitude && MoveType >= 2)
  if (PilotingRoll < genPilotModifier()+TargetEvasion[HexesMoved]-1) Skid();

Vector.head += 60;
if (Vector.head >= 360) Vector.head -= 360;
if (MP > 0) MoveType < 0 ? MP : MP -= 1;// If unit Jumps no MP cost

  drawHex(Vector.x,Vector.y);
  drawUnit(0);
  
return 1;
}

int Mech::ResolveWeapons(class Unit *Attacker) {
int i,j,k,r,d,l,c,a;
int MisHit; // # of Missiles that actually Connect
int x,y,col=Window.TextColour;
int PartialCover;
int Dam,DamageCluster,Cluster;
char bString[40];

sprintf(bString,"Missiles");

BITMAP *block;
block = create_bitmap(550,250);

x = 60;
y = 130;

ScrollLock = Off;

blit    (screen,block, 50,120,0,0,550,250);
vsync();
rectfill(screen, 50,120,550,360,Window.BGColour);

//PartialCover = ProcCover(LOSstring,0,2,0,2);
PartialCover = ProcCover(LOSstring,Attacker->Altitude,Attacker->Position+1,Altitude,Position+1);

for (i=0;i<Attacker->Weapons;i++) {
    r = GunneryRoll;

  if (Attacker->AmmoState(Attacker->Weapon[i].AmmoType,0) < Attacker->Weapon[i].AmmoConsumption )
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d Ammo Depleted",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Options.WeaponJams == On && Weapon[i].Jams == 1 && r <= Weapon[i].JamMod+(Weapon[i].RateOfFire/2))
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d Weapon Jams",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Attacker->Flag[i] == 0)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d OFFLINE",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Attacker->Flag[i] == 127)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Used",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Attacker->Flag[i] > 12)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Target ERROR - Shot Aborted",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Attacker->Flag[i] <= r) {
  Attacker->Pilot.TargetPenalty = 1; // If a weapon is fired, multiple target penalty

    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d ",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage);
//    Attacker->AmmoState(Attacker->Weapon[i].AmmoType,1);
    Attacker->AmmoState(Attacker->Weapon[i].AmmoType, Attacker->Weapon[i].RateOfFire);

  HeatTurn += Attacker->Weapon[i].TargetHeat;
  Infernos += Attacker->Weapon[i].Persistence; // Inferno
  k = Attacker->Weapon[i].Missiles*Attacker->Weapon[i].RateOfFire;

  if (Options.GlancingHits == On && Attacker->Flag[i] == r)
    Cluster = -2; // Glancing Hit
  else Cluster = 0;
  if (Options.MissileBonus == On) Cluster += r - Attacker->Flag[i];

  if (ECMType == 1)
    Cluster =  roll2d6 + Cluster; // Artemis jammed
  else
    Cluster =  roll2d6 + Attacker->Weapon[i].Cluster + Cluster; // Artemis etc.
    Cluster<0?Cluster=0:Cluster>12?Cluster=12:Cluster;// Bind Cluster

    c = Misptr[k][Cluster];
//    c<1?c=1:c;

    for (j=0;j<Weapons;j++) {
//      textprintf(screen,font,300,10+j*10,col,"AMS Intercepts [%d] ",Weapon[j].MissileIntercepts);
//      if (Attacker->Weapon[i].AMS == On && Weapon[j].MissileIntercepts > 0 && AmmoState(Weapon[j].Type,0) > 0 && Flag[j]!=127) {
      if (Attacker->Weapon[i].AMS == On && Weapon[j].MissileIntercepts > 0 && AmmoState(Weapon[j].AmmoType,0) > 0 && Flag[j]!=127) {
//      if (Weapon[j].MissileIntercepts > 0 && Flag[j]!=127) {
        a = rollxd6(Weapon[j].MissileIntercepts); c -= a; AmmoState(Weapon[j].AmmoType,a); Flag[j] = 127;
        HeatTurn += rollxd6(Weapon[j].RandomHeat);
        y+=8;
        textprintf(screen,font,x,y,col,"AMS Intercepts %d %s",a,bString);
        }
      }
    c<0?c=0:c;

    Dam = c * Attacker->Weapon[i].Damage;
    DamageCluster = Attacker->Weapon[i].DamageCluster;

  if (Dam == DamageCluster) { // One Hit / Med/Laser
        l = getFacing(getDamageAngle(Attacker->Vector,Vector));
        if(PartialCover==Off)k=HitLoc[l][roll2d6];
          else k=PunchLoc[l][rolld6];

        if(Attacker->Pilot.Aim == RIGHT) l==0?l=2:l==1?l=0:l==2?l=3:l==3?l=1:0;
        if(Attacker->Pilot.Aim == LEFT)  l==0?l=1:l==1?l=3:l==2?l=0:l==3?l=2:0;
        if(Attacker->Pilot.Aim == HIGH)  k=PunchLoc[l][rolld6];
        if(Attacker->Pilot.Aim == LOW)   k=KickLoc[l][rolld6];

        if(Attacker->Pilot.Aim == AIM && Attacker->Weapon[i].Class != 3) {
          d = roll2d6;
          if (d == 6 || d == 7 || d == 8)
            k=Attacker->Pilot.AimTarget;}

        if(Attacker->Pilot.Aim == TARGETED && Attacker->Weapon[i].Class != 3)
          k=Attacker->Pilot.AimTarget;

        if (Options.GlancingHits == On && Attacker->Flag[i] == r)
  	  Damage(k, l,(Attacker->Weapon[i].Damage)/2); // Glancing Hit
        else
  	  Damage(k, l, Attacker->Weapon[i].Damage );
        y+=8;
        textprintf(screen,font,x,y,col,"Hits %s",LocationName[k+1]);
      }
  else {
        y+=8;
        textprintf(screen,font,x,y,col," %d %s Hit ",c,bString);
        l = getFacing(getDamageAngle(Attacker->Vector,Vector));

      for (k=DamageCluster;k<=Dam;k+=DamageCluster) {

        if(PartialCover==Off)d=HitLoc[l][roll2d6];
          else d=PunchLoc[l][rolld6];

        if(Attacker->Pilot.Aim == RIGHT) l==0?l=2:l==1?l=0:l==2?l=3:l==3?l=1:0;
        if(Attacker->Pilot.Aim == LEFT)  l==0?l=1:l==1?l=3:l==2?l=0:l==3?l=2:0;
        if(Attacker->Pilot.Aim == HIGH)  d=PunchLoc[l][rolld6];
        if(Attacker->Pilot.Aim == LOW)   d=KickLoc[l][rolld6];

        Damage( d ,l,DamageCluster);
        y+=8;
        textprintf(screen,font,x,y,col,"Hits %s",LocationName[d+1]);
        }

        if (PartialCover==Off) d=HitLoc[l][roll2d6];
          else d=PunchLoc[l][rolld6];

        if(Attacker->Pilot.Aim == LEFT)  l==0?l=2:l==1?l=0:l==2?l=3:l==3?l=1:0;
        if(Attacker->Pilot.Aim == RIGHT) l==0?l=1:l==1?l=3:l==2?l=0:l==3?l=2:0;
        if(Attacker->Pilot.Aim == HIGH)  d=PunchLoc[l][rolld6];
        if(Attacker->Pilot.Aim == LOW)   d=KickLoc[l][rolld6];
          
        if (Dam%DamageCluster>0) {
          y+=8;
          textprintf(screen,font,x,y,col,"Hits %s",LocationName[d+1]);
          Damage( d ,l,(Dam%DamageCluster));
          }
        }

  } // End if
    else {
    if (Attacker->Weapon[i].Locking == On && ECMType == 1)
      Attacker->HeatTurn -= Attacker->Weapon[i].Heat; // Missed Streaks generate no heat
    else
      Attacker->AmmoState(Attacker->Weapon[i].AmmoType,Attacker->Weapon[i].RateOfFire);

    Pilot.TargetPenalty = 1; // If a weapon is fired, multiple target penalty
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Miss",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage);

    if (Map.Hex[Vector.x][Vector.y].Type=='t'||Map.Hex[Vector.x][Vector.y].Type=='T')
      if (roll2d6 <= 3)
        CreateFire(Vector.x,Vector.y);

    }
    y+=8;

  } // End for



getkey();
vsync();
ScrollLock = On;
blit    (block,screen,0,0, 50,120,550,250);
destroy_bitmap(block);
return 0;
}

int Mech::genPilotModifier() {
int Modifier = Pilot.Piloting;

if (GyroHits == 1) Modifier += 3;
if (GyroHits >= 2) Modifier += 12;
//if (Type == QUAD) Modifier -= 2;
//if (TurnDamage >= 20) Modifier += 1;
if (Immobile == On) Modifier += 6;

if (RightLeg.Hip == Off) Modifier += 2;
  else { if (RightLeg.UpperLeg == Off) Modifier += 1;
         if (RightLeg.LowerLeg == Off) Modifier += 1;
         if (RightLeg.Foot     == Off) Modifier += 1; }

if (LeftLeg.Hip == Off) Modifier += 2;
  else { if (LeftLeg.UpperLeg == Off) Modifier += 1;
         if (LeftLeg.LowerLeg == Off) Modifier += 1;
         if (LeftLeg.Foot     == Off) Modifier += 1; }

if (validQuad() == On)
  Modifier -= 2;
  
return Modifier;
}

int Mech::WeaponDisable(int Loc, int WeaponType) {
int i=0;
//Crit[Loc][Pos].Type
  for (i=0;i<Weapons;i++) {
    if (Weapon[i].Type == WeaponType && Weapon[i].Loc == Loc && Weapon[i].State!=-1) {
      Weapon[i].State = -1;
      if (Weapon[i].SelfDestructs == On)
        InternalDamage(Loc, 0, (Weapon[i].Damage*Weapon[i].Missiles));
      return 1;
      }
  }

return 0;
}

int Mech::genAmmoTable() {
int i,j,k;
int Alloc;
//clear(screen);
for (i=0;i<8;i++) // Locations
  for (j=0;j<CritSlot[i];j++) // Positions
    if (Crit[i][j].Class == AMMO) { // Is Ammo
//      Ammo[Ammunitions] = AmmoTable[Crit[i][j].Type];
//      textprintf(screen,font,20,20+Ammunitions*10,EGAColour[7],"%d %d",Ammunitions,Crit[i][j].Type);
      for (k=0;k<Ammos;k++) {
//        textprintf(screen,font,320,20+k*10,EGAColour[7],"%d %d %d %s : %d %d %d",k,AmmoTable[k].Type,Crit[i][j].Type,AmmoTable[k].Name,AmmoTable[k].Damage,AmmoTable[k].DamageCluster,AmmoTable[k].Missiles);
        if (AmmoTable[k].Type == Crit[i][j].Type)
//          if (AmmoTable[k].Class == 0)
            Ammo[Ammunitions] = AmmoTable[k];
            }

      Ammo[Ammunitions].Loc = i;
      Ammo[Ammunitions].Pos = j;
      Ammo[Ammunitions].Ammo = Crit[i][j].State;
//      Ammo[Ammunitions].ExplodeDamage = WeaponTable[Crit[i][j].AmmoType].Damage;
      if (Ammo[Ammunitions].SelfDestructs == 1)
        Ammo[Ammunitions].ExplodeDamage = WeaponTable[AmmoTable[Crit[i][j].Type].AmmoType].Damage * WeaponTable[AmmoTable[Crit[i][j].Type].AmmoType].Missiles;
      else
        Ammo[Ammunitions].ExplodeDamage = 0;
//      Ammo[Ammunitions].Ammo = 1;
      Ammunitions ++;
      }

//textprintf(screen,font,320,20+Index*10,EGAColour[7],"%d %d %d %s : %d %d %d",0,Ammo[0].Type,Crit[i][j].Type,Ammo[0].Name,Ammo[0].Damage,Ammo[0].DamageCluster,Ammo[0].Missiles);
for (i=0;i<Weapons;i++) {

  Weapon[i].RateOfFire = Weapon[i].FireMode; // UACs start at burst of 2

  if (Weapon[i].Class == 3) // Missile
    if (ARTType == 4) {
      Weapon[i].Linked  = 3;
      Weapon[i].Cluster = 2;
      }
//  while (Weapon[i].AmmoType != Ammo[j].AmmoType && j!=Weapons) j++;

  j=0;
  while ((Weapon[i].AmmoType != Ammo[j].AmmoType) && j!=Ammunitions) j++;
    if (Weapon[i].AmmoConsumption > 0) {
      Weapon[i].AmmoIndex = -1;
      SetAmmoType(i,j);
      }
/*
    if (Weapon[i].Class == 2 || Weapon[i].Class == 3) { // Pre Load Weapons
      Weapon[i].Damage        += Ammo[j].Damage;
      Weapon[i].DamageCluster += Ammo[j].DamageCluster;
      Weapon[i].Cluster       += Ammo[j].Cluster;
      Weapon[i].Accuracy      += Ammo[j].Accuracy;
      Weapon[i].Missiles      += Ammo[j].Missiles;
      }
*/
//      textprintf(screen,font,320,20+i*10,EGAColour[7],"%d %d %d %d %d %d",i,j,Weapon[i].Damage,Weapon[i].DamageCluster,Weapon[i].Cluster,Weapon[i].Missiles);
  }

//for (j=0;j<Ammunitions;j++)
//  textprintf(screen,font,320,20+j*10,EGAColour[7],"%d %d %d %d %d %d",i,j,Ammo[j].Damage,Ammo[j].DamageCluster,Ammo[j].Missiles);
/*
if (CompType == 1) {
  textprintf(screen,font,320,20+j*10,EGAColour[7],"%d %d %d %d %d %d",i,j,Ammo[j].Damage,Ammo[j].DamageCluster,Ammo[j].Missiles);
  getkey(); }
*/
return 0;
}

int Mech::AmmoState(int AmmoType, int Ammount) {
int i=0,j,k = 0;

if (Options.AmmoConsumption == Off) return 1;

//textprintf(screen,font,300,50+Ammount*10,0,"%d %d %d %d %d",i,k,Type,Ammo[0].Type,Ammunitions);

 while (i <= Ammunitions) { // Will always consume top ammo first
  if (Ammo[i].AmmoType == AmmoType) { // Will always consume top ammo first
//    k = 0;
    if (k == 0) {
    Ammo[i].Ammo -= Ammount;
    if (Ammo[i].Ammo < 0) Ammo[i].Ammo = 0;
    Crit[Ammo[i].Loc][Ammo[i].Pos].State = Ammo[i].Ammo;
    }
    k += Ammo[i].Ammo;
    }
//textprintf(screen,font,300,50+i*10,0,"%d %d %d %d",i,k,Type,Ammo[i].AmmoType);
  i++;
  }

return k;
}

int Mech::WeaponAmmo(int Weap, int Ammount) {
int i=0,j,k = 0;

if (Options.AmmoConsumption == Off) return 1;

if (Weapon[Weap].AmmoType != -1) {

  if (Ammo[Weapon[Weap].AmmoType].Ammo < Ammount && Ammo[Weapon[Weap].AmmoType].Ammo > 0)
    Weapon[Weap].RateOfFire = Ammo[Weapon[Weap].AmmoType].Ammo;
// Change Ammo Type
  
  Ammo[Weapon[Weap].AmmoType].Ammo -= Ammount;

  k = Ammo[Weapon[Weap].AmmoType].Ammo;
  }
else k = 1;

return k;
}

int Mech::AmmoExplosion(int Loc, int Pos) {
char String[80];
int AmmoDamage=0;
int Num=0;
int i;

for (i=0;i<Ammunitions;i++)
  if (Ammo[i].Loc == Loc && Ammo[i].Pos == Pos)
    Num = i; // Get Ammo Number

//Num=0;
if (Num > Ammunitions) Num = Ammunitions;
if (Num < 0) Num = 0;

AmmoDamage = Ammo[Num].ExplodeDamage;
AmmoDamage*= Ammo[Num].Ammo;
Ammo[Num].Ammo = 0;

Crit[Loc][Pos].State = -1;

if (Options.AmmoExplosions == Off) return 1;
if (Options.ModeratedAmmoExplosions == On) AmmoDamage /= 10;
if (AmmoDamage == 0) return 0; // Not worth mentioning
sprintf(String,"%s explodes for %d damage!",Ammo[Num].Name,AmmoDamage);
putString(String,Colour);
getkey();

//if (AmmoDamage > 400) AmmoDamage = 400; // Help OverFlow

int srt=Struct[RT],slt=Struct[LT],srl=Struct[RL],sll=Struct[LL],sra=Struct[RA],sla=Struct[LA];
int shift;

if (AmmoDamage > 0) {
    Pilot.Hits +=2;
    ConcRoll();
  if ( Loc == 0 ) { // Head
    Pilot.Hits ++;
    ConcRoll();
    }

  if ( Loc == 15) { // Back of the Head
    Pilot.Hits ++;
    ConcRoll();
    Loc = 0;
    }
    }

    if (AmmoDamage > 0) {
      Struct[Loc] -= AmmoDamage;
      AmmoDamage = -Struct[Loc];

    if (Struct[Loc] <= 0) Destroy(Loc);
//      else Critical(Loc,-1);
    shift = 2<<Loc;
    if ((CaseLoc&shift)==shift); // Case for this Location
      else
    if (Struct[Loc] <= 0)
      if (TransferDamage[Loc] != -1 && Options.TransferDamage == On)
        InternalDamage(TransferDamage[Loc],0,AmmoDamage);

//    sprintf(String,"Critical Damage!");
//    putString(String,Colour);
//    getkey();

//    sprintf(String,"[D] %s explodes %d %d ",Ammo[Num].Name,AmmoDamage,Loc);
//    putString(String,Colour);
//        Damage(Loc,0,0);
      if (Struct[HD] <= 0) Pilot.Hits += 6, ConcRoll();
      if (Struct[CT] <= 0 || Struct[HD] <= 0) { Position = 0; drawUnit(1); Status = Off; Immobile = On;return 4;}
      if (Struct[RT] <= 0 && srt > 0) Armour[RT]=0,Armour[RTr]=0, Destroy(RT), Sever(RA);
      if (Struct[LT] <= 0 && slt > 0) Armour[LT]=0,Armour[LTr]=0, Destroy(LT), Sever(LA);
      if (Struct[RA] <= 0 && sra > 0) Destroy(RA);
      if (Struct[LA] <= 0 && sla > 0) Destroy(LA);
      if (Struct[RL] <= 0 && srl > 0) { Destroy(RL); if (Position == 1) Fall(1); }
      if (Struct[LL] <= 0 && sll > 0) { Destroy(LL); if (Position == 1) Fall(1); }

      if (TransferDamage[Loc] == -1 || TransferDamage[Loc] == -2) return -1;

    if (Struct[Loc] <= 0)
      Struct[Loc] = 0;

    return 1;

    }

return 0;
}

int Mech::genToHit(class Unit Target) {
//i = Gunnery + Mod;
//Tohit = Gunnery + Modifier + Heat + Move + TargetMove + Range + Weather + Global;
// Add option to soften range limits
int Range,Modifier,ToHit;
float Medium = 1.0;
int i,a;
int Cover;
char bString[60];
int Hit[20];

for (i=0;i<Weapons;i++)
  Hit[i] = Flag[i];

//Range = 0 ;
Range = doLos(Vector.x,Vector.y,Target.Vector.x,Target.Vector.y);
Modifier = ProcLOSstrALT (LOSstring,Altitude,Position,Target.Altitude,Target.Position);
Cover    = ProcCover (LOSstring,Altitude,Position,Target.Altitude,Target.Position);

ToHit  = Pilot.Gunnery;
ToHit += Pilot.TargetPenalty;
ToHit += Modifier;
if (MoveType >= 0)
  ToHit += MoveType;
else
  ToHit += 3; // Jumping Mechs
ToHit += TargetEvasion [ Target.HexesMoved ];
ToHit += HeatAcc [ Heat ];
if (Target.Immobile == On)
  ToHit += -4;

if (Target.MoveType == 3) ToHit -= 1;
if (Target.MoveType == 4 && Options.SkilledEvade == On ) ToHit  =(9 - Pilot.Piloting) / 2;
if (Target.MoveType == 4 && Options.SkilledEvade == Off) ToHit += 1;

if (validQuad()==Off)
  if (Position == 0)
    ToHit += 2; // Attacker is Prone Normal Mech / Damaged Quad

if (SensorHits == 1) // Sensors Damaged
  ToHit += 2;

if (SensorHits >= 2) // Sensors Destroyed
  ToHit += 12;

if (Submersed != Target.Submersed) ToHit += 12; // Can't fire between media

if (Options.AngleOfAttack == On) {
  if (abs(Vector.head - Target.Vector.head) == 0) ToHit += 0;
  if (abs(Vector.head - Target.Vector.head) == 1) ToHit += 2;
  if (abs(Vector.head - Target.Vector.head) == 2) ToHit += 3;
  if (abs(Vector.head - Target.Vector.head) == 3) ToHit += 1;
  }

if (Target.Position == 0)
  if (Range == 1)
    ToHit += -1; // If unit prone and close, easier to-hit
  else
    ToHit +=  1; // If unit prone and far, tougher to-hit

for (i=0;i<Weapons;i++)
  if (Flag[i] == 0 || Options.SimultaneousWeaponFire == On) {
    Flag[i] = 1;
      
    Flag[i] *= ToHit;
    a = Weapon[i].Type;

    if (Weapon[i].Class == 1 || Weapon[i].Class == 2) {
      if (Pilot.Aim == AIM      && Pilot.AimTarget == 0) Flag[i] += 7;
      if (Pilot.Aim == TARGETED && Pilot.AimTarget == 0 && Target.Immobile == Off) Flag[i] += 16;
      if (Pilot.Aim == TARGETED && Pilot.AimTarget == 0 && Target.Immobile == On ) Flag[i] += 7;
      if (Pilot.Aim == TARGETED                        ) Flag[i] += 3;
      }
    if (Pilot.Aim > 0 && Pilot.Aim < 5) Flag[i] += 4;

    if (Submersed == On) {
      Medium = .6;
      if (WeaponTable[a].Type != 1 && WeaponTable[a].Type != 1) // Only Lasers and PPC can fire
        Flag[i] += 12;
      }

    Range <=(WeaponTable[a].Minimum* Medium) ? Flag[i] +=int(WeaponTable[a].Minimum*Medium) - Range + 1 : i;
    Range > (WeaponTable[a].Short  * Medium) ? Flag[i] += 2  : i ;
    Range > (WeaponTable[a].Medium * Medium) ? Flag[i] += 2  : i ;
    Range > (WeaponTable[a].Long   * Medium) ? Flag[i] += 12 : i ;
    if (Options.ExtremeRange == On && Range > (WeaponTable[a].Long   * Medium))
    Range <=((WeaponTable[a].Medium*2)*Medium) ? Flag[i] -= 8  : i ;

    if (Weapon[i].Loc == RA) // Arm Damage
      if (RightArm.Shoulder == Off)
        Flag[i] += 4;
      else { if (RightArm.UpperArm == Off && RightArm.Length >= 3) Flag[i] += 1;
             if (RightArm.LowerArm == Off && RightArm.Length == 4) Flag[i] += 1; }

    if (Weapon[i].Loc == LA)
      if (LeftArm.Shoulder == Off)
        Flag[i] += 4;
      else { if (LeftArm.UpperArm == Off && LeftArm.Length >= 3) Flag[i] += 1;
             if (LeftArm.LowerArm == Off && LeftArm.Length == 4) Flag[i] += 1; }

    if (Cover == 1)
      if (Weapon[i].Loc == RL || Weapon[i].Loc == LL)
        Flag[i] += 12; // Leg mounted weapons can't fire with partial cover

    Flag[i] += Weapon[i].Accuracy;

    if (CompType == 1 && (Weapon[i].Class == 1 || Weapon[i].Class == 2))
      Flag[i] -= 1; // Targeting computer accuracy bonus

    if ( Flag[i] < 2 && Options.LinearGunnery == Off)
      Flag[i] = 2;
    if ( Flag[i] < 1 && Options.LinearGunnery == On )
      Flag[i] = 1;

  }
  else {
    if ( Options.SimultaneousWeaponFire == Off )
      Flag[i] = 127; // Weapon Previosly Fired
    if ( Options.SimultaneousWeaponFire == On && Flag[i] != 0)
      Flag[i] = Hit[i];
    }
    
return ToHit;
}


/////////////////////////////////////////////////////////////////////////////
// * Remember it dosn't have to be pretty
//
//
//

//char Flag[30];
char AlphaFlag;

void Mech::WeaponSelect(int Angle,int Target)
{
unsigned char key;
char cd[256];
int  Number;
int  i,l;
int x,y,col=0;
int Hit[20];
int AngleLoc[20];
int ProneFlag = 0;
char ErrorMSG[80];

// LegMounted Weapons have a different arc
for (i=0;i<Weapons;i++) {
  if (Weapon[i].Loc == RL || Weapon[i].Loc == LL)
    AngleLoc[i] = Angle+Turret;
  else AngleLoc[i] = Angle;

  // Flip Arms
  if (Weapon[i].Loc == RA || Weapon[i].Loc == LA)
    if (RightArm.Length == 2 && RightArm.Length == 2) {
      if (Angle >  120)
        AngleLoc[i] = Angle - 120;
      if (Angle < -120)
        AngleLoc[i] = Angle + 120;
        }

  }

BITMAP *block;
block = create_bitmap(550,250);

x = 110;
y = 130;

blit    (screen,block,100,120,0,0,550,250);

ScrollLock = On;
//Bind Angle
if (Angle >  180) Angle -= 360;
if (Angle < -180) Angle += 360;

for (i=0;i<Weapons;i++)
  Hit[i] = Flag[i];

cd['1'] = 0;
cd['2'] = 1;
cd['3'] = 2;
cd['4'] = 3;
cd['5'] = 4;
cd['6'] = 5;
cd['7'] = 6;
cd['8'] = 7;
cd['9'] = 8;
cd['0'] = 9 ;
cd['q'] = 10;
cd['w'] = 11;
cd['e'] = 12;
cd['r'] = 13;
cd['t'] = 14;
cd['y'] = 15;
cd['u'] = 16;
cd['i'] = 17;
cd['o'] = 18;
cd['p'] = 19;
cd[8]   = 127;
cd[TAB] = 127;

AlphaFlag = 0;
//printf("%d",Weapons);
//textattr(07);

for (i=0;i<Weapons;i++)
  Flag[i] = AlphaFlag;// * Weapon[i].Status;

while (key != FIRE && key != DONE && key != QUIT) {
//drawWeaponBox(vMech);
vsync();
rectfill(screen,100,120,600,360,Window.BGColour);


for (i=0;i<Weapons;i++) { // Should Really be an If Statement
  y = i * 8 + 130;

      sprintf(ErrorMSG,"%2d ",Hit[i]);
      if (WeaponTarget[i] != -1)
        sprintf(ErrorMSG,"%2d [%s] ",Hit[i],unit[WeaponTarget[i]]->Name);

    if (   (LeftArc[Weapon[i].Loc] <= AngleLoc[i] && RightArc[Weapon[i].Loc] >= AngleLoc[i]) ^ \
       (180-LeftArc[Weapon[i].Loc] <= abs(AngleLoc[i])));                                        /*Rear Arc Check*/
      else // Outside of Arc
        sprintf(ErrorMSG,"Outside Arc");

    if (Weapon[i].State == -2)
      sprintf(ErrorMSG,"Weapon Jammed");
    if (Weapon[i].State == -1)
      sprintf(ErrorMSG,"Weapon Destroyed");

    if (Hit[i] == 127)
      sprintf(ErrorMSG,"Used");
    if (Hit[i]>=24)
      sprintf(ErrorMSG,"No LOS");
    if (Hit[i]> 12)
      sprintf(ErrorMSG,"Out of Range");

    if (Weapon[i].AmmoConsumption == 0)
      textprintf(screen,font,x,y,col,"%2d >> %-20s       <%3s> %3s %s ",i+1,Weapon[i].Name,LocName[Weapon[i].Loc],State[Flag[i]],ErrorMSG);
    else
      textprintf(screen,font,x,y,col,"%2d >> %-20s <%3d> <%3s> %3s %s ",i+1,Weapon[i].Name,AmmoState(Weapon[i].AmmoType,0),LocName[Weapon[i].Loc],State[Flag[i]],ErrorMSG);
  }


key = getkey();

if (key != FIRE && key != DONE && key != QUIT) {

  if (key == 128+125) { // Left Mouse Button
    key = ((mouse_y-130+4)/8);
    if (key < 10) key+=48;
    if (key >= 10)
      switch (key) {
      case 10: key = 'q';break;
      case 11: key = 'w';break;
      case 12: key = 'e';break;
      case 13: key = 'r';break;
      case 14: key = 't';break;
      case 15: key = 'y';break;
      case 16: key = 'u';break;
      case 17: key = 'i';break;
      case 18: key = 'o';break;
      case 19: key = 'p';break;
      default: ;break;
      }
    key > 127 ? key = 100 : key;
//    textprintf(screen,font,20,20,10,"%d %d",key,Weapons);
    }

// (  ( (LeftArc[Weapon[cd[key]].Loc]<=Angle && RightArc[Weapon[cd[key]].Loc]>=Angle) || /*Front Arc Check*/
//      (LeftArc[Weapon[cd[key]].Loc]>=Angle &&-RightArc[Weapon[cd[key]].Loc]<=Angle) ) ||
//     (-LeftArc[Weapon[cd[key]].Loc]<=Angle && RightArc[Weapon[cd[key]].Loc]>=Angle) ) /*Rear Arc Check*/

//  if (Hit[cd[key]] != 127 && Weapon[cd[key]].Status == On && AmmoState(Weapon[cd[key]].Type,0) > 0) {

  if ( Hit[cd[key]]<=12 && Weapon[cd[key]].State >= 0 && \
     ((LeftArc[Weapon[i].Loc] <= AngleLoc[i] && RightArc[Weapon[i].Loc] >= AngleLoc[i]) ^ \
  (180-LeftArc[Weapon[i].Loc] <= abs(AngleLoc[i])))                                       \
    && (AmmoState(Weapon[cd[key]].AmmoType,0) >= Weapon[cd[key]].AmmoConsumption) )
    Flag[cd[key]] ^= 0x0001;

  if (validQuad()==Off)
  if (Position == 0 && Struct[RA]>0 && Struct[LA]>0) { // If mech Prone only one arm can fire / or arms destroyed
    if (Weapon[cd[key]].Loc == RA) {
      ProneFlag = 1;
        for (i=0;i<Weapons;i++)
          if (Weapon[i].Loc == LA) Flag[i] = 0;
        }
    if (Weapon[cd[key]].Loc == LA) {
      ProneFlag = 0;
        for (i=0;i<Weapons;i++)
          if (Weapon[i].Loc == RA) Flag[i] = 0;
            }  }
  }

  if (cd[key] == 127) {
    AlphaFlag ^= 0x0001;

// Alpha Strike
    for (i=0;i<Weapons;i++) {
      if ( Hit[i]<=12 && Weapon[i].State >= 0 && \
         ((LeftArc[Weapon[i].Loc] <= AngleLoc[i] && RightArc[Weapon[i].Loc] >= AngleLoc[i]) ^ \
      (180-LeftArc[Weapon[i].Loc] <= abs(AngleLoc[i])))                                       \
        && (AmmoState(Weapon[i].AmmoType,0) >= Weapon[i].AmmoConsumption) )
        Flag[i] = AlphaFlag;
	else Flag[i] = 0;
      }

  // If Mech Prone
  if (Position == 0 && Struct[RA]>0 && Struct[LA]>0)
    for (i=0;i<Weapons;i++) {
      if (Weapon[i].Loc == RA)
        Flag[i] = (ProneFlag * AlphaFlag);
      if (Weapon[i].Loc == LA)
        Flag[i] = (ProneFlag * AlphaFlag) ^ 0x0001;
        }

      }

  }

for (i=0;i<Weapons;i++)
  if (Weapon[i].State == 1) {

    // Preserve Weapon Target
    if (WeaponTarget[i] != -1 && Flag[i] == 0 && Hit[i] > 0 && Hit[i] <= 12 && Options.SimultaneousWeaponFire == On)
      Flag[i] = Hit[i];

    // Weapon Targeted at new Target
    if (Flag[i] == 1 && Options.SimultaneousWeaponFire == Off) {
      WeaponTarget[i] = Target;
      Flag[i] = Hit[i];
      }

    // Weapon Targeted at new Target
    if (Flag[i] == 1 && Options.SimultaneousWeaponFire == On) {
      WeaponTarget[i] = Target;
      Pilot.TargetPenalty = 1;
      Flag[i] = Hit[i];
      }

    if (Hit[i] == 127)
      Flag[i] = 127;

//    Flag[i] *= Weapon[i].State;
  }

ScrollLock = Off;
vsync();
blit    (block,screen,0,0,100,120,550,250);
destroy_bitmap(block);
}

int Mech::getMoveType(byte ch)
{
  switch (ch) {
    case 'w'  : if(getSpeed( 1)>0) return 1; break;
    case 'W'  : if(getSpeed( 1)>0) return 1; break;
    case 'r'  : if(getSpeed( 2)>0) return 2; break;
    case 'R'  : if(getSpeed( 2)>0) return 2; break;
    case 'x'  : if(getSpeed( 3)>0) return 3; break;
    case 'X'  : if(getSpeed( 3)>0) return 3; break;
    case 'e'  : if(getSpeed( 4)>0) return 4; break;
    case 'E'  : if(getSpeed( 4)>0) return 4; break;
    case 'j'  : if(getSpeed(-1)>0) return-1; break;
    case 'J'  : if(getSpeed(-1)>0) return-1; break;
    case 's'  : ; return 0;
    case 'S'  : ; return 0;
    case 'a'  : ;
    case 'A'  : ReactorShutDown  (); return 0;
    case 'u'  : ;
    case 'U'  : if (Surrender(Side) == 0)  ; break;
    case 'm'  : ;
    case 'M'  : if (MASCState == Off) EngageMASC(); break;
    case 128+120  : ;
    case PgUp : ScrollUp  (); break;
    case 128+121  : ;
    case PgDn : ScrollDn  (); break;
    case 128+122  : ;
    case Home : ScrollLt  (); break;
    case 128+123  : ;
    case End  : ScrollRt  (); break;
    case 128+125  : ;
    case 'i'  : getInfo   (); break;
    case 'I'  : getInfo   (); break;
    case QUIT : ExitGame (0); break;
    case 'C'  : ;
    case 'c'  : CentreMap(Vector.x,Vector.y) ;break;
    case CTRLA: ToggleFastAI         (); break;
    case CTRLG: ToggleGrid           (); break;
    case CTRLW: ToggleShowWeapons    (); break;
    case CTRLS: ToggleCentreMap      (); break;
    case CTRLH: ToggleAltitudeDisplay(); break;
    case CTRLD: ToggleMovementDice   (); break;
    case CTRLO: ShowOptions          (); break;
    case CTRLE: screen_shot          (); break;
    default   : ;break;
  }

return RETURNNULL;
}


int Mech::Move(byte ch)
{
  switch (ch) {
//  case 'a'  : MP = 1; return 1;
  case 32   : return 2;
  case 's'  : if (Position == 0) Stand();return 1 ; // Stand Up
  case 'd'  : ; // Drop Down /
  case 'p'  : if (Position == 1 && MoveType >= 0)Prone();return 1 ; // go Prone
  case 128+120  : ;
  case PgUp : ScrollUp();break;
  case 128+121  : ;
  case PgDn : ScrollDn();break;
  case 128+122  : ;
  case Home : ScrollLt();break;
  case 128+123  : ;
  case End  : ScrollRt();break;
  case 128+126  : if (Options.MouseMove==On) MouseMove(0);return 0; // Mouse Button 2
  case 128+125  : if (Options.MouseMove==On){MouseMove(1);return 0;}// Mouse Button 1
  case 'i'  : ;
  case 'I'  : getInfo  (); return 1 ;
  case Up   : Advance  (); return 1 ;
  case Left : TurnLeft (); return 1 ;
  case Right: TurnRight(); return 1 ;
  case Down : Reverse  (); return 1 ;
  case QUIT : ExitGame(0) ;break;
  case INS  : Shift    (); return 1 ;
  case 'C'  : ;
  case 'c'  : CentreMap(Vector.x,Vector.y) ;break;
  case CTRLA: ToggleFastAI         (); break;
  case CTRLG: ToggleGrid           (); break;
  case CTRLW: ToggleShowWeapons    (); break;
  case CTRLS: ToggleCentreMap      (); break;
  case CTRLH: ToggleAltitudeDisplay(); break;
  case CTRLD: ToggleMovementDice   (); break;
  case CTRLO: ShowOptions          (); break;
  case CTRLE: screen_shot          (); break;
//  case EXAM : Exam(); return 0;break;
//  case 32   : return 0;
  default   : ;break;
  }

return 0;
}

int Mech::drawUnit(int Clear) {
// 0 : Draws over Hex
// 1 : Clears Hexs

if (Hidden != On) {
  if (Clear == On ) drawHex (Vector.x,Vector.y);
  drawMech(Vector,UnitColour,Position);

  }

return 0;
}

int Mech::Skid() {
char String[40];
int Levels = Altitude - MPH[Map.Hex[Vector.x][Vector.y].Alt] + Position; // Level
int SkidDamage;
int i,j;

//  if (roll2d6 < 13) { // Skid
    sprintf(String,"%s skids!",Name);
    putString(String,Colour);
    SkidDamage = ((HexesMoved * Tons) / 20) + ((Levels * Tons) / 10); // Skid + Fall
    Position  = 0; // Mech Falls down

    for (i=0;i<SkidDamage-5;i+=5)
      Damage(HitLoc[0][roll2d6],0,5);
      Damage(HitLoc[0][roll2d6],0,SkidDamage%5);

    j = (HexesMoved+1/2);
    for (i=0;i<j;i++) {
      Shoved(Vector.head);
      rest(250);
      }
    MP = 0; // Can't Move After
    getch();

return 1;
}

int Mech::genToHitHex(struct Vector Target) {
int Range,Modifier,ToHit;
float Medium = 1.0;
int i,a;
int x=50,y = 100;
int col = makecol24(171,0,0);
//Range = 0 ;
Range = doLos(Vector.x,Vector.y,Target.x,Target.y);
Modifier = ProcLOSstrALT (LOSstring,Altitude,Position+1,MPH[Map.Hex[Target.x][Target.y].Alt],TerHeight[Map.Hex[x][y].Type]+1);

ToHit  = Pilot.Gunnery;
ToHit += Modifier;
ToHit += MoveType + (MoveType - MoveType) * -2;
ToHit += HeatAcc [ Heat ];
ToHit += -4;

if (Position == 0)
  ToHit += 2; // Attacker is Prone

if (SensorHits == 1) // Sensors Damaged
  ToHit += 2;

if (SensorHits >= 2) // Sensors Destroyed
  ToHit += 16;

for (i=0;i<Weapons;i++)
  if (Flag[i] == 0) {
    Flag[i] = 1;

    Flag[i] *= ToHit;
    a = Weapon[i].Type;

    if (Submersed == On) {
      Medium = .6;
      if (WeaponTable[a].Type != 1 && WeaponTable[a].Type != 1) // Only Lasers and PPC can fire
        Flag[i] += 12;
      }

    Range <=(WeaponTable[a].Minimum* Medium) ? Flag[i] +=int(WeaponTable[a].Minimum*Medium) - Range + 1 : i;
    Range > (WeaponTable[a].Short  * Medium) ? Flag[i] += 2  : i ;
    Range > (WeaponTable[a].Medium * Medium) ? Flag[i] += 2  : i ;
    Range > (WeaponTable[a].Long   * Medium) ? Flag[i] += 12 : i ;
    if (Options.ExtremeRange == On && Range > (WeaponTable[a].Long   * Medium))
    Range <=((WeaponTable[a].Medium*2)*Medium) ? Flag[i] -= 8  : i ;

    if (Weapon[i].Loc == RA) // Arm Damage
      if (RightArm.Shoulder == Off)
        Flag[i] += 4;
      else { if (RightArm.UpperArm == Off && RightArm.Length >= 3) Flag[i] += 1;
             if (RightArm.LowerArm == Off && RightArm.Length == 4) Flag[i] += 1; }

    if (Weapon[i].Loc == LA)
      if (LeftArm.Shoulder == Off)
        Flag[i] += 4;
      else { if (LeftArm.UpperArm == Off && LeftArm.Length >= 3) Flag[i] += 1;
             if (LeftArm.LowerArm == Off && LeftArm.Length == 4) Flag[i] += 1; }

    if (Range == 1)
      Flag[i] = 2;

    if ( Flag[i] < 2)
      Flag[i] = 2;
  }
  else
    Flag[i] = 127; // Weapon Previosly Fired

return ToHit;
}

int Mech::ResolveWeaponsHex(struct Vector Target) {
int i,j,k,r,d,l,c;
int MisHit; // # of Missiles that actually Connect
int x,y;
int col=Window.TextColour;
int PartialCover;
char String[80],bString[40];
int Dam,DamageCluster,Cluster;
sprintf(bString,"Missiles");

BITMAP *block;
block = create_bitmap(550,250);

x = 60;
y = 130;

blit    (screen,block, 50,120,0,0,550,250);
vsync();
rectfill(screen, 50,120,550,360,Window.BGColour);

for (i=0;i<Weapons;i++) {
  r = GunneryRoll;
  if (AmmoState(Weapon[i].AmmoType,0) < Weapon[i].AmmoConsumption )
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d Ammo Depleted",r,Flag[i], Weapon[i].Name,Weapon[i].Damage,Flag[i]);
  if (Options.WeaponJams == On && Weapon[i].Jams == 1 && r <= Weapon[i].JamMod+(Weapon[i].RateOfFire/2))
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d Weapon Jams",r,Flag[i], Weapon[i].Name,Weapon[i].Damage,Flag[i]);
  else
  if (Flag[i] == 0)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d OFFLINE",r,Flag[i], Weapon[i].Name,Weapon[i].Damage,Flag[i]);
  else
  if (Flag[i] == 127)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Used",r,Flag[i], Weapon[i].Name,Weapon[i].Damage,Flag[i]);
  else
  if (Flag[i] > 12)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Target ERROR - Shot Aborted",r,Flag[i],Weapon[i].Name,Weapon[i].Damage,Flag[i]);
  else
  if (Flag[i] <= r) {
  Pilot.TargetPenalty = 1; // If a weapon is fired, multiple target penalty

    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d ",r,Flag[i], Weapon[i].Name,Weapon[i].Damage);
    AmmoState(Weapon[i].AmmoType,1);

//  if (Weapon[i].TargetHeat > 0 || Weapon[i].Persistence > 0) // Inferno
  if (Weapon[i].Persistence > 0) // Inferno
    CreateFire(Target.x,Target.y);

  k = Weapon[i].Missiles*Weapon[i].FireMode;

  if (Options.GlancingHits == On && Flag[i] == r)
    Cluster = -2; // Glancing Hit
  else Cluster = 0;

    Cluster =  roll2d6 + Weapon[i].Cluster + Cluster; // Artemis etc.
    Cluster<0?Cluster=0:Cluster>12?Cluster=12:Cluster;// Bind Cluster

    c = Misptr[k][Cluster];
    c<0?c=0:c;

    Dam = c * Weapon[i].Damage;
    DamageCluster = Weapon[i].DamageCluster;

  if (Dam == DamageCluster) { // One Hit / Med/Laser
        if (Options.GlancingHits == On && Flag[i] == r)
          DamageHex(Target.x,Target.y,(Dam+1)/2);
        else
          DamageHex(Target.x,Target.y,Dam);
//        y+=8;
        textprintf(screen,font,x+280,y,col,"Hits");
      }
  else { // LRM / MRM Case
//        y+=8;
        textprintf(screen,font,x+280,y,col," %d %s Hit ",c,bString);
        l = getFacing(getDamageAngle(Vector,Vector));

      for (k=DamageCluster;k<=Dam;k+=DamageCluster) {
        DamageHex(Target.x,Target.y,DamageCluster);
        y+=8;
        textprintf(screen,font,x+64,y,col,"Hits ");
        }        

        if (Dam>0) {
          y+=8;
          DamageHex( d ,l,Dam%DamageCluster);
          textprintf(screen,font,x+64,y,col,"Hits ");
          }
        }

  } // End if
    else {
    if (Weapon[i].Locking == On)
      HeatTurn -= Weapon[i].Heat; // Missed Streaks generate no heat
    else
      AmmoState(Weapon[i].AmmoType,1);

    Pilot.TargetPenalty = 1; // If a weapon is fired, multiple target penalty
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Miss",r,Flag[i], Weapon[i].Name,Weapon[i].Damage);

    }

    y+=8;

  } // End for


getkey();
vsync();
blit    (block,screen,0,0, 50,120,550,250);
destroy_bitmap(block);
return 0;
}

int Mech::ConfigWeapons () {

// Show Menu
//
// Eject Ammo
// Called Shots     (High / Low)
// Aimed Shots      (Shutdown)
// Targeted Shots   (TargetingComputer / CT / RA )
// Rate of Fire

char String[80],iString[80];
char Trees = 0;
char ch = 0;
int  i,Itemnear = -1;


      
  sprintf(iString,"%s [R]ate of Fire [S]elect Ammo [E]ject Ammo",Name);
//  sprintf(iString,"%s [R]ate of Fire [E]ject Ammo",Name);

  sprintf(String,"%-65s Heat [%d]",iString,Heat);
  putString(String, Colour);

  while (ch != RETURNNULL) {
    switch (getkey()) {
    case 'R': ;
    case 'r': SetRateOfFire(); ch = RETURNNULL; break;
    case 'S': ;
    case 's': SetAmmoTypes (); ch = RETURNNULL; break;
    case 'E': ;
    case 'e': EjectAmmo   () ; ch = RETURNNULL; break;
    case 120  : ;
    case PgUp : ScrollUp();break;
    case 121  : ;
    case PgDn : ScrollDn();break;
    case 122  : ;
    case Home : ScrollLt();break;
    case 123  : ;
    case End  : ScrollRt();break;
    case 125: ;
    case 'i': getInfo()       ; break;
    case 27 : return 0;
    case 32 : return 0;
    case 13 : return 0;
    case 'C': ;
    case 'c': CentreMap(Vector.x,Vector.y) ;break;    
    case CTRLA: ToggleFastAI         (); break;
    case CTRLG: ToggleGrid           (); break;
    case CTRLW: ToggleShowWeapons    (); break;
    case CTRLS: ToggleCentreMap      (); break;
    case CTRLH: ToggleAltitudeDisplay(); break;
    case CTRLD: ToggleMovementDice   (); break;
    case CTRLO: ShowOptions          (); break;
    case CTRLE: screen_shot          (); break;
        default : break;
    };
  }

return 0;
}


int Mech::EjectAmmo () {
int i,j,k;
int Eject[20];
// Eject Ammo 0
for (k=0;k<Ammunitions;k++)
  Eject[k] = Off;

char key;
char cd[256];
int  Number;
int x,y,col=0;
char *EjectState[] = {"  ",
                      "Eject",
                      0x0000};

BITMAP *block;
block = create_bitmap(550,250);

x = 110;
y = 130;

blit    (screen,block,100,120,0,0,550,250);

cd['1'] = 0;
cd['2'] = 1;
cd['3'] = 2;
cd['4'] = 3;
cd['5'] = 4;
cd['6'] = 5;
cd['7'] = 6;
cd['8'] = 7;
cd['9'] = 8;
cd['0'] = 9 ;
cd['q'] = 11;
cd['w'] = 12;
cd['e'] = 13;
cd['r'] = 14;
cd['t'] = 15;
cd[8]   = 127;

AlphaFlag = 0;

for (i=0;i<Weapons;i++)
  Eject[i] = AlphaFlag;// * Weapon[i].Status;

while (key != FIRE && key != DONE && key != QUIT) {
//drawWeaponBox(vMech);
vsync();
rectfill(screen,100,120,600,360,Window.BGColour);

for (i=0;i<Ammunitions;i++) { // Should Really be an If Statement
  y = i * 8 + 130;
  textprintf(screen,font,x,y,col,"%2d>> %-20s <%3s>   <%3d> %s",i+1,Ammo[i].Name,LocName[Ammo[i].Loc],Ammo[i].Ammo,EjectState[Eject[i]]);
  }

key = getkey();

if (key != FIRE && key != DONE && key != QUIT) {

  if (key == 125) { // Left Mouse Button
    key = ((mouse_y-130+4)/8) + 48;
    key < 0 ? key = 100 : key;
    }
  
//  if (AmmoState(Weapon[cd[key]].Type,0) > 0)
    Eject[cd[key]] ^= 0x0001;
    
  if (cd[key] == 127) {
    AlphaFlag ^= 0x0001;
// Alpha Strike
    for (i=0;i<Ammunitions;i++)
        Eject[i] = AlphaFlag;
    }
  }
}

vsync();
blit    (block,screen,0,0,100,120,550,250);
destroy_bitmap(block);

for (k=0;k<Ammunitions;k++)
  if (Eject[k] == On) {
    i = Ammo[k].Loc ;
    j = Ammo[k].Pos ;
    Ammo[k].Type;
    Ammo[k].Ammo = 0;
    Crit[i][j].State = 0;
    }

return 0;
}

int Mech::ShowWeaponFire(int Weap, class Unit *Target) {
int i = Weap;
int x, y;
int xa, ya;
int x1 = (Vector.x-scrollx)*HexWidth+globalx+16;
int y1 = (Vector.y-scrolly)*HexHeight+globaly+18;

//int x1 = (Vector.x-scrollx)*HexWidth+globalx;
//int y1 = (Vector.y-scrolly)*HexHeight+globaly+18;
//int x1 = ((Vector.x-scrollx)*HexWidth)+globalx;
//int y1 = ((Vector.y-scrolly)*HexHeight)+globaly;

int x2 = (Target->Vector.x-scrollx)*HexWidth+globalx+16;
int y2 = (Target->Vector.y-scrolly)*HexHeight+globaly+18;

//for (i=0;i<Weapons;i++)
  if (Flag[i]>=1 && Flag[i]<=12 && WeaponTarget[i] == Target->Index) {

    xa  = FireCoor[UnitColour][Weapon[i].Loc].x;
    ya  = FireCoor[UnitColour][Weapon[i].Loc].y;
    
//    x  = x1 + int(x*cos((Vector.head-90)*PI/180))-int(y*sin((Vector.head-90)*PI/180));
    x   = int(xa*cos((Vector.head-90.0)*PI/180)) - int(ya*sin((Vector.head-90.0)*PI/180));
    y   = int(ya*cos((Vector.head-90.0)*PI/180)) + int(xa*sin((Vector.head-90.0)*PI/180));
    x  += x1;
    y  += y1;

    drawWeaponFire(Weapon[i].Effect,1,x,y,x2,y2);
//    textprintf(screen,font,20,20+i*10,0,">> %d",Weapon[i].Effect);
//    line(BITMAP *bmp, int x1, int y1, int x2, int y2, int color);
//    line(screen,x,y,x2,y2,makecol24(255,0,0));
    }
return 0;
}

int Mech::SetAmmoType(int Weap,int Amm) {
int OldAmm = Weapon[Weap].AmmoIndex;

if (OldAmm != -1) {
  Weapon[Weap].Damage        -= Ammo[OldAmm].Damage; // resets Weapon
  Weapon[Weap].DamageCluster -= Ammo[OldAmm].DamageCluster;
  Weapon[Weap].Cluster       -= Ammo[OldAmm].Cluster;
  Weapon[Weap].Accuracy      -= Ammo[OldAmm].Accuracy;
  Weapon[Weap].Missiles      -= Ammo[OldAmm].Missiles;
  }

Weapon[Weap].AmmoIndex      = Amm;

Weapon[Weap].Damage        += Ammo[Amm].Damage;
Weapon[Weap].DamageCluster += Ammo[Amm].DamageCluster;
Weapon[Weap].Cluster       += Ammo[Amm].Cluster;
Weapon[Weap].Accuracy      += Ammo[Amm].Accuracy;
Weapon[Weap].Missiles      += Ammo[Amm].Missiles;

return 0;
}

int Mech::InternalDamage(int Loc, int Facing, int Dam) {
int srt=Struct[RT],slt=Struct[LT],srl=Struct[RL],sll=Struct[LL],sra=Struct[RA],sla=Struct[LA];
int shift;
int i;
char String[40];

if ( Loc == 0 ) { // Head
  Pilot.Hits ++;
  ConcRoll();
  }

if ( Loc == 15) { // Back of the Head
  Pilot.Hits ++;
  ConcRoll();
  Loc = 0;
  }
// -4 equals Roll for Location
if ( Loc ==  -1) { // 0 = Head, -1 equals Crit
    if (Options.FloatingCrits == On)
      Loc = abs(HitLoc[Facing][roll2d6]);
    else Loc = HitLoc[Facing][7];
    Critical( Loc , 0);
    }

if ( Loc ==  -2) return Dam; // -2 equal wasted shot

//      sprintf(String,">--> %d   %d",TransferDamage[Loc],Dam);
//      putString(String,Colour);
//      getkey();

if (Loc < 8) { // Frontal Structure
    Struct[Loc] -= Dam;

  shift = 2<<Loc;
  if ((CaseLoc&shift)==shift); // Case for this Location
    else
  if (Struct[Loc] <= 0) {
    if (TransferDamage[Loc] != -1 && Options.TransferDamage == On) {
//      sprintf(String,">> %d   %d",TransferDamage[Loc],-Struct[Loc]);
//      putString(String,Colour);
//      getkey();

      Damage(TransferDamage[Loc],Facing,-Struct[Loc]);
      }
//    else
//      Damage(TransferDamage[Loc],Facing,Struct[Loc]);
  if (Struct[Loc] > 0)
    Critical(Loc, 0);
  else
    Destroy(Loc);

    Struct[Loc] = 0;
  }
} else {

  if (Dam > 0 && Loc < 11) {
    Struct[Loc-7] -= Dam;
    if (Struct[Loc-7] > 0)
      Critical(Loc-7, 0);
  }

  if (Dam > 0 && Loc > 10) {
    Struct[Loc-7] -= Dam;
    if (Struct[Loc-7] > 0)
      Critical(Loc-7, 0);
  }

  shift = 2<<(Loc-7);
  if (((CaseLoc-7)&shift)==shift); // Case for this Location
    else
  if (Struct[Loc-7] <= 0) {
    if (TransferDamage[Loc] != -1 && Options.TransferDamage == On)
      Damage(TransferDamage[Loc],Facing, -Struct[Loc-7]);
    Struct[Loc-7] = 0;

  }
}

if (Struct[HD] <= 0) Pilot.Hits += 6, ConcRoll();
if (Struct[CT] <= 0 || Struct[HD] <= 0) { Position = 0; drawUnit(1); Status = Off; Immobile = On;return 4;}
if (Struct[RT] <= 0 && srt > 0) Armour[RT]=0,Armour[RTr]=0, Destroy(RT);
if (Struct[LT] <= 0 && slt > 0) Armour[LT]=0,Armour[LTr]=0, Destroy(LT);
if (Struct[RT] <= 0 && srt > 0 && Struct[RA] > 0) Sever(RA); // Arm Blown Off
if (Struct[LT] <= 0 && slt > 0 && Struct[LA] > 0) Sever(LA);
if (Struct[RA] <= 0 && sra > 0) Destroy(RA);
if (Struct[LA] <= 0 && sla > 0) Destroy(LA);
if (Struct[RL] <= 0 && srl > 0) { Destroy(RL); if (Position == 1) Fall(1); }
if (Struct[LL] <= 0 && sll > 0) { Destroy(LL); if (Position == 1) Fall(1); }

return Loc;
}

int Mech::EngageMASC() {
char String[80];
//sprintf(String,">> %d %d ", LeftLeg.Hip, RightLeg.Hip);
//putString(String,Colour);
//getch();
if (MASCType!=1 || MASCNumber > 12) return 0; // If has no MASC of damaged MASC
if (MASCState == On) return 1;
if (roll2d6 >= MASCNumber) {
MASCState = On;
MASCNumber += 4;
sprintf(String," MASC ENGAGES !");
putString(String,Colour);
getkey();

} else {
//if (Options.MASCLocks == On) {
  RightLeg.Hip = Off; LeftLeg.Hip  = Off;
//  Crit[RL][0].State = 0; // Destroy Both Hips
//  Crit[LL][0].State = 0;
//  CriticalDamage(LL,0);
//  CriticalDamage(RL,0);
  MASCType = 0; // MASC Destroyed
  sprintf(String," MASC LOCKS !");
  putString(String,Colour);
  getkey();
  }

return 0;
}

int Mech::SetPosition()
{
int mpc;
int i, o, k;
int x,y,Move = On, dam;
int BuildingHeight = 0;
int BuildingModifier = 0;

x = Vector.x;
y = Vector.y;

// if (AdvanceOpen())
// AdvanceOpen
int UnitsInHex=0;
for (i=0;i<Units;i++)
  if ( (x == unit[i]->Vector.x && \
        y == unit[i]->Vector.y ) ) {
        UnitsInHex ++;
        if (Options.Stacking==On)
          if (unit[i]->Side!=Side&&MoveType>=0)
   	    Move = Off; // Can't stack with an enemy on the ground
          else {
            if (Stacked == Off)
              LastVector = Vector;              
            Stacked = Off;
            }
        }

// Max Units in hex
//if (UnitsInHex >= 5) Move = Off, Stacked = Off;

  // Hex Open, Unit can Advance
if (x<Xmin || x >= Xmax) // Mech Out Off bounds
  {Move = Off;MP = 0;}
//  if(Options.Retreat==On)Retreat(0);} // Add Retreat

if (y<Ymin || y >= Ymax) // Mech Out Off bounds
  {Move = Off;MP = 0;}
//  if(Options.Retreat==On)Retreat(0);} // Add Retreat

  if(MoveType<0) // If a Mech is Jumping, can't Jump over obstacle
    if(Altitude+Jump < MPH[Map.Hex[x][y].Alt])
      Move = Off;

// Buildings
  if (Map.Hex[x][y].Type == 'L') BuildingModifier = 1, BuildingHeight = 1;
  if (Map.Hex[x][y].Type == 'M') BuildingModifier = 2, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'H') BuildingModifier = 3, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'A') BuildingModifier = 5, BuildingHeight = 3;

  if (BuildingModifier != 0 && MoveType >= 0) // Buildings on Foot
    if (PilotingRoll >= genPilotModifier()+BuildingModifier) {
      Move = On;
        if (Tons > Map.Hex[x][y].Index) DamageHex(x,y,Map.Hex[x][y].Index), BuildingHeight = 0;}
      else Move = Off;
// BuildingDamage
// Water Submersion
  if (Position+1 <= - MPH[Map.Hex[Vector.x][Vector.y].Alt] && Map.Hex[Vector.x][Vector.y].Type == 'w') Submersed = On;
    else Submersed = Off;

  if (MPC[Map.Hex[x][y].Type] == 20 && MoveType>=0) // Impassable by Foot
    Move=Off;

  mpc = MPC[Map.Hex[x][y].Type];
  if (onRoad(Vector.x,Vector.y) && onRoad(x,y))
    mpc = 1, BuildingHeight = (RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt])>=0?(RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt]):0;

  mpc += abs(MPH[Map.Hex[Vector.x][Vector.y].Alt] - MPH[Map.Hex[x][y].Alt]);
  Altitude = MPH[Map.Hex[x][y].Alt] + BuildingHeight;

  MoveType< 0?mpc =1:mpc; // If a Mech is Jumping, only one MP / HEX
  Position==0?mpc+=4:mpc; // If Mech is Prone, crawl costs 4 MP

  Submersed==On?mpc+=4:mpc; // If Mech under water
  if (Map.Hex[x][y].Fire == 'f' || Map.Hex[x][y].Fire == 'F')
    HeatTurn += 2;
  
  if (Holding >= 0) Item[Holding].Vector = Vector; // If Mech moves, Item moves with it
//  if (MoveType >= 0 && Map.Hex[x][y].Type == 'w' && PilotingRoll < (genPilotModifier()-1-Pilot.FallBonus)) Fall(Altitude); // Mech can fall if it enters water hex

return Move;
}

int Mech::Shift() {
char String[80];
byte ch=0;
sprintf(String,"Lateral Shift   [Home]  [PgUp]  [End]   [PgDn]");
putString(String,Colour);
ScrollLock = On;

while (ch != RETURNNULL) {
  ch = getkey();
  switch (ch) {
//  case 'a'  : MP = 1; return 1;
//  case 32   : return 1;
  case PgUp : LateralShift(  60); ch = RETURNNULL ;break;
  case PgDn : LateralShift( 120); ch = RETURNNULL ;break;
  case Home : LateralShift( -60); ch = RETURNNULL ;break;
  case End  : LateralShift(-120); ch = RETURNNULL ;break;
  case 125  : ;//AbortGame(0);// Mouse Button 1
  case 'i'  : ;
  case 'I'  : getInfo  () ;break;
  case QUIT : ExitGame(0) ;break;
  case 'C'  : ;
  case 'c'  : CentreMap(Vector.x,Vector.y) ;break;
  case CTRLA: ToggleFastAI         (); break;
  case CTRLG: ToggleGrid           (); break;
  case CTRLW: ToggleShowWeapons    (); break;
  case CTRLS: ToggleCentreMap      (); break;
  case CTRLH: ToggleAltitudeDisplay(); break;
  case CTRLD: ToggleMovementDice   (); break;
  case CTRLO: ShowOptions          (); break;
  case CTRLE: screen_shot          (); break;

//  case EXAM : Exam(); return 0;break;
//  case 32   : return 0;
  default   : ;break;
  }
  }
ScrollLock = Off;

return 0;
}

int Mech::LateralShift(int Direction)
{
int mpc;
int i, o, k;
int x,y,Move = On, dam;
int BuildingHeight = 0;
int BuildingModifier = 0;

Direction += Vector.head;
Direction > 360 ? Direction -= 360: Direction;
Direction < 0   ? Direction += 360: Direction;

x = Vector.x + vec[Direction/30].x;
y = Vector.y + vec[Direction/30].y;

// if (AdvanceOpen())
// AdvanceOpen
int UnitsInHex=0;
for (i=0;i<Units;i++)
  if ( (x == unit[i]->Vector.x && \
        y == unit[i]->Vector.y ) ) {
        UnitsInHex ++;
        if (Options.Stacking==On)
          if (unit[i]->Side!=Side&&MoveType>=0)
   	    Move = Off; // Can't stack with an enemy on the ground
          else {
            if (Stacked == Off)
              LastVector = Vector;              
            Stacked = On;
            }
        }

// Max Units in hex
//if (UnitsInHex >= 5) Move = Off, Stacked = Off;

  // Hex Open, Unit can Advance
if (x<Xmin || x >= Xmax) // Mech Out Off bounds
  {Move = Off;MP = 0;}
//  if(Options.Retreat==On)Retreat(0);} // Add Retreat

if (y<Ymin || y >= Ymax) // Mech Out Off bounds
  {Move = Off;MP = 0;}
//  if(Options.Retreat==On)Retreat(0);} // Add Retreat

  if(MoveType<0) // If a Mech is Jumping, can't Jump over obstacle
    if(Altitude+Jump < MPH[Map.Hex[x][y].Alt])
      Move = Off;

// Buildings
  if (Map.Hex[x][y].Type == 'L') BuildingModifier = 1, BuildingHeight = 1;
  if (Map.Hex[x][y].Type == 'M') BuildingModifier = 2, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'H') BuildingModifier = 3, BuildingHeight = 2;
  if (Map.Hex[x][y].Type == 'A') BuildingModifier = 5, BuildingHeight = 3;

  if (BuildingModifier != 0 && MoveType >= 0) // Buildings on Foot
    if (PilotingRoll >= genPilotModifier()+BuildingModifier) {
      Move = On;
        if (Tons > Map.Hex[x][y].Index) DamageHex(x,y,Map.Hex[x][y].Index), BuildingHeight = 0;}
      else Move = Off;
// BuildingDamage
// Water Submersion
  if (Position+1 <= - MPH[Map.Hex[Vector.x][Vector.y].Alt] && Map.Hex[Vector.x][Vector.y].Type == 'w') Submersed = On;
    else Submersed = Off;

  if (MPC[Map.Hex[x][y].Type] == 20 && MoveType>=0) // Impassable by Foot
    Move=Off;

if (Move == On) {

  mpc = MPC[Map.Hex[x][y].Type]+1; // Lateral Shift Cost
  if (onRiver(x,y)) mpc ++;
  if (onRoad(Vector.x,Vector.y) && onRoad(x,y))
    mpc = 2, BuildingHeight = (RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt])>=0?(RoadHeight(x,y) - MPH[Map.Hex[x][y].Alt]):0;

//  mpc += abs(MPH[Map.Hex[Vector.x][Vector.y].Alt] - MPH[Map.Hex[x][y].Alt]);
  mpc += abs(Altitude - MPH[Map.Hex[x][y].Alt]-BuildingHeight);
  Altitude = MPH[Map.Hex[x][y].Alt] + BuildingHeight;

  MoveType< 0?mpc =1:mpc; // If a Mech is Jumping, only one MP / HEX
  Position==0?mpc+=4:mpc; // If Mech is Prone, crawl costs 4 MP

  Submersed==On?mpc+=4:mpc; // If Mech under water
  if (Map.Hex[x][y].Fire == 'f' || Map.Hex[x][y].Fire == 'F')
    HeatTurn += 2;

  if (HexesMoved == 0 || MP >= mpc) { // Can't advance if Mech lacks MP
    drawHex(Vector.x,Vector.y);

    Vector.x = x;
    Vector.y = y;

  if (UnitsInHex == 0) {
    if (Stacked == On)
      for (i=0;i<Units;i++)
        unit[i]->drawUnit(0);
      Stacked = Off;
      }

    drawUnit(0);
  
    if (Holding >= 0) Item[Holding].Vector = Vector; // If Mech moves, Item moves with it
    if (MoveType >= 0 && Map.Hex[x][y].Type == 'w' && PilotingRoll < (genPilotModifier()-1-Pilot.FallBonus)) Fall(0); // Mech can fall if it enters water hex

    MP -= mpc;
    HexesMoved ++;
    }
    else Move = Off; // Not Enough MP
  }

return Move;
}

int Mech::ReactorShutDown() {
ShutDown = 1;
Immobile = On;
MP = 0;
return 0;
}

int Mech::SetWeaponTarget(class Unit *Target) {
int i;

for (i=0;i<Weapons;i++)
  if (Flag[i] >= 2 && Flag[i] <= 12) {
    WeaponTarget[i] = Target->Index;
    Pilot.TargetPenalty = 1;
    }

return 0;
}

int Mech::ResolveWeaponFire() {

int Target;
int i,j;
int x = 60;
int y = 130;
int WeapUsed = 0;
//int Angle;
char String[80];

BITMAP *block;

  if (Options.SimultaneousWeaponFire == Off && Options.TwentyPointFalls == On)
    if (TurnDamage >= 20) // Mech may fall if it takes 20 pts of Damage
      if (roll2d6 < genPilotModifier())
        Fall(Position);

if (Options.SimultaneousWeaponFire == Off) return 0;

block = create_bitmap(550,250);

blit    (screen,block, 50,120,0,0,550,250);

  if (Options.ShowWeaponFire == On)
  for (i=0;i<Weapons;i++)
    if (WeaponTarget[i] != -1) {
      Target = WeaponTarget[i];
      ShowWeaponFire(i,unit[Target]);
      WeapUsed ++;
      }

if (WeapUsed > 0) {
  vsync();
  rectfill(screen, 50,120,550,360,Window.BGColour);
  }
  else return 1;
  unit[Index]->Hidden=On;

  for (i=0;i<Weapons;i++)
    if (WeaponTarget[i] != -1) {
      Target = WeaponTarget[i];
      sprintf(String,"%s fires on enemy %s",unit[Index]->Name,unit[Target]->Name);
      putString(String,Colour);
//      Flag[i] = 0;
//      Angle = getAttackAngle(Vector,unit[Target]->Vector);
//      genToHit(*unit[Target]); // Sets Flag as the To Hit
//      WeaponSelect(getAttackAngle(Vector,unit[Target]->Vector)-Turret);

      unit[Target]->Hidden=On;
      y=unit[Target]->ResolveWeapon(unit[Index],i,x,y);
      unit[Target]->Hidden=Off;
//      y += 8;
      }

  unit[Index]->Hidden=Off;

if (WeapUsed > 0) {
  getkey();
  vsync();
  blit    (block,screen,0,0, 50,120,550,250);
  destroy_bitmap(block);
  }
ScrollLock = On;

  for (i=0;i<Weapons;i++)
    if (WeaponTarget[i] != -1) {
      Target = WeaponTarget[i];
      drawHex (unit[Target]->Vector.x,unit[Target]->Vector.y);
      unit[Target]->drawUnit(0);
      }

  if (Options.TwentyPointFalls == On)
    if (TurnDamage >= 20) // Mech may fall if it takes 20 pts of Damage
      if (Options.CumulativeTwentyPointFalls == On) {
        if ((roll2d6+(TurnDamage/20)-1) < genPilotModifier())
          Fall(Position); }
      else
      if (roll2d6 < genPilotModifier())
        Fall(Position);

return 0;
}

int Mech::ResolveWeapon(class Unit *Attacker, int ActiveWeapon, int x, int y) {
int i,j,k,r,d,l,c,a;
int MisHit; // # of Missiles that actually Connect
int col=Window.TextColour;
int PartialCover;
int Dam,DamageCluster,Cluster;
char bString[40];

sprintf(bString,"Missiles");

ScrollLock = Off;

//BITMAP *block;
//block = create_bitmap(550,250);

//x = 60;
//y = 130;

//blit    (screen,block, 50,120,0,0,550,250);
//vsync();
//rectfill(screen, 50,120,550,360,Window.BGColour);

//PartialCover = ProcCover(LOSstring,0,2,0,2);
PartialCover = ProcCover(LOSstring,Attacker->Altitude,Attacker->Position+1,Altitude,Position+1);
i = ActiveWeapon;
//for (i=0;i<Attacker->Weapons;i++) {
    r = GunneryRoll;
  if (Attacker->AmmoState(Attacker->Weapon[i].AmmoType,0) < Attacker->Weapon[i].AmmoConsumption )
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d Ammo Depleted",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Options.WeaponJams == On && Weapon[i].Jams == 1 && r <= Weapon[i].JamMod+(Weapon[i].RateOfFire/2))
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d Weapon Jams",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Attacker->Flag[i] == 0)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d F%3d OFFLINE",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Attacker->Flag[i] == 127)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Used",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Attacker->Flag[i] > 12)
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Target ERROR - Shot Aborted",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage,Attacker->Flag[i]);
  else
  if (Attacker->Flag[i] <= r) {
  Attacker->Pilot.TargetPenalty = 1; // If a weapon is fired, multiple target penalty

    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d ",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage);
    Attacker->AmmoState(Attacker->Weapon[i].AmmoType,1);

  HeatTurn += Attacker->Weapon[i].TargetHeat;
  Infernos += Attacker->Weapon[i].Persistence; // Inferno
  k = Attacker->Weapon[i].Missiles*Attacker->Weapon[i].RateOfFire;

  if (Options.GlancingHits == On && Attacker->Flag[i] == r)
    Cluster = -2; // Glancing Hit
  else Cluster = 0;
  if (Options.MissileBonus == On) Cluster += r - Attacker->Flag[i];

  if (ECMType == 1)
    Cluster =  roll2d6 + Cluster; // Artemis jammed
  else
    Cluster =  roll2d6 + Attacker->Weapon[i].Cluster + Cluster; // Artemis etc.
    Cluster<0?Cluster=0:Cluster>12?Cluster=12:Cluster;// Bind Cluster

    c = Misptr[k][Cluster];
//    c<1?c=1:c;

    for (j=0;j<Weapons;j++) {
//      textprintf(screen,font,300,10+j*10,col,"AMS Intercepts [%d] ",Weapon[j].MissileIntercepts);
//      if (Attacker->Weapon[i].AMS == On && Weapon[j].MissileIntercepts > 0 && AmmoState(Weapon[j].Type,0) > 0 && Flag[j]!=127) {
      if (Attacker->Weapon[i].AMS == On && Weapon[j].MissileIntercepts > 0 && AmmoState(Weapon[j].AmmoType,0) > 0 && Flag[j]!=127) {
//      if (Weapon[j].MissileIntercepts > 0 && Flag[j]!=127) {
        a = rollxd6(Weapon[j].MissileIntercepts); c -= a; AmmoState(Weapon[j].AmmoType,a); Flag[j] = 127;
        HeatTurn += rollxd6(Weapon[j].RandomHeat);
        y+=8;
        textprintf(screen,font,x,y,col,"AMS Intercepts %d %s",a,bString);
        }
      }
    c<0?c=0:c;

    Dam = c * Attacker->Weapon[i].Damage;
    DamageCluster = Attacker->Weapon[i].DamageCluster;

  if (Dam == DamageCluster) { // One Hit / Med/Laser
        l = getFacing(getDamageAngle(Attacker->Vector,Vector));
        if(PartialCover==Off)k=HitLoc[l][roll2d6];
          else k=PunchLoc[l][rolld6];

        if(Attacker->Pilot.Aim == LEFT)  l==0?l=2:l==1?l=0:l==2?l=3:l==3?l=1:0;
        if(Attacker->Pilot.Aim == RIGHT) l==0?l=1:l==1?l=3:l==2?l=0:l==3?l=2:0;
        if(Attacker->Pilot.Aim == HIGH)  d=PunchLoc[l][rolld6];
        if(Attacker->Pilot.Aim == LOW)   d=KickLoc[l][rolld6];

        if(Attacker->Pilot.Aim == AIM && Attacker->Weapon[i].Class != 3) {
          d = roll2d6;
          if (d == 6 || d == 7 || d == 8)
            k=Attacker->Pilot.AimTarget; }

        if(Attacker->Pilot.Aim == TARGETED  && Attacker->Weapon[i].Class != 3)
            k=Attacker->Pilot.AimTarget;
            
        if (Options.GlancingHits == On && Attacker->Flag[i] == r)
  	  Damage(k, l,(Dam)/2); // Glancing Hit
        else
  	  Damage(k, l, Dam );
        y+=8;
        textprintf(screen,font,x,y,col,"Hits %s",LocationName[k+1]);
      }
  else {
        y+=8;
        textprintf(screen,font,x,y,col," %d %s Hit ",c,bString);
        l = getFacing(getDamageAngle(Attacker->Vector,Vector));

      for (k=DamageCluster;k<=Dam;k+=DamageCluster) {
        if(PartialCover==Off)d=HitLoc[l][roll2d6];
          else d=PunchLoc[l][rolld6];

        if(Attacker->Pilot.Aim == LEFT)  l==0?l=2:l==1?l=0:l==2?l=3:l==3?l=1:0;
        if(Attacker->Pilot.Aim == RIGHT) l==0?l=1:l==1?l=3:l==2?l=0:l==3?l=2:0;
        if(Attacker->Pilot.Aim == HIGH)  d=PunchLoc[l][rolld6];
        if(Attacker->Pilot.Aim == LOW)   d=KickLoc[l][rolld6];

        Damage( d ,l,DamageCluster);
        y+=8;
        textprintf(screen,font,x,y,col,"Hits %s",LocationName[d+1]);
        }

        if (PartialCover==Off) d=HitLoc[l][roll2d6];
          else d=PunchLoc[l][rolld6];

        if(Attacker->Pilot.Aim == LEFT)  l==0?l=2:l==1?l=0:l==2?l=3:l==3?l=1:0;
        if(Attacker->Pilot.Aim == RIGHT) l==0?l=1:l==1?l=3:l==2?l=0:l==3?l=2:0;
        if(Attacker->Pilot.Aim == HIGH)  k=PunchLoc[l][rolld6];
        if(Attacker->Pilot.Aim == LOW)   k=KickLoc[l][rolld6];
        
        y+=8;
        if (Dam%DamageCluster>0) {
          textprintf(screen,font,x,y,col,"Hits %s",LocationName[d+1]);
          Damage( d ,l,Dam%DamageCluster);
          }
        }

  } // End if
    else {
    if (Attacker->Weapon[i].Locking == On && ECMType == 0)
      Attacker->HeatTurn -= Attacker->Weapon[i].Heat; // Missed Streaks generate no heat
    else
      Attacker->AmmoState(Attacker->Weapon[i].AmmoType,1);

    Pilot.TargetPenalty = 1; // If a weapon is fired, multiple target penalty
    textprintf(screen,font,x,y,col,"%3d/%-3d %-20s : %3d Miss",r,Attacker->Flag[i], Attacker->Weapon[i].Name,Attacker->Weapon[i].Damage);

    if (Map.Hex[Vector.x][Vector.y].Type=='t'||Map.Hex[Vector.x][Vector.y].Type=='T')
      if (roll2d6 <= 3)
        CreateFire(Vector.x,Vector.y);
    }
    y+=8;

//  } // End for


//getkey();
//vsync();
//ScrollLock = On;
//blit    (block,screen,0,0, 50,120,550,250);
//destroy_bitmap(block);
return y;
}

int Mech::ResolvePhysicalAttacks() {

int i,j;
int Table,f;
int loc;
int Target;
char ch=0;

if (Options.SimultaneousPhysicalAttacks == Off) return 0;

for (i=0;i<PhysAttacks;i++) {
  Table = PhysAttack[i].Table / 4;
  f     = PhysAttack[i].Table % 4;

  switch (Table) {
  case 0: loc = HitLoc[f][roll2d6] ; break;
  case 1: loc = PunchLoc[f][roll2d6];break;
  case 2: loc = KickLoc[f][roll2d6]; break;
  case 3: loc = QuadLoc[f][roll2d6]; break;
  default : loc = -2; break;
  }

    Target = PhysAttack[i].Target;
    for (j=PhysAttack[i].Group;j<PhysAttack[i].Damage;j+=PhysAttack[i].Group)
      unit[Target]->Damage(loc,f,j);

      unit[Target]->Damage(loc,f,PhysAttack[i].Group);

    if (PhysAttack[i].Fall > 0)
      unit[Target]->Fall(PhysAttack[i].Fall-1);

  }

return 0;
}

int Mech::SetRateOfFire () {
int i,j,k;
int ROF[20];
// Eject Ammo 0
for (k=0;k<Weapons;k++)
  ROF[k] = Weapon[k].RateOfFire;

char key;
char cd[256];
int  Number;
int x,y,col=0;

BITMAP *block;
block = create_bitmap(550,250);

x = 110;
y = 130;

blit    (screen,block,100,120,0,0,550,250);

cd['1'] = 0;
cd['2'] = 1;
cd['3'] = 2;
cd['4'] = 3;
cd['5'] = 4;
cd['6'] = 5;
cd['7'] = 6;
cd['8'] = 7;
cd['9'] = 8;
cd['0'] = 9 ;
cd['q'] = 11;
cd['w'] = 12;
cd['e'] = 13;
cd['r'] = 14;
cd['t'] = 15;
cd[8]   = 127;

while (key != FIRE && key != DONE && key != QUIT) {
//drawWeaponBox(vMech);
vsync();
rectfill(screen,100,120,600,360,Window.BGColour);
y = 130;
for (i=0;i<Weapons;i++) {
  if (Weapon[i].AmmoConsumption > 0)
    textprintf(screen,font,x,y,col,"%2d >> %-20s <%3d> <%2s> [%2d]",i+1,Weapon[i].Name,AmmoState(Weapon[i].AmmoType,0),LocName[Weapon[i].Loc],ROF[i]);
  else
    textprintf(screen,font,x,y,col,"%2d >> %-20s       <%2s> [%2d]",i+1,Weapon[i].Name,AmmoState(Weapon[i].AmmoType,0),LocName[Weapon[i].Loc],ROF[i]);
  y+=8;
  }

key = getkey();

if (key != FIRE && key != DONE && key != QUIT) {

  if (key == 125) { // Left Mouse Button
    key = ((mouse_y-130+4)/8) + 48;
    key < 0 ? key = 100 : key;
    }
  
//  if (AmmoState(Weapon[cd[key]].Type,0) > 0)
  if (cd[key] != 127)
    if (Flag[cd[key]] != 127)
      ROF[cd[key]] ++;
    
  if (cd[key] == 127)
// Alpha Strike
    for (i=0;i<Weapons;i++)
      if (Flag[i] != 127)
        ROF[i]++;

    for (i=0;i<Weapons;i++)
      if (ROF[i] > Weapon[i].FireMode) ROF[i] = 1;

  }
}

vsync();
blit    (block,screen,0,0,100,120,550,250);
destroy_bitmap(block);

for (k=0;k<Weapons;k++)
  Weapon[k].RateOfFire = ROF[k];

return 0;
}

int Mech::AimedShot() {
char String[80];
char ch = 0;
int  i;
int  Target;
int  Angle;
//char iString[80];

//    sprintf(String,"Select Target",Name);
//    putString(String,Colour);
    if (Options.AimedShots == Off)      return 0;
    if (MoveType == 3 || MoveType == 4) return 0;

    Cursor.x = Vector.x;
    Cursor.y = Vector.y;

    Target = getTarget(1); // Target Enemies Only
    // If Target == -1, then it has targeted a hex
    if (Target != -1) {
      if (CompType == 1 || unit[Target]->Immobile == On)
        sprintf(String,"Target : [%s]  [U]naimed Shot  [A]imed Shot  [T] Called Shot",unit[Target]->Name);
      else
      if (Options.CalledShots == On)
        sprintf(String,"Target : [%s]  [U]naimed Shot  [T] Called Shot",unit[Target]->Name);
      else
        sprintf(String,"Target : [%s]  [U]naimed Shot  ",unit[Target]->Name);

      putString(String,Colour);

      Angle = getAttackAngle(Vector,unit[Target]->Vector);

      while (ch != RETURNNULL)
        switch (getkey()) {
        case 'u'  : ;
        case 'U'  : return 0;
        case 'a'  : ;
        case 'A'  : if (CompType == 1 || unit[Target]->Immobile == On) AimTarget (unit[Target]); ch = RETURNNULL; break;
        case 't'  : ;
        case 'T'  : if (Options.CalledShots == On) CallTarget(unit[Target]); ch = RETURNNULL; break;
        case 120  : ;
        case PgUp : ScrollUp();break;
        case 121  : ;
        case PgDn : ScrollDn();break;
        case 122  : ;
        case Home : ScrollLt();break;
        case 123  : ;
        case End  : ScrollRt();break;
        case 125: ;
        case 'i': getInfo()       ; break;
//        case ESC: ExitGame(0)     ; break;
        case 27 : ch = RETURNNULL; break ;
        case 32 : ch = RETURNNULL; break ;
        case 13 : ch = RETURNNULL; break ;
        case 'C': ;
        case 'c': CentreMap(Vector.x,Vector.y) ;break;    
        case CTRLA: ToggleFastAI         (); break;
        case CTRLG: ToggleGrid           (); break;
        case CTRLW: ToggleShowWeapons    (); break;
        case CTRLS: ToggleCentreMap      (); break;
        case CTRLH: ToggleAltitudeDisplay(); break;
        case CTRLD: ToggleMovementDice   (); break;
        case CTRLO: ShowOptions          (); break;
        case CTRLE: screen_shot          (); break;

        default : break;
        };


      genToHit(*unit[Target]); // Sets Flag as the To Hit
      WeaponSelect(getAttackAngle(Vector,unit[Target]->Vector)-Turret,Target);

      SetWeaponTarget(unit[Target]);
      if (Options.SimultaneousWeaponFire == Off) {
//      if (Options.ShowWeaponFire == On)
//        ShowWeaponFire(unit[Target]);
      if (Options.ShowWeaponFire == On)
        for (i=0;i<Weapons;i++)
          if (WeaponTarget[i] != -1) {
            Target = WeaponTarget[i];
            ShowWeaponFire(i,unit[Target]);
            }

        unit[Target]->Hidden=On;
        unit[Target]->ResolveWeapons(unit[Index]);
        unit[Target]->Hidden=Off;

        drawHex (unit[Target]->Vector.x,unit[Target]->Vector.y);
        unit[Target]->drawUnit(0);
        }

      }

//    if (Options.MultiTarget == On)
    putString(String,Colour);

ch = 0;
//if (Pilot.TargetPenalty == 1) // Weapon Fired, Turn over
for (i=0;i<Weapons;i++)
  if (Flag[i] >= 2 && Flag[i] <= 12) // Weapon Aimed, Turn Over
    ch = RETURNNULL;
//else
//  ch = 0;

return ch;
}

int Mech::AimTarget (class Unit *Target) {

// Show Menu
//
// Eject Ammo
// Called Shots     (High / Low)
// Aimed Shots      (Shutdown)
// Targeted Shots   (TargetingComputer / CT / RA )
// Rate of Fire

char String[80],iString[80];
char Trees = 0;
char ch = 0;
int  Itemnear = -1;

int  i  = -1;
int  x, y;
int  Angle;
int  Facing;

  Angle = getAttackAngle(Vector,Target->Vector);
  Facing = getFacing(Angle);

  BITMAP *block;
  block = create_bitmap(550,250);

  blit(screen,block, 50,120,0,0,550,250);
  rectfill(screen, 100,150,500,360,Window.BGColour);

  if (Facing == 3) {
    x = 110;
    y = 160;
    if (Target->Immobile == On)
    textprintf(screen,font,x,y,Window.TextColour,"                    [1] [H]ead ");
    y += 8;
    textprintf(screen,font,x,y,Window.TextColour,"   [2] Rear LT      [3] Rear CT       [4] Rear RT");
    y += 16;
    textprintf(screen,font,x,y,Window.TextColour,"[5] Left Arm                             [6] Right Torso ");
    y += 24;
    textprintf(screen,font,x,y,Window.TextColour,"      [7] Left Leg                 [8] Right Leg");  
  } else {
    x = 110;
    y = 160;

    if (Target->Immobile == On)
    textprintf(screen,font,x,y,Window.TextColour,"             [1] [H]ead ");

    y += 8;
    textprintf(screen,font,x,y,Window.TextColour,"   [2] Left Torso      [4] Right Torso");
    y += 8;
    textprintf(screen,font,x,y,Window.TextColour,"             [3] Centre Torso");
    y += 16;
    textprintf(screen,font,x,y,Window.TextColour,"[5] Left Arm                 [6] Right Torso ");
    y += 24;
    textprintf(screen,font,x,y,Window.TextColour,"   [7] Left Leg        [8] Right Leg");
    }

  int AimType = AIM;
  if (CompType == 1)
    AimType = TARGETED;
  int FacingBonus;
  int HeadBonus;

  if (Facing == 3) HeadBonus = 15, FacingBonus = 7;
    else HeadBonus =  0, FacingBonus = 0;

  // All Locs need a Facing bonus because facing won't transfer
  while (ch != RETURNNULL) {
    ch = getkey();
    switch (ch) {
    case '1': if (Target->Immobile == On) Pilot.Aim = AimType; Pilot.AimTarget = 0+HeadBonus  ; ch = RETURNNULL;break;
    case '2': Pilot.Aim = AimType; Pilot.AimTarget = 3+FacingBonus; ch = RETURNNULL;break;
    case '3': Pilot.Aim = AimType; Pilot.AimTarget = 1+FacingBonus; ch = RETURNNULL;break;
    case '4': Pilot.Aim = AimType; Pilot.AimTarget = 2+FacingBonus; ch = RETURNNULL;break;
    case '5': Pilot.Aim = AimType; Pilot.AimTarget = 5+FacingBonus; ch = RETURNNULL;break;
    case '6': Pilot.Aim = AimType; Pilot.AimTarget = 4+FacingBonus; ch = RETURNNULL;break;
    case '7': Pilot.Aim = AimType; Pilot.AimTarget = 7+FacingBonus; ch = RETURNNULL;break;
    case '8': Pilot.Aim = AimType; Pilot.AimTarget = 6+FacingBonus; ch = RETURNNULL;break;
    case 27 : ch = RETURNNULL; break;
    case 13 : ch = RETURNNULL; break;
    case 32 : ch = RETURNNULL; break;
    default : ;break;
    }
  }
    
  blit(block,screen,0,0, 50,120,550,250);
  destroy_bitmap(block);

return 0;
}

int Mech::CallTarget (class Unit *Target) {

// Show Menu
//
// Eject Ammo
// Called Shots     (High / Low)
// Aimed Shots      (Shutdown)
// Targeted Shots   (TargetingComputer / CT / RA )
// Rate of Fire

char String[80],iString[80],lString[20];
char Trees = 0;
char ch = 0;
int  Itemnear = -1;

int  i  = -1;
int  x, y;
int  Angle;
int  Facing;
int  PartialCover;


  Angle = getAttackAngle(Vector,Target->Vector);
  PartialCover = ProcCover(LOSstring,Altitude,Position+1,Target->Altitude,Target->Position+1);
  Facing = getFacing(Angle);

  if (PartialCover == 1)
    sprintf(lString,"");
  else
    sprintf(lString,"[2] Low");

  if (Facing == 0)
    sprintf(String,"Aim Shot [1] High %s [3] Left [4] Right",lString);
  if (Facing == 1)
    sprintf(String,"Aim Shot [1] High %s ",lString);
  if (Facing == 2)
    sprintf(String,"Aim Shot [1] High %s ",lString);
  if (Facing == 3)
    sprintf(String,"Aim Shot [1] High %s [3] Left [4] Right",lString);
    putString(String,Colour);

  // All Locs need a Facing bonus because facing won't transfer
  while (ch != RETURNNULL) {
    ch = getkey();
    switch (ch) {
    case '1': Pilot.Aim = HIGH ; ch = RETURNNULL;break;
    case '2': if (PartialCover == 0) Pilot.Aim = LOW  ; ch = RETURNNULL;break;
    case '3': Pilot.Aim = LEFT ; ch = RETURNNULL;break;
    case '4': Pilot.Aim = RIGHT; ch = RETURNNULL;break;
    case 27 : ch = RETURNNULL; break;
    case 13 : ch = RETURNNULL; break;
    case 32 : ch = RETURNNULL; break;
    default : ;break;
    }
  }

  if (Facing == 1 || Facing == 2)
    if (Pilot.Aim == LEFT || Pilot.Aim == Right)
      Pilot.Aim = Off;

return 0;
}

int Mech::validQuad() {
int State = Off;
if (MechType==QUADMECH)
  if (Struct[RA]>0 && Struct[LA]>0 && Struct[RL]>0 && Struct[LL]>0)
    State = On;
return State;
}

int Mech::SetAmmoTypes () {
int i,j,k;
int ROF[20];
// Eject Ammo 0
for (k=0;k<Weapons;k++)
  ROF[k] = Weapon[k].RateOfFire;

char key;
char cd[256];
int  Number;
int x,y,col=0;

BITMAP *block;
block = create_bitmap(550,250);

x = 110;
y = 130;

blit    (screen,block,100,120,0,0,550,250);

cd['1'] = 0;
cd['2'] = 1;
cd['3'] = 2;
cd['4'] = 3;
cd['5'] = 4;
cd['6'] = 5;
cd['7'] = 6;
cd['8'] = 7;
cd['9'] = 8;
cd['0'] = 9 ;
cd['q'] = 11;
cd['w'] = 12;
cd['e'] = 13;
cd['r'] = 14;
cd['t'] = 15;
cd[8]   = 127;

while (key != FIRE && key != DONE && key != QUIT) {
//drawWeaponBox(vMech);
vsync();
rectfill(screen,100,120,600,360,Window.BGColour);
y = 130;
for (i=0;i<Weapons;i++) {
  if (Weapon[i].AmmoConsumption > 0)
    textprintf(screen,font,x,y,col,"%2d >> %-20s <%3d> <%2s>  %2d",i+1,Weapon[i].Name,AmmoState(Weapon[i].AmmoType,0),LocName[Weapon[i].Loc],Weapon[i].AmmoIndex);
  else
    textprintf(screen,font,x,y,col,"%2d >> %-20s       <%2s>     ",i+1,Weapon[i].Name,LocName[Weapon[i].Loc]);
  y+=8;
  }

key = getkey();

if (key != FIRE && key != DONE && key != QUIT) {

  if (key == 125) { // Left Mouse Button
    key = ((mouse_y-130+4)/8) + 48;
    key < 0 ? key = 100 : key;
    }
  
//  if (AmmoState(Weapon[cd[key]].Type,0) > 0)
  if (Flag[cd[key]] != 127) {

  j=Weapon[cd[key]].AmmoIndex+1;
  k=0;
//  while ((Weapon[cd[key]].AmmoType != Ammo[j].AmmoType) && j!=k) {
  while ((Weapon[cd[key]].AmmoType != Ammo[j].AmmoType) && k != Ammunitions) {
    j++;
    k++;
    if (j>=Ammunitions) j = 0;
    }
    Weapon[cd[key]].AmmoIndex = j;
//    if (Weapon[cd[key]].AmmoConsumption > 0) {
//      SetAmmoType(cd[key],j);
//      }

  }
/*
  if (cd[key] == 127)
// Alpha Strike
    for (i=0;i<Weapons;i++) {
     j=Weapon[i].AmmoIndex;
     k=j-1;
     while ((Weapon[i].AmmoType != Ammo[j].AmmoType) && j!=k) {
       j++;
       if (j>=Ammunitions) j = 0;
       if (Weapon[i].AmmoConsumption > 0) {
         SetAmmoType(i,j);
        }
      }
    }
*/

  }
}

vsync();
blit    (block,screen,0,0,100,120,550,250);
destroy_bitmap(block);

//for (k=0;k<Weapons;k++)
//  Weapon[k].RateOfFire = ROF[k];

return 0;
}

int Mech::Retreat() {
drawHex (Vector.x,Vector.y);
Vector.x = -1;
Vector.y = -1;
Status   = Off;
drawUnits();
return 0;
}

int Mech::HullIntegrity() {
int i,j;
int Loc,Pos;
if (Submersed == On)
  for (i=0;i<8;i++)
    if (Armour[i] == 0)
      for (j=0;j<CritSlot[i];i++) {
        Loc = i; Pos = j;
        Crit[Loc][Pos].State = -1;

  switch (Crit[Loc][Pos].Class) {
  case 1: WeaponDisable(Loc,Crit[Loc][Pos].Type);break; // Weapons
  case 2: AmmoExplosion(Loc,Pos);break; // Ammo
  case 3:// Equipment
    if (Crit[Loc][Pos].Type  == 0) // HeatSinks
      HeatSinks --;
    if (Crit[Loc][Pos].Type  == 1) // JumpJets
      Jump --;
    if (Crit[Loc][Pos].Type  == 3) // Artemis IV
      for (i=0;i<Weapons;i++)
        if (Weapon[i].Linked == 3 && Weapon[i].Loc == Loc) {
          Weapon[i].Linked = 0;
          Weapon[i].Cluster = 0;
          i+=Weapons; // Quit Loop
          }          
    if (Crit[Loc][Pos].Type  == 4) // Hatchet
      if (Loc == RA) RightHatchetType = 0;
        else
      if (Loc == LA) LeftHatchetType  = 0;

      break;
  case 4: // Equipment / Actuators
  if (Crit[Loc][Pos].Type  == 0) // Shoulder
       if (Loc == 4) RightArm.Shoulder = Off;
       else if (Loc == 5) LeftArm.Shoulder  = Off;
  if (Crit[Loc][Pos].Type  == 1) // Upper Arm
       if (Loc == 4) RightArm.UpperArm = Off;
       else if (Loc == 5) LeftArm.UpperArm  = Off;
  if (Crit[Loc][Pos].Type  == 2) // Lower Arm
       if (Loc == 4) RightArm.LowerArm = Off;
       else if (Loc == 5) LeftArm.LowerArm  = Off;
  if (Crit[Loc][Pos].Type  == 3) // Hand
       if (Loc == 4) RightArm.Hand = Off;
       else if (Loc == 5) LeftArm.Hand  = Off;
  if (Crit[Loc][Pos].Type  == 4) // Hip
       if (Loc == 6) RightLeg.Hip = Off;
       else if (Loc == 7) LeftLeg.Hip  = Off;
  if (Crit[Loc][Pos].Type  == 5) // Upper Leg
       if (Loc == 6) RightLeg.UpperLeg = Off;
       else if (Loc == 7) LeftLeg.UpperLeg  = Off;
  if (Crit[Loc][Pos].Type  == 6) // Lower Leg
       if (Loc == 6) RightLeg.LowerLeg = Off;
       else if (Loc == 7) LeftLeg.LowerLeg  = Off;
  if (Crit[Loc][Pos].Type  == 7) // Foot
       if (Loc == 6) RightLeg.Foot = Off;
       else if (Loc == 7) LeftLeg.Foot  = Off;

  if (Crit[Loc][Pos].Type  == 8) // Engine
       EngineHits ++;
  if (EngineHits >= 3) Immobile = On;
  if (Crit[Loc][Pos].Type  == 9) // Gyro
       { GyroHits ++; if (PilotingRoll < genPilotModifier()-Pilot.FallBonus) Fall(1); }
  if (Crit[Loc][Pos].Type  ==10) // Life Support
       LifeSupportHits ++;
  if (Crit[Loc][Pos].Type  ==12) // Sensors
       SensorHits ++;
  if (Crit[Loc][Pos].Type  ==11) // Cockpit
       Immobile = On, Pilot.Hits += 6,Status = Off; // Mech Destroyed
  if (Crit[Loc][Pos].Type  ==13) // XL Engine
       EngineHits ++;
     break;
  default : ;break;
  };

        }

return 0;
}

int Mech::Swat(class Unit *Target, int Arm) {
int Range, Modifier,r,loc,f;
int ToHit,Loc;
int PunchDamage;
int AltDiff = Altitude - Target->Altitude;
int Table;
char String[40];

PunchDamage = ( Tons + 5 ) / 10;

if (Submersed == On) PunchDamage /= 2;
if (TSMState  == On) PunchDamage *= 2;

ToHit = genPilotModifier()+4;

if (Arm == RA)
  if (RightArm.Shoulder == Off) ToHit += 4, PunchDamage /= 2;
    else
  if (RightArm.UpperArm == Off) ToHit += 2, PunchDamage /= 2;
    else
  if (RightArm.LowerArm == Off) ToHit += 2, PunchDamage /= 2;
    else
  if (RightArm.Hand     == Off) ToHit += 1;
else
  if (LeftArm.Shoulder  == Off) ToHit += 4, PunchDamage /= 2;
    else
  if (LeftArm.UpperArm  == Off) ToHit += 2, PunchDamage /= 2;
    else
  if (LeftArm.LowerArm  == Off) ToHit += 2, PunchDamage /= 2;
    else
  if (LeftArm.Hand      == Off) ToHit += 1;

r = PilotingRoll;

if (Carrying < 0) return 0;
if (Arm == RA) f = 2;
if (Arm == LA) f = 1;
Loc = PunchLoc[f][rolld6];

if (r >= ToHit)
    sprintf(String,"Swat Connects "),
    unit[Carrying]->Drop(PunchDamage);
  else
    sprintf(String,"Swat Missed, damage to %s",LocName[Loc]),
    Damage (Loc,f,PunchDamage);

  putString(String,Colour);
//  getch();
getkey();
return 0;
}

int Mech::MouseMove(int Mode) {
int  x,y;

  x=mouse_x-globalx; y=mouse_y-globaly;
  x-=(y/HexHeight & 0x0001) * HexWidth; // Improved
  x/=HexWidth;       y/=HexHeight;
  x &= 0xFFFE;
  x += y & 0x0001;
  x += scrollx;
  y += scrolly;

if (Mode == 1)
  Viper (u,x,y,MP,-1);
if (Mode == 0)
  MilkSnake (u,x,y,MP,-1);

return 0;
}

//////////////////////////////////////////////////////////////////
//
// BV Generator
//

int Mech::CalcBV(int Type) {
// BV Types
// 0 BV Modded by Piloting
// 1 BV Unmodded
// 2 DEF BV
// 3 OFF BV
float x,y;
float GunneryMod[] = {2.05,1.85,1.65,1.45,1.25,1.15,1.05,0.95,0.85,0.75,0.65,0x0000};
int value,def,off;
int i,j,k,s;
int MaxHeat,HeatDisp;
//                          5        10        15        20        25  
int SpeedMod[] = {0,0,0,1,1,2,2,3,3,3,4,4,4,4,5,5,5,5,5,6,6,6,6,6,6,7,0x0000};

if (Type > 3 || Type < 0) Type = 1;

x = 0;

if (HeatSinkType == 0)
  HeatDisp = HeatSinks;
else
  HeatDisp -= HeatSinks*2;

MaxHeat = Jump; for (i=0;i<Weapons;i++) MaxHeat += Weapon[i].Heat;

// Defensive :
// Struct
s = 0; for (i=0;i<8;i++) s += Struct[i];
x += s * 1.125 +.5;

// Armour  
s = 0; for (i=0;i<11;i++) s += Armour[i];
x += s * 2;

x += Tons;
// Defensive Equipment
// Ammo
// Heat Modifier
if ((MaxHeat-HeatDisp)>0) def -= 5 * MaxHeat-HeatDisp;
// Movement Mod (Level 3 Toggle)
//if (getSpeed[2] > 25 && Options.Lvl3speedmod == On ) s = 7;
//if (getSpeed[2] > 10 && Options.Lvl3speedmod == Off) s = 4;
if (getSpeed(2) > 10 ) s = 4;
  else s = SpeedMod[getSpeed(2)];

def = int ( ( x * (1.0 + (s*0.1)) ) + .5 );


// Offensive :
// Weapons
k = 0;
for (i=0;i<Weapons;i++) k += Weapon[i].BV; // Add Art IV Mod
  
for (i=0;i<Ammunitions;i++) k += Ammo[i].BV;

x = (HeatDisp * k) / MaxHeat;
y = (k - x) / 2;

x += y;
// Offensive Movement Modifier
// Rounds to two decimals
off = int ( pow(1+((getSpeed(2) + getSpeed(-1) - 5)*.1),1.2) * 100);

off = int ( (x + y) * (off / 100.00) ); 

if (Type == 0)
  value = int ( (def + off) * (GunneryMod[Pilot.Gunnery]-(Pilot.Piloting*.05)) );
if (Type == 1)
  value = (def + off);
if (Type == 2)
  value = def;
if (Type == 3)
  value = off;

  
return int(value);
}
