/////////////////////////////////////////////////////////////////////////////
//.mep file reader
//
//

//#include <stdio.h>
//#include <conio.h>
//#include <string.h>

#include "mepdata.cpp"

int WeapStart=0, WeapEnd  = 53;
int Weaponsr =0;
int Weapdex[78];
int Weaploc[78];
int WeapSize[78];

int Weaprear[78];

int Actuators = 0;
int Actdex[78];
int Actloc[78];

int Equipments = 0;
int Equipdex[78];
int Equiploc[78];

int Ammunitions = 0;
int Ammodex[78];
int Ammoloc[78];

int NullSlots = 0;
int Nulldex[78];
int Nullloc[78];

int Conts = 0;
int Contdex[78];
int Contloc[78];

int RightHatchet=0,LeftHatchet=0;

char *getCode(char *String) {
int i=0;
while (String[i+5]!=32) String[i] = String[i+5],i++;
String[i] = 0x0000;
return String;
}

char *getName(char *String) {
int i=0,j;
while (String[i]!=32) i++;
i++;
j = i;
while (String[i]!=32 || (String[i]==32 && String[i+1]!=32)) String[i-j] = String[i],i++; // Only works for single word names
i++;
String[i-j-1] = 0x0000;
return String;
}

int getArmour(char *String) {
int j;
j = (String[2] - 48) * 10;
j += String[3] - 48;

return j;
}

int getStruct(char *String) {
int j;
j = (String[12] - 48) * 10;
j += String[13] - 48;

return j;
}

int allocCrits(class Mech &Mech);
int genWeaponTable(class Mech &Mech);
//int SaveMech();
int Strip        (char *String);
int getTechBase  (char *Origin, char *TechBase);
int getType      (char *String);
int getEngine    (char *String);
int getHeatSink  (char *String);
int getArmourType(char *String);
int getStructType(char *String);


//void main() {
int LoadMEP(class Mech &Mech, char *Name)
{
int  i,j,k,l;

//sprintf(argv[1],"as7-d");
char ch;
//int  Weapons;
char  String[160];
char Crits[80][30];

/*
for (i=0;i<Weaps;i+=5)
  printf("%s            %s\n",Weap[i],ShortWeap[i]);
return 0;
*/
FILE *MechIn;
//clrscr();
sprintf(String,"%s.mep",Name);
//in = fopen("as7-d.mep","r+");
//in = fopen("mad-3r.mep","r+");
//in = fopen("cer.mep","r+");
MechIn = fopen(String,"r+");
//checkFile(MechIn,5);
checkFile(MechIn,5);

// The Easy Part
// String is used for Generica
char rName[40];
char Type[40];
char Tons[40];
char Walk[40];
char Jump[40];
char HS  [40];

char Origin[40];
char TechBase[40];
char EngineType[40];
char HeatSinkType[40];
char StructType[40];
char ArmourType[40];

char HD  [40];
char LA  [40];
char LT  [40];
char LTr [40];
char CT  [40];
char CTr [40];
char RT  [40];
char RTr [40];
char RA  [40];
char LL  [40];
char RL  [40];

char M   [20];

readString(String,MechIn);  // 1
readString(rName,MechIn);
readString(String,MechIn);
readString(String,MechIn);
readString(String,MechIn);  // 5
readString(String,MechIn);
readString(String,MechIn);
readString(String,MechIn);
readString(Origin,MechIn);       // Origin
readString(TechBase,MechIn); // 10 // TechBase

readString(Type,MechIn);
readString(Tons,MechIn);

readString(EngineType,MechIn); // Engine
readString(HeatSinkType,MechIn); // HeatSinks
readString(StructType,MechIn); // 15  - Struct
readString(ArmourType,MechIn); // Armour

readString(Walk,MechIn);
readString(Jump,MechIn);
readString(HS,MechIn);

readString(String,MechIn); // 20 // Primary Weapon Type?
readString(String,MechIn); // Armour Factor
readString(String,MechIn);
readString(String,MechIn);

readString(HD ,MechIn);
readString(LA ,MechIn);    // 25
readString(LT ,MechIn);
readString(LTr,MechIn);
readString(CT ,MechIn);
readString(CTr,MechIn);
readString(RT ,MechIn);    // 30
readString(RTr,MechIn);
readString(RA ,MechIn);
readString(LL ,MechIn);
readString(RL ,MechIn);

Mech.Armour[0]  = getArmour(HD);
Mech.Armour[1]  = getArmour(CT);
Mech.Armour[2]  = getArmour(RT);
Mech.Armour[3]  = getArmour(LT);
Mech.Armour[4]  = getArmour(RA);
Mech.Armour[5]  = getArmour(LA);
Mech.Armour[6]  = getArmour(RL);
Mech.Armour[7]  = getArmour(LL);
Mech.Armour[8]  = getArmour(CTr);
Mech.Armour[9]  = getArmour(RTr);
Mech.Armour[10] = getArmour(LTr);
Mech.Struct[0]  = getStruct(HD);
Mech.Struct[1]  = getStruct(CT);
Mech.Struct[2]  = getStruct(RT);
Mech.Struct[3]  = getStruct(LT);
Mech.Struct[4]  = getStruct(RA);
Mech.Struct[5]  = getStruct(LA);
Mech.Struct[6]  = getStruct(RL);
Mech.Struct[7]  = getStruct(LL);

//for (i=0;i<8;i++)
//  printf("%d\n",Mech.Struct[i]);
//for (i=0;i<11;i++)
//  printf("%d\n",Mech.Armour[i]);

//printf("<%s>\n",getCode(Name));
//printf("<%s>\n",getName(Name));
//getch();
readString(M,MechIn); // 35
k = ConvertString(M);
//printf("%d\n",k);

for (i=0;i<k;i++)
  readString(String,MechIn);

readString(String,MechIn); // +1
readString(String,MechIn); // +2
readString(String,MechIn); // +3

Mech.TechBase = getTechBase(Origin,TechBase);

		       // Start Of Crit Table
for (i=0;i<78;i++)
  readString(Crits[i],MechIn);

for (i=0;i<78;i++)
  readCrit(Crits[i]);

  fclose(MechIn);

/*
textattr(04);
for (i=1;i<=Weapons;i++)
  cprintf("%2d   %s %d\r\n",i,Weap[Weapdex[i]],Weaploc[i]);

textattr(12);
for (i=1;i<=Ammunitions;i++)
  cprintf("%2d   %s %d\r\n",i,Ammo[Ammodex[i]],Ammoloc[i]);
textattr(01);
for (i=1;i<=Equipments;i++)
  cprintf("%2d   %s %d\r\n",i,Equipment[Equipdex[i]],Equiploc[i]);

textattr(07);
for (i=1;i<=Actuators;i++)
  cprintf("%2d   %s %d\r\n",i,Actuator[Actdex[i]],Actloc[i]);
*/
sprintf(Mech.Code,"%s",getCode(rName));
sprintf(Mech.Name,"%s",getName(rName));
//printf("%s %s\n",Mech.Code, Mech.Name);
Mech.Type = getType(Type);
Mech.Tons = ConvertString(Tons);

Mech.Walk = ConvertString(Walk);
Mech.Jump = ConvertString(Jump);
Mech.HeatSinks = ConvertString(HS  );
//Mech.Tons = ConvertString(Tons);

Mech.EngineType = getEngine(EngineType);
Mech.GyroType = 0;
Mech.CockPitType = 0;
Mech.SensorType = 0;

Mech.MyomerType   = 0;
Mech.StructType   =  getStructType(StructType);
Mech.ArmourType   =  getArmourType(ArmourType);
Mech.HeatSinkType =  getHeatSink  (HeatSinkType);

Mech.NullSigType = 0;
Mech.RightHatchetType = 0;
Mech.LeftHatchetType  = 0;
Mech.BAPType = 0;
Mech.ECMType = 0;
Mech.CompType = 0;
Mech.ARTType = 0;

Mech.CaseType = 0;
Mech.CaseLoc = 0;

  if (Mech.Crit[4][3].Class == 4 && Mech.Crit[5][3].Type == 3)
    Mech.RightArm.Length = 4;
    else
    if (Mech.Crit[4][2].Class == 4 && Mech.Crit[5][2].Type == 2)
      Mech.RightArm.Length = 3;
    else
      Mech.RightArm.Length = 2;

//if (Mech.Crit[5][3].Class == 4 && Mech.Crit[5][3].Type == 14) // Hatchet
  if (Mech.Crit[5][3].Class == 4 && Mech.Crit[5][3].Type == 3)
    Mech.LeftArm.Length = 4;
    else
    if (Mech.Crit[5][2].Class == 4 && Mech.Crit[5][2].Type == 2)
      Mech.LeftArm.Length = 3;
    else
      Mech.LeftArm.Length = 2;

  if (Mech.RightHatchetType == 1)
    Mech.RightArm.Length = 5;
  if (Mech.LeftHatchetType  == 1)
    Mech.LeftArm.Length = 5;

  if (Mech.TechBase > 3) {
    Mech.CaseType = 1;
    Mech.CaseLoc  = 255; }

allocCrits(Mech);

//  clrscr();
/*
for (k=0;k<8;k++) {
  for (i=0;i<Mech.CritSlot[k];i++)
    cprintf("C%2d T%2d %s\r\n",Mech.Crit[k][i].Class,Mech.Crit[k][i].Type,CritName[Mech.Crit[k][i].Class][Mech.Crit[k][i].Type]);
  getch(); }
*/
//for (i=0;i<12;i++)
//  cprintf("%2d C%d T%d\r\n",);
//  getch();

genWeaponTable(Mech);

//for (i=0;i<Mech.Weapons;i++)
//  cprintf("%d %d\r\n",i,Mech.Weapon[i].Type);

//SaveMech();

  Mech.Run      = (Mech.Walk * 3 + 1) / 2;
  Mech.Position = 1; // Mech starts Standing, height equals 1+1 level
  Mech.Heat     = 0; // Mechs Start with no Heat
  Mech.Holding  =-1; // Mechs Start out not Holding Anything
  Mech.Carrying =-1; // Mechs Start out not Carrying any one
  Mech.Size     = 2; // Mech Height

  Mech.Status   = 1;
  Mech.Stacked  = Off;
  Mech.MASCNumber=3;

  Mech.EngineHits      = 0;
  Mech.GyroHits        = 0;
  Mech.SensorHits      = 0;
  Mech.LifeSupportHits = 0;

  Mech.RightArm.Shoulder = On;
  Mech.RightArm.UpperArm = On;
  if (Mech.RightArm.Length >= 3) Mech.RightArm.LowerArm = On;
  if (Mech.RightArm.Length == 4) Mech.RightArm.Hand     = On;
  Mech.LeftArm.Shoulder  = On;
  Mech.LeftArm.UpperArm  = On;
  if (Mech.LeftArm.Length >= 3) Mech.LeftArm.LowerArm  = On;
  if (Mech.LeftArm.Length == 4) Mech.LeftArm.Hand      = On;
  Mech.RightLeg.Hip      = On;
  Mech.RightLeg.UpperLeg = On;
  Mech.RightLeg.LowerLeg = On;
  Mech.RightLeg.Foot     = On;
  Mech.LeftLeg.Hip       = On;
  Mech.LeftLeg.UpperLeg  = On;
  Mech.LeftLeg.LowerLeg  = On;
  Mech.LeftLeg.Foot      = On;

return 0;
}
/*
char isDigit(char input)
{
if ((input >= 48) && (input <=57))
  return 1;

return 0;
}
*/
long ConvertString(char *string)
{
long num=0;
long in;
int i=0,j=0;
char numstr[40];

  do {
    if (isDigit(string[i]))
    {
    num *= 10;
    num += string[i] - 48;
    numstr[j] = string[i];
    j++;
    }
    i++;
  } while (string[i]!=0x0000 && j!=8);
  numstr[j] = 0x0000;

return num;
}

int readCrit(char *String) {
//Remove Crit Header, return Index
int i;
int j;
int Index;
int loc = -1;
char Num[4];
char buf[40];

//textattr(07);

for (i=0;i<3;i++)
  Num[i] = String[i]; // Move first 3 numbers into Num

//String[3] String[4] // 'R' 'A'
if (String[3] == 'H' && String[4] == 'D') loc = 0;
if (String[3] == 'C' && String[4] == 'T') loc = 1;
if (String[3] == 'R' && String[4] == 'T') loc = 2;
if (String[3] == 'L' && String[4] == 'T') loc = 3;
if (String[3] == 'R' && String[4] == 'A') loc = 4;
if (String[3] == 'L' && String[4] == 'A') loc = 5;
if (String[3] == 'R' && String[4] == 'L') loc = 6;
if (String[3] == 'L' && String[4] == 'L') loc = 7;

i = 0;
while (String[i] != 0x0000) {
  String[i] = String[i+7]; i++;} // Shifts String Right 7

  Num[3] = 0x0000;
  Index = ConvertString(Num);

//  textattr(7);
/*
  printf("CONTINUE? <%s>\n",String);
  for (j=0;j<Continues;j++)
    printf("%2d <%s>\n",strcmp(String,Continue[j]),Continue[j]);
*/

  // Weapons
  if (Index != 0) {

   for (i=WeapStart;i<WeapEnd;i++)
     if (strcmp(String,Weap[i]) == 0) {
       Weaponsr++;
       Weapdex[Weaponsr] = i;
       Weaploc[Weaponsr] = loc;
       Weaprear[Weaponsr] = 0;
       WeapSize[Weaponsr] = WeapSizeTable[i];
//       textattr(3);
       return 1;
     }
   //Concated Weapon Name
   for (i=WeapStart;i<WeapEnd;i++)
     if (strcmp(String,ShortWeap[i]) == 0) {
       Weaponsr++;
       Weapdex[Weaponsr] = i;
       Weaploc[Weaponsr] = loc;
       Weaprear[Weaponsr] = 0;
       WeapSize[Weaponsr] = WeapSizeTable[i];
//       textattr(3);
       return 2;
     }

   //Weapon Continuation
   for (i=0;i<Continues;i++)
     if (strcmp(String,Continue[i]) == 0) {
       printf("%2d <%s>\n",strcmp(String,Continue[i]),Continue[i]);
       Conts++;
       Contdex[Conts] = i;
       Contloc[Conts] = loc;
//       textattr(12);
       return 2;
     }

       // If weapon rear mounted
    if (String[0] == '(' && String[1] == 'R' && String[2] == ')' && String[3] == 32 ) {
//       j = 0;
    for (i=WeapStart;i<WeapEnd;i++) {
	sprintf(buf,"(R) %s",Weap[i]);
//	textattr(2);
//	cprintf("%d >%s<>%s<\r\n",Index,String,buf);
      if (strcmp(String,RearWeap[i]) == 0 || strcmp(String,buf) == 0) {
	Weaponsr++;
	Weapdex[Weaponsr] = i;
	Weaploc[Weaponsr] = loc;
	Weaprear[Weaponsr] = -1;
	WeapSize[Weaponsr] = WeapSizeTable[i];
//	textattr(i);
	cprintf("%d >%s<\r\n",Index,String);
	return 0;
	}
	}
      }

   for (i=0;i<Ammunits;i++)
     if (strcmp(String,Ammo[i]) == 0 ) {
       Ammunitions++;
       Ammodex[Ammunitions] = i;
       Ammoloc[Ammunitions] = loc;
//       textattr(i-3);
      }

   for (i=0;i<Ammunits;i++)
     if (strcmp(String,ShortAmmo[i]) == 0) {
       Ammunitions++;
       Ammodex[Ammunitions] = i;
       Ammoloc[Ammunitions] = loc;
//       textattr(i-3);
      }

   for (i=0;i<Ammunits;i++)
     if (strcmp(String,ConAmmo[i]) == 0) {
       Ammunitions++;
       Ammodex[Ammunitions] = i;
       Ammoloc[Ammunitions] = loc;
//       textattr(i-3);
      }

   for (i=0;i<Equips;i++)
     if (strcmp(String,Equipment[i]) == 0) {
       Equipments++;
       Equipdex[Equipments] = i;
       Equiploc[Equipments] = loc;
//       textattr(1);
//       if (i==8) cprintf("A-Pod\r\n");
       return 3;
       }

  for (i=0;i<Equips;i++)
     if (strcmp(String,ShortEquipment[i]) == 0) {
       Equipments++;
       Equipdex[Equipments] = i;
       Equiploc[Equipments] = loc;
//       textattr(2);
//       if (i==8) cprintf("A-Pod\r\n");
       return 3;
       }

    }

for (i=0;i<Acts;i++)
  if (strcmp(String,Actuator[i]) == 0) {
    Actuators++;
    Actdex[Actuators] = i;
    Actloc[Actuators] = loc;
//    textattr(07);
//    cprintf("%d >%s<\r\n",Index,String);
  }
for (i=0;i<Acts;i++)
  if (strcmp(String,ActLong[i]) == 0) {
    Actuators++;
    Actdex[Actuators] = i;
    Actloc[Actuators] = loc;
//    textattr(07);
//    cprintf("%d >%s<\r\n",Index,String);
  }

//       printf("%d >%s<\n",Index,String);
  for (i=0;i<Nulls;i++)
     if (strcmp(String,Null[i]) == 0) {
       NullSlots++;
       Nulldex[NullSlots] = i;
       Nullloc[NullSlots] = loc;
//       textattr(1);
//       cprintf("%d >%s<\r\n",Index,String);
       }

//  cprintf("%d >%s<\r\n",Index,String);
//  cprintf("%d >%s<\r\n",Index,Equipment[2]);
return 0;
}

/*
int writeString(char *String, FILE *fout) {
int i = 0;
while (String[i] != 0x0000) putc(String[i],fout), i++;
putc(0x0000,fout); // Write a Terminator to the File
return i;
}
*/
int genWeaponTable(class Mech &Mech) {
int i,n=0;

for (i=0;i<Weaponsr;i++) {
//    Mech.Weapon[n].Type = Weapdex[i];
//    Mech.Weapon[n].Loc  = Weaploc[i] + (Weaprear[i] * -7);
    Mech.Weapon[i]      = WeaponTable[Weapdex[i+1]];
    Mech.Weapon[i].Loc  = Weaploc[i+1] + (Weaprear[i+1] * -7);
    Mech.Weapon[i].State= 1;
//    n++;
    }

//  getch();
  Mech.Weapons = Weaponsr;
return 0;
}
/*
int ConvertMEP()
{
char String[30];
FILE *MechOut;

//sprintf(String,"save.mec");
//sprintf(String,"%s.mec",Mech.Code);

//while (String[i] != 0) String[i] = Code[i];

MechOut = fopen(String,"wb+");
if (MechOut == NULL) return 1;
/////////////////////////////////////////////////////////////////////////////
// File Header
// ALWAYS 12 BYTES in length
//

fputc(0,MechOut);          // 0 - BattleMech 1 - Vehicle etc..
fputc(Mech.TechBase,MechOut);          // 0 - InnerSphere 1 - StarLeague 2 - Clan 3 - Custom
writeString("BTV0.1a",MechOut);  // File Class
fputc('1',MechOut);           // IE Version 1.0, 2.0
fputc('9' ,MechOut);           // IE Version  .2   .7
fputc('A' ,MechOut);           // Release Version  / Alpha / Beta / Gamma

writeString(Mech.Name,MechOut);
writeString(Mech.Code,MechOut);

fputc(Mech.Type,MechOut);       //  0 - Biped 1 - Quad 2 - Lam 3 - OmniMech

fputc(Mech.Tons,MechOut);
fputc(Mech.Walk,MechOut);
fputc(Mech.Jump,MechOut);

// Pod Weight?

//putc(HeatSinkType) // 0 - Normal 1 - Double 2 - Clan 3 - Compact 4 - Laser
fputc(Mech.HeatSinks,MechOut);

  if (Mech.Crit[4][3].Class == 4 && Mech.Crit[5][3].Type == 3)
    Mech.RightArm = 4;
    else
    if (Mech.Crit[4][2].Class == 4 && Mech.Crit[5][2].Type == 2)
      Mech.RightArm = 3;
    else
      Mech.RightArm = 2;

//if (Mech.Crit[5][3].Class == 4 && Mech.Crit[5][3].Type == 14) // Hatchet
  if (Mech.Crit[5][3].Class == 4 && Mech.Crit[5][3].Type == 3)
    Mech.LeftArm = 4;
    else
    if (Mech.Crit[5][2].Class == 4 && Mech.Crit[5][2].Type == 2)
      Mech.LeftArm = 3;
    else
      Mech.LeftArm = 2;

  if (Mech.RightHatchetType == 1)
    Mech.RightArm = 5;
  if (Mech.LeftHatchetType  == 1)
    Mech.LeftArm = 5;

//printf(">>  %d %d\n",RightHatchet,LeftHatchet);
//printf("RA >>> %d,\n",Mech.RightArm);
//printf("LA >>> %d,\n",Mech.LeftArm);

fputc(Mech.LeftArm ,MechOut); // The Arms Length, 2-4
fputc(Mech.RightArm,MechOut);
//ptinyg
int i,j;             // 0 1 2 3 4 5 6 7 8 9 0
for (i=0;i<11;i++) {
  fputc(Mech.Armour[i],MechOut);
//  printf("%d\n",Mech.Armour[i]);
  }
for (i=0;i<8 ;i++) {
  fputc(Mech.Struct[i],MechOut);
  }

// Derived

//int   MaxAF,CurAF;
//float MaxArmourTons,CurArmourTons;

  fputc(127,MechOut); // End Main
// Put Equipment Type

fputc(Mech.EngineType  ,MechOut);
fputc(Mech.GyroType    ,MechOut);
fputc(Mech.CockPitType ,MechOut);
fputc(Mech.SensorType  ,MechOut);

fputc(Mech.MyomerType  ,MechOut);
fputc(Mech.StructType  ,MechOut);
fputc(Mech.ArmourType  ,MechOut);
fputc(Mech.HeatSinkType,MechOut);

fputc(Mech.NullSigType ,MechOut);
fputc(Mech.BAPType     ,MechOut);
fputc(Mech.ECMType     ,MechOut);
fputc(Mech.C3Type      ,MechOut);
fputc(Mech.AMSType     ,MechOut);
fputc(Mech.MASCType    ,MechOut);
fputc(Mech.CompType    ,MechOut);
fputc(Mech.ARTType     ,MechOut);

if (Mech.TechBase > 3) {
  Mech.CaseType = 1;
  Mech.CaseLoc  = 255; }

fputc(Mech.CaseType    ,MechOut);
fputc(Mech.CaseLoc     ,MechOut);

fputc(Mech.RightHatchetType ,MechOut);
fputc(Mech.LeftHatchetType  ,MechOut);

  fputc(127,MechOut); // End Type

genWeaponTable();
fputc(Mech.Weapons, MechOut);
//printf("%d\n",Mech.Weapons<<2);
for (i=0;i<Mech.Weapons;i++) {
  fputc(Mech.Weapon[i].Type,MechOut);
  fputc(Mech.Weapon[i].Loc ,MechOut);
  }

  fputc(127,MechOut); // End Weapon

for (i=0;i<8;i++) {
  fputc(Mech.CritSlot[i],MechOut);
  for (j=0;j<Mech.CritSlot[i];j++) {
    fputc(Mech.Crit[i][j].Class ,MechOut);
    fputc(Mech.Crit[i][j].Type  ,MechOut);
    fputc(Mech.Crit[i][j].Size  ,MechOut);
    fputc(Mech.Crit[i][j].Status,MechOut);
    }
  }

  fputc(127,MechOut); // End Crit
//Put Terminators
fclose(MechOut);
return 0;
}
*/

int allocCrits(class Mech &Mech) {
int i,j;
int loc,crit;
//int CritSlot[8];

for (i=0;i<8;i++) Mech.CritSlot[i] = 0;

  // Weapon Continue Slots
for (i=1;i<=Conts;i++)
  for (j=1;j<=Weaponsr;j++)
    if (Contdex[i] == Weapdex[j])
      WeapSize[j]-=1;

  // Actuators
for (i=1;i<=Actuators;i++) {
  loc  = Actloc[i];
  crit = Mech.CritSlot[loc];
  Mech.CritSlot[loc] ++;
  Mech.Crit[loc][crit].Class = 4;
  Mech.Crit[loc][crit].Type  = Actdex[i];
  Mech.Crit[loc][crit].Size  = 1;
  Mech.Crit[loc][crit].State = 0;

  if (Actdex[i] == 13) { // XL Engine - 2 More Crits
//    printf("XL Det\n");
    crit = Mech.CritSlot[loc];
    Mech.CritSlot[loc] ++;
    Mech.Crit[loc][crit].Class = 4;
    Mech.Crit[loc][crit].Type  = 13;
    Mech.Crit[loc][crit].Size  = 1;
    Mech.Crit[loc][crit].State = 0;

  if (Mech.TechBase <= 3) { // IS unit XL engines = 3 Crits
    crit = Mech.CritSlot[loc];
    Mech.CritSlot[loc] ++;
    Mech.Crit[loc][crit].Class = 4;
    Mech.Crit[loc][crit].Type  = 13;
    Mech.Crit[loc][crit].Size  = 1;
    Mech.Crit[loc][crit].State = 0;
    }
    }
  }

  // Weapons
for (i=1;i<=Weaponsr;i++) {
  loc  = Weaploc[i];
  crit = Mech.CritSlot[loc];
  Mech.CritSlot[loc] ++;
  Mech.Crit[loc][crit].Class = 1;
  Mech.Crit[loc][crit].Type  = Weapdex[i];
  Mech.Crit[loc][crit].Size  = WeapSize[i];
  Mech.Crit[loc][crit].State = 1;
  }

  // Ammunition
for (i=1;i<=Ammunitions;i++) {
  loc  = Ammoloc[i];
  crit = Mech.CritSlot[loc];
  Mech.CritSlot[loc] ++;
  Mech.Crit[loc][crit].Class = 2;
  Mech.Crit[loc][crit].Type  = Ammodex[i];
  Mech.Crit[loc][crit].Size  = 1;
  Mech.Crit[loc][crit].State = AmmoState[Ammodex[i]];
  }

  // Equipment
for (i=1;i<=Equipments;i++) {
  loc  = Equiploc[i];
  crit = Mech.CritSlot[loc];
  Mech.CritSlot[loc] ++;
  Mech.Crit[loc][crit].Class = 3;
  Mech.Crit[loc][crit].Type  = Equipdex[i];
  Mech.Crit[loc][crit].Size  = 1;
  Mech.Crit[loc][crit].State = 0;

  if (Equipdex[i] == 0 && Mech.HeatSinkType == 1)
    Mech.Crit[loc][crit].Size  = 3; // IS Double Heat Sinks
  if (Equipdex[i] == 0 && Mech.HeatSinkType == 1 && Mech.TechBase > 3)
    Mech.Crit[loc][crit].Size  = 2; // Clan Double Heat Sinks
  if (Equipdex[i] == 4) { // Hatchet
    Mech.Crit[loc][crit].Size = (Mech.Tons+10) / 15;
//    Mech.RightHatchetType = 1;
    if (loc == 4) Mech.RightHatchetType = 1; // Hatchet Location
    if (loc == 5) Mech.LeftHatchetType  = 1;
    }

  if (Equipdex[i] == 2) {// Case
    Mech.CaseType = 1;
    Mech.CaseLoc += (1<<Equiploc[i]);
    }

  if (Equipdex[i] == 3) // Artemis Type
    Mech.ARTType = 4;

  if (Equipdex[i] == 5) // Targeting Computer
//    printf("TG ENABLED>>\n");
    Mech.CompType = 1;

  if (Equipdex[i] == 6) // ECM
    Mech.ECMType = 1;

//for (i=1;i<Equipments;i++)
  if (Equipdex[i] == 9) { // MASC
    Mech.MASCType = 1;
//    printf("MASC ENABLED>>\n");
    Mech.Crit[loc][crit].Size = (Mech.Tons+15) / 20;
    }

  }

  // Null Slots
for (i=1;i<=NullSlots;i++) {
  loc  = Nullloc[i];
  crit = Mech.CritSlot[loc];
  Mech.CritSlot[loc] ++;
  Mech.Crit[loc][crit].Class = 0;
  Mech.Crit[loc][crit].Type  = Nulldex[i];
  Mech.Crit[loc][crit].Size  = 1;
  Mech.Crit[loc][crit].State = 0;
  if (Nulldex[i] == 3)
    Mech.MyomerType = 1; // TSM Enabled
  }

  // Weapon Continue Slots
for (i=1;i<=Conts;i++) {
  loc  = Contloc[i];
  crit = Mech.CritSlot[loc];
  Mech.CritSlot[loc] ++;
  Mech.Crit[loc][crit].Class = 6;
  Mech.Crit[loc][crit].Type  = Contdex[i];
  Mech.Crit[loc][crit].Size  = 1;
  Mech.Crit[loc][crit].State = 0;
  }

return 0;
}

int Strip(char *String) {
int i=0;
while (String[i]!=0x0000) {
  if (String[i]==32) String[i]=0x0000;
  i++;
  }
return i;
}

int getType(char *String) {
if (strcmp(String,"Quad")==0) {
//printf("<QUAD>\n");
return 1; }
return 0;
}

int getEngine(char *String) {
if (strcmp(String,"XL")==0) return 1;
return 0;
}

int getHeatSink(char *String) {
//Strip(String);
//printf ("<%s>",String);
if (strcmp(String,"Double")==0) return 1;
// printf("SINGLE!");
return 0;
}

int getArmourType(char *String) {
if (strcmp(String,"Ferro Fibre")==0) return 1;
return 0;
}

int getStructType(char *String) {
if (strcmp(String,"Endo Steel")==0) return 1;
return 0;
}

int getTechBase(char *Origin, char *TechBase) {
//if (strcmp(String,"Endo Steel")==0) return 1;
if (strcmp(Origin,"Inner Sphere")==0 && ConvertString(TechBase) == 2750) return 1;
if (strcmp(Origin,"Inner Sphere")==0 && ConvertString(TechBase) == 3050) return 2;
if (strcmp(Origin,"Inner Sphere")==0 && ConvertString(TechBase) == 3055) return 3;

if (strcmp(Origin,"Clan")==0 && ConvertString(TechBase) == 3050) {
WeapStart = 80; WeapEnd = 122; return 4; }
if (strcmp(Origin,"Clan")==0 && ConvertString(TechBase) == 3055) {
WeapStart = 80; WeapEnd = 122; return 5; }
if (strcmp(Origin,"Clan")==0 && ConvertString(TechBase) == 3057) {
WeapStart = 80; WeapEnd = 122; return 6; }

return 0;
}
